C
C///////////////////////////////////////////////////////////////////////
C
C   SUBROUTINE TO DO SCALAR ARITHMATICS
C
	SUBROUTINE ARITHM(*)
	REAL CNST(14)
	CHARACTER*60 STR
	CHARACTER*1 IC,NUM(13),OPE(13)
	character*64 string,fstr5,fstr6
	CHARACTER*5 FUNC,NTEMP
	common/cpar/om,ol
	DATA NUM/'1','2','3','4','5','6','7','8','9','0','.','-','+'/
	HC=50.
	QN=0.
	WRITE(6,*) ' CALCULATOR MODE: enter h for help'
 100	WRITE(6,2)
 2	FORMAT(' ^^ ',$)
	STR=' '
	FUNC=' '
	DO 90 I=1,13
	  CNST(I)=0.
	  OPE(I)=' '
 90	CONTINUE
	READ(5,3,END=900) STR
	IF (STR.EQ.' ') RETURN1
 3	FORMAT(A60)
 4	FORMAT(A1)
C check if first character is part of a number
	DO 110 IIN=1,60
	  IC=STR(IIN:IIN)
	  IF (IC.NE.' ') THEN
	    DO 101 I=1,13
	      IF (IC.EQ.NUM(I)) THEN
	        IFU=0
	        GO TO 102
	      END IF
 101	    CONTINUE
	    GO TO 103
	  END IF
 110	CONTINUE 
C
C First character is not a number .. look for function
C
 103	DO 200 IFU=IIN,60
	  IC=STR(IFU:IFU)
	  IF (IC.EQ.' ') GO TO 201
	  IF (IC.EQ.'+'.OR.IC.EQ.'-'.OR.IC.EQ.'*'.OR.IC.EQ.'/'
     *        .OR.IC.EQ.'e') 
     *    GO TO 201	  
 200	CONTINUE
 201	ICL=IFU-1
	IF (ICL.EQ.60) RETURN1
	FUNC=STR(IIN:ICL)
	IF (FUNC.EQ.'ans') IFU=0
 	IF (FUNC.EQ.'h'.or.func.eq.'hel') THEN
	  WRITE(6,1000)
	  GO TO 100
	END IF
1000	FORMAT(' Cosmic Calculator :'/
     *	'   Arithmatical expressions are evaluated IN ORDER. (Max 10)'/
     *   '   Operations allowed are +,-,*,/,e, NO brackets, NO blanks.'/
     *   '   ans represents the previous answer , as in: ans*1.35+3.8'/
     *   '   Use capital E for exp format number: e.g 1E-14.'/
     *   '   The following self-explanatory functions are allowed'/
     *   '   as the first argument:  sin, cos, tan, asin, acos,'/
     *   '   atan, log, ln and sqrt.    e.g. sin expression, (with'/
     *   '   blanks in between). Cosmological functions: '/
     *   '     mag flux - convert flux to magnitude'/
     *   '     amag mag - convert mag to intensity'/
     *   '     abm z,m - absolute magnitude of m at z, no K-cor '/
     *   '     apm z,M - apparent magnitude of M at z, no K-cor'/
     *   '     lum z,f - luminosity (in 10^40) of flux f (/cm^2) at z'/
     *   '     flx z,L - flux (/cm^2) of luminosity (in 10^40) at z'/
     *   '     pds z - proper (comoving) distance (mpc) at z'/
     *   '     lds z - luminosity distance (mpc) at z (pds*(1+z))'/
     *   '     ads z - angula diameter distance (mpc) at z (pds/(1+z))'/
     *  '     mdm z,a - metric diameter (D_th kpc) of a=arc sec at z'/
     *	'     adm z,d - angular diameter (") of (D_theta) d=kpc at z'/
     *   '     vol z1,z2 - proper volume between z1 and z2, Gpc^3'/
     *   '     lbt z - look back time at z in yrs'/
     *   '     ho const - Hubble constant, default =50'/
     *   '     qo const - q_o, default=0.0, for positive q only'/  
     *   '     om const - Omega_m, default=0.3, =2X qo, if O_Lam=0'/  
     *   '     ol const - Omega_Lambda, only for O_tot=1, default=0'/  
     *   '     r2g - convert ra(h.hh) & dec(d.dd) to galactic b & l'/
     *   '     g2r - convert b & l to ra & dec'/
     *   '     qsum a,b - quadrature sum of a and b'/
     *   '     qdif a,b - quadrature diff of a-b'/
     *   '     h - help'/
     *   '     off ,or <cr> - out')
c
c
c 5	FORMAT(A<ICL>)
c 6	FORMAT(F<ICL>.0)
C
C INTERPRET numerical expression
 102	INU=IFU
	DO 400 L=1,13
c  added to deal with xxxx
	  iskip=0
	  DO 202 K=INU+1,60
	    if (iskip.eq.1) then
	      iskip=0
	      goto 202
	    end if
	    READ(STR(K:K),4) IC
	    IF (IC.EQ.' '.OR.IC.EQ.'/'.OR.IC.EQ.'*'.OR.
     *           IC.EQ.'e'.OR.IC.EQ.',') GO TO 203
	    if (ic.eq.'E') then
c       xxxx this not allowed by linux f77
C  exponent of number, skip next sign
c	      k=k+1
	      iskip=1
	      go to 202
	    end if
	    IF (IC.EQ.'-'.OR.IC.EQ.'+') THEN
	      IF (K.EQ.INU+1) GO TO 202
	      GO TO 203
	    END IF
 202	  CONTINUE
 203	ICL=K-INU-1
	istatus=encode(string,float(icl),1,0,idum)
	fstr5='(A'//string(1:lnblnk(string))//')'
	fstr6='(G'//string(1:lnblnk(string))//'.0)'
	IF ((FUNC.EQ.'ho'.OR.FUNC.EQ.'qo').AND.ICL.EQ.0) GO TO 302
	IF ((FUNC.EQ.'hn'.OR.FUNC.EQ.'qn').AND.ICL.EQ.0) GO TO 302
	IF ((FUNC.EQ.'om'.OR.FUNC.EQ.'ol').AND.ICL.EQ.0) GO TO 302
	IF (ICL.EQ.0.OR.K.EQ.61) GO TO 999
	READ(STR(INU+1:K-1),fstr6,ERR=222) CNST(L)
 	GO TO 220
 222	READ(STR(INU+1:K-1),fstr5) NTEMP
	IF (NTEMP.EQ.'ans') THEN
	  CNST(L)=ANS
	ELSE
	  GO TO 999
	END IF
220	IF (IC.EQ.' ') GO TO 300
	OPE(L)=IC
	INU=K
400	CONTINUE
C
C evaluate expression
300	WRITE(6,2000) FUNC,(CNST(JJ),OPE(JJ),JJ=1,MIN0(L,6))
	IF (L.GT.5) WRITE(6,2100) (CNST(JJ),OPE(JJ),JJ=7,L)
2100	FORMAT(6X,7(G12.5,A1))
2000	FORMAT(1X,A5,6(G12.5,A1))
	ANS=CNST(1)
	IF (L.EQ.1) GO TO 500
	DO 301 M=1,L-1
	IF (OPE(M).EQ.',') GO TO 301
	IF (OPE(M).EQ.'-') ANS=ANS-CNST(M+1)
	IF (OPE(M).EQ.'+') ANS=ANS+CNST(M+1)
	IF (OPE(M).EQ.'*') ANS=ANS*CNST(M+1)
	IF (OPE(M).EQ.'e') THEN
	  IF (ANS.LE.0.) GO TO 999
	  ANS=ANS**CNST(M+1)
	END IF
	IF (OPE(M).EQ.'/') THEN
	  IF (CNST(M+1).EQ.0.) GO TO 999
	  ANS=ANS/CNST(M+1)
	END IF
 301	CONTINUE
 500	IF (IFU.EQ.0) GO TO 600
	if (func.eq.'off') go to 900
	IF (FUNC.EQ.'pds') THEN
	  ANS=(299799./HC)*COSTERM(QN,ANS)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'lds') THEN
	  ANS=(299799./HC)*COSTERM(QN,ANS)*(1.+ans)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'ads') THEN
	  ANS=(299799./HC)*COSTERM(QN,ANS)/(1.+ans)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'lbt') THEN
c lookback time
c	  write(6,*) '  * for non-Lambda cosmologies only *'
	  timecons=3.1556E+07/3.0856E+19
	  if (abs(ol).le.0.00001) then
c  non-Lambda models
	  if (abs(qn-0.).lt.0.00001) then
	    ans=ans/((1.+ans)*hc*timecons)
	  else if (abs(qn-0.5).lt.0.00001) then
	    ans=2*(1-(1+ans)**(-1.5))/(3*hc*timecons)
	  else 
c formulae from Bruzual's thesis, appendix A.4
	    tem0=(1.-qn)/qn
	    tem=(1.-qn*(1.-ans))/(qn*(1.+ans))
	    if (qn.gt.0.5000001) then
	      trigterm=acos(tem)
	      trigterm0=acos(tem0)
	      tem0=1./(1.-2.*qn)+qn*((2.*qn-1.)**(-1.5))*trigterm0
	      tem=sqrt(1.+2*qn*ans)/((1.-2.*qn)*(1.+ans))
     *            +qn*((2.*qn-1.)**(-1.5))*trigterm
	    else 
C qo between 0 and .5
	      trigterm=acosh(tem)
	      trigterm0=acosh(tem0)
	      tem0=1./(1.-2.*qn)+qn*((1.-2.*qn)**(-1.5))*trigterm0
	      tem=sqrt(1.+2*qn*ans)/((1.-2.*qn)*(1.+ans))
     *            +qn*((1.-2.*qn)**(-1.5))*trigterm
c	      write(6,*) '  +++ not yet available for the specified qo ++'
c	      go to 100
	    end if
	    ans=(tem0-tem)/(hc*timecons)
	  end if
	  else
c  Lambda flat universe
c  do integral
	    ans=rlbte(ans)/(hc*timecons)
	  end if
	  GO TO 600
	END IF
	IF (L.LT.2) GO TO 550
	IF (FUNC.EQ.'lum') THEN
          write(6,*) ' lum in units of 10^40'
	  ANS=cnst(2)*4.*3.14159*9.5209E+8*8.98758E+10*
     *               ((COSTERM(QN,cnst(1))*(1.+cnst(1))/hc)**2)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'flx') THEN
	  write(6,*) ' lum input is assumed to be in units of 10^40'
	  ANS=cnst(2)/(4.*3.14159*(3.0856E+4*(299793./HC)
     *           *COSTERM(QN,cnst(1))*(1.+cnst(1)))**2)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'mdm') THEN
	  ANS=(CNST(2)*299792500.*COSTERM(QN,CNST(1)))/
     *             (HC*206265.*(1.+CNST(1)))
	  GO TO 600
	END IF
	IF (FUNC.EQ.'adm') THEN
	  ANS=CNST(2)*HC*206265.*(1.+CNST(1))/
     *           (299792500.*COSTERM(QN,CNST(1)))
	  GO TO 600
	END IF
	IF (FUNC.EQ.'abm') THEN
	  ANS=-25.+CNST(2)-5.*ALOG10(AMAX1(.00000001,
     *         299793.*COSTERM(QN,CNST(1))*(1.+CNST(1))/HC))
	  GO TO 600
	END IF
	IF (FUNC.EQ.'apm') THEN
	  ANS=25.+CNST(2)+5.*ALOG10(AMAX1(.00000001,
     *         299793.*COSTERM(QN,CNST(1))*(1.+CNST(1))/HC))
	  GO TO 600
	END IF
	if (func.eq.'vol') then
	  write(6,*) '  ++ currently only works for Omega_T=1 ++'
	  write(6,*) '  volume in Gpc^3 '
c  compute volume at z1 and z2, and subtract
	  dm1=(299799./HC)*COSTERM(QN,cnst(1))
	  dm2=(299799./HC)*COSTERM(QN,cnst(2))
	  ans=(4.*3.14156/3.)*(dm2**3.-dm1**3.)*1E-9
	  goto 600
	end if
	if (func.eq.'qsum') then
	  ans=sqrt(cnst(1)*cnst(1)+cnst(2)*cnst(2))
	  goto 600
	end if
	if (func.eq.'qdif') then
	  if (cnst(2).gt.cnst(1)) then 
	    write(6,*) '  +++ b is greater than a, no diff taken '
	  else
	    ans=sqrt(cnst(1)*cnst(1)-cnst(2)*cnst(2))
	  end if
	  go to 600
	end if
	if (func.eq.'r2g') then
	  call galactic1(cnst(1),cnst(2),ans1,ans,0)
	  write(6,13) ans, ans1
	  go to 100
	end if
	if (func.eq.'g2r') then
	  call galactic1(ans,ans1,cnst(2),cnst(1),1)
	  write(6,14) ans, ans1
	  go to 100
	end if
 13	format('  b (dd.dd): ',f7.2,4x,'l(dd.dd): ',f7.2)
 14	format('  RA (h.hh): ',f7.2,4x,'dec (dd.dd): ',f7.2)
 550	CONTINUE
 	IF (FUNC.EQ.'sqrt') THEN
	  IF (ANS.LT.0.) GO TO 999
	  ANS=SQRT(ANS)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'mag') THEN
	  IF (ANS.LT.0.) GO TO 999
	  ANS=-2.5*ALOG10(ANS)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'amag') THEN
	  ANS=10.**(-.4*ANS)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'sin') THEN
	  ANS=SIN(ANS/57.2958)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'cos') THEN
	  ANS=COS(ANS/57.2958)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'tan') THEN
	  ANS=TAN(ANS/57.2958)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'asin') THEN
	  ANS=57.2958*ASIN(ANS)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'acos') THEN
	  ANS=57.2958*ACOS(ANS)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'atan') THEN
	  ANS=57.2958*ATAN(ANS)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'ln') THEN
	  IF (ANS.LT.0.) GO TO 999
	  ANS=ALOG(ANS)
	  GO TO 600
	END IF
	IF (FUNC.EQ.'log') THEN
	  IF (ANS.LT.0.) GO TO 999
	  ANS=ALOG10(ANS)
	  GO TO 600
	END IF
 302	IF (FUNC.EQ.'ho'.or.func.eq.'hc') THEN
	  WRITE(6,*) ' old constant =',HC
	  IF (ICL.EQ.0) GO TO 100
	  HC=ANS
	  GO TO 600
	END IF
	IF (FUNC.EQ.'qo'.or.func.eq.'qn') THEN
	  WRITE(6,*) ' old constant =',QN,'  Omega_Lambda = 0, assumed'
	  IF (ICL.EQ.O) GO TO 100
	  QN=ANS
	  ol=0.
	  om=2.*qn
	  GO TO 600
	END IF
	IF (FUNC.EQ.'om') THEN
	  WRITE(6,*) ' old Omega_L=',ol
	  IF (ICL.EQ.O) GO TO 100
	  om=ANS
	  qn=om/2. 
	  GO TO 600
	END IF
	IF (FUNC.EQ.'ol') THEN
	  WRITE(6,*) ' old Omega_L=',ol,'  Omega_total = 1, assumed'
	  IF (ICL.EQ.O) GO TO 100
	  ol=ANS
	  om=1.-ol 
	  write(6,*) ' LambdaCDM: Omega_m=',om,' Omega_L=',ol
	  GO TO 600
	END IF
	GO TO 999
 600	WRITE(6,10) ANS
 10	FORMAT(10X,'=',G15.7)
	GO TO 100
 999	WRITE(6,*) ' ***********ILLEGAL EXPRESSION**********'
	GO TO 100
 900	RETURN
	END
c//////////////////////////////////////////////////////////////
c
c  this is the effective z: Z_q, for lambda cosmology, now it
c        works with O_m+O_L=1 only
c
	FUNCTION COSTERM(QN,Z)
	common/cpar/om,ol
	if (abs(ol).lt.0.0001) then
	 IF (abs(QN).ge.0.00001) THEN
	  COSTERM=(QN*Z+(QN-1)*(SQRT(AMAX1(0.,2.*QN*Z+1.))-1.))
     *            /(QN*QN*(Z+1.))
	  ELSE
	    COSTERM=Z*(1.+.5*Z)/(1.+Z)
	  end if
	else
	    costerm=costermlam(z)
c  lambda cosmology
	END IF
	RETURN 
	END
c/////////////////////////////////////////////////////
c
c  computes cosh^-1 x
c
	function acosh(x)
	if (x.lt.1.0000001) then
	  write(6,*) '  illegal acosh argument, set value to 1.0'
	  acosh=1.
	else
	  acosh=2.302585*alog(x+sqrt(x*x-1.))
	end if
	return
	end
C
C Subroutine to convert RA and DEC to galatic co-ordinates
C     iflag=0 radec to lb, 1 lb to radec
C     alpha in decimal hours, delta decimal  deg
C
C      from Serge Demers
        subroutine galactic1(alphat,deltat,l,b,iflag)
        real*4 alpha,delta,alphat,deltat,l,b
        real*4 theta,a0,l0,x1,x2,sinb
        cn1=8.0*atan(1.0)/24.0
        cn2=8.0*atan(1.0)/360.0
	alpha=alphat*cn1
	delta=deltat*cn2
        pi=4.0*atan(1.0)
        a0=282.25*cn2
        theta=62.6*cn2
        l0=33.0*cn2
        if(iflag.eq.0)then
          x1=cos(delta)*cos(alpha-a0)
          x2=cos(delta)*sin(alpha-a0)*cos(theta)+sin(delta)*sin(theta)
          l=atan2(x2,x1)+l0
          if(l.lt.0.0)l=l+2.0*pi
          sinb=sin(delta)*cos(theta)-cos(delta)*sin(alpha-a0)*sin(theta)
          b=asin(sinb)
        else
          x1=cos(b)*cos(l-l0)
          x2=cos(b)*sin(l-l0)*cos(theta)-sin(b)*sin(theta)
          alpha=atan2(x2,x1)+a0
          if(alpha.lt.0.0)alpha=alpha+2.0*pi
          sind=sin(theta)*cos(b)*sin(l-l0)+sin(b)*cos(theta)
          delta=asin(sind)
        endif
	l=l/cn2
	b=b/cn2
        return
        end
c/////////////////////////////////////////////////////////////////////
c   computation of integral of dz/E(z) (see Hogg, astroph/9905116
c    for Omega_tot=1 (Omega_k=0)
c
	function costermlam(z)
	external zfunc0
	common/cpar/om,ol
	call qsimp(zfunc0,0.,z,costermlam)
	return
	end
c///////////////////////////////////////////////////////////
c   the function E(z) for Omega)k=0
	function zfunc0(z)
	common/cpar/om,ol
	zemp=1.+z
	zemp=zemp*zemp*zemp
	zfunc0=1./sqrt(om*zemp+ol)
	return
	end
c/////////////////////////////////////////////////////////////////////
c   computation of integral of dz/(1+z)E(z) (see Hogg, astroph/9905116
c    for Omega_tot=1 (Omega_k=0)
c
	function rlbte(z)
	external zfunct
	common/cpar/om,ol
	call qsimp(zfunct,0.,z,rlbte)
	return
	end
c///////////////////////////////////////////////////////////
c   the function (1+z)E(z) for Omega)k=0
	function zfunct(z)
	common/cpar/om,ol
	zemp=1.+z
	zemp=zemp*zemp*zemp
	zfunct=1./((1.+z)*sqrt(om*zemp+ol))
	return
	end
c//////////////////////////////////////////////////
c numerical recipies program: simpson's rule integration
c
      SUBROUTINE QSIMP(FUNC,A,B,S)
	external func
      PARAMETER (EPS=1.E-6, JMAX=20)
      OST=-1.E30
      OS= -1.E30
      DO 11 J=1,JMAX
        CALL TRAPZD(FUNC,A,B,ST,J)
        S=(4.*ST-OST)/3.
        IF (ABS(S-OS).LT.EPS*ABS(OS)) RETURN
        OS=S
        OST=ST
11    CONTINUE
      PAUSE 'Too many steps.'
      END
c////////////////////////////////////////////////////////////
c numerical recipies program: trapezoid routine used by simpson's rule
c
      SUBROUTINE TRAPZD(FUNC,A,B,S,N)
	external func
      IF (N.EQ.1) THEN
        S=0.5*(B-A)*(FUNC(A)+FUNC(B))
        IT=1
      ELSE
        TNM=IT
        DEL=(B-A)/TNM
        X=A+0.5*DEL
        SUM=0.
        DO 11 J=1,IT
          SUM=SUM+FUNC(X)
          X=X+DEL
11      CONTINUE
        S=0.5*(S+(B-A)*SUM/TNM)
        IT=2*IT
      ENDIF
      RETURN
      END
