c subroutine for generalized fits tape writing using unix "dd"
	subroutine ddfits(tapedrive,*)
	character tapedrive*18,opt*3
	character name*25,bname*10,string*80,version*3,command*80
     *            ,logname*30,fdate*24,oldlog*79,aname*10,filename*25
c	integer*2 nff(200)
	integer nff(200)
	write(6,20) 
 20	format(' Program for copying disk fits (or any) files to tape'
     *  ,' or vice versa.'
     * /'  ++++++ warning: ddfits does NOT search for double eof '
     * /'   forward to appropriate eof by "mt fsf n" before writing.'
     * /'  (1) recursive copying of files in the form of XXXnnn.YYY,'/
     *  '    XXX.nnn or XXXnnn, use blank for YYY if names are of '/
     *  '    second form and NNN for YYY for names of the 3rd form'
     *  /'  (2) for entering individual file names, enter blank for'
     *  /'    nnn,  XXX and YYY.'/
     * '  (3) for entering a file containing file names, enter NNN=-1')
	nfile=0
 6001	write(6,14) 
 14     format('  Enter dtt for disk-to-tape, ttd for tape-to-disk: '
     *      ,$)
	read(5,'(a3)',end=999) opt
	if (opt.ne.'ttd'.and.opt.ne.'dtt') go to 600
 601	write(6,*) ' enter first part (XXX) of fits file name: '
	read(5,2,err=601,end=999) bname
 6011	write(6,*) '  enter second part (YYY) of fits file name: '
	read(5,2,err=6011,end=999) aname
 600	write(6,*) ' enter file numbers nnn (mfo format): '
	read(5,1,err=600,end=999) string
	call mfnum(string,80,nff,200,nfile,1)
	if (string(1:1).eq.'-') nff(1)=-1
 602	write(6,*) '  enter file name for saving tape log:'
	read(5,7,err=602,end=999) logname
	open(unit=20,file=logname,status='old',err=105)
	ilog=1
	do 200 i=1,1000
 	  read(20,10,end=106) oldlog
	  if (oldlog(1:3).eq.' ') ilog=ilog+1
 200	continue
 10	format(a79)
 7	format(a30)
	goto 106
c no old log, opern new one
 105	close(unit=20)
	ilog=1
	open(unit=20,file=logname,status='new',err=999)
 106	if (opt.eq.'dtt') then
	  write(20,5) fdate()
	else
	  write(20,51) fdate()
	end if
 5	format(' fits files copied to tape, date: ',a24)	
 51	format(' fits files copied to disk, date: ',a24)	
1	format(a80)
2	format(a10)
c files to be entered indiviually
	if (nfile.eq.0) then
 500	  write(6,21) ilog
 21	format('  File #',I3,
     *        '  Enter fits file name in full, "end" to exit: ',$)
	  read(5,22,end=998) name
 22	format(a25)
	  if (name.eq.'end') go to 998
	   if (opt.eq.'dtt') then
	     command='dd if='//name//' of='//
     *            tapedrive(1:lnblnk(tapedrive))//' bs=2880'
	   else
	     command='dd of='//name//' if='//
     *            tapedrive(1:lnblnk(tapedrive))//' bs=2880'
	   end if
	  if (opt.eq.'dtt') then
	    write(6,3) ilog, name
	  else
	    write(6,31) ilog, name
	  end if
	  istatus=system(command)
	  write(20,4) ilog,name
	  ilog=ilog+1
	  go to 500
	else if (nff(1).lt.0) then
c for getting entries from an include file
 603	  write(6,41)
 41	format(' Enter file name containing names of files to',
     *       ' be tarred: ',$)
	  read(5,22,end=998) filename
	  open(unit=25,file=filename,status='old',err=603)
 501	  read(25,22,end=997) name
	  if (opt.eq.'dtt') then
	    command='dd if='//name//' of='//
     *            tapedrive(1:lnblnk(tapedrive))//' bs=2880'
	  else
	    command='dd of='//name//' if='//
     *            tapedrive(1:lnblnk(tapedrive))//' bs=2880'
	  end if
	  if (opt.eq.'dtt') then
	    write(6,3) ilog, name
	  else
	    write(6,31) ilog, name
	  end if
	  istatus=system(command)
	  write(20,4) ilog,name
	  ilog=ilog+1
	  go to 501
 997	  close (unit=25)
	  go to 998
	else
c files are in a set
	do 100 i=1,nfile
	  nf=nff(i)
	  call ntocha(nf,version)
c make name
	  if (aname.eq.' ') then
c  Form 2: YYY=blank, name = XXX.nnn
	    name=bname(1:lnblnk(bname))//'.'//version
	  else if (aname.eq.'NNN') then
c  form 3: YYY=NNN --- name = XXXnnn
	    name=bname(1:lnblnk(bname))//version
	  else if (bname.ne.' ') then
c  form 1: name = XXXnnn.YYY,   
	    name=bname(1:lnblnk(bname))//version//'.'//aname
	  else 
c  form 1 again: XXX can be a blank
	    name=version//'.'//aname
	  end if
	  if (opt.eq.'dtt') then
	    command='dd if='//name//' of='//
     *            tapedrive(1:lnblnk(tapedrive))//' bs=2880'
	  else
	    command='dd of='//name//' if='//
     *            tapedrive(1:lnblnk(tapedrive))//' bs=2880'
	  end if
	  if (opt.eq.'dtt') then
	    write(6,3) ilog, name
	  else
	    write(6,31) ilog, name
	  end if
	  istatus=system(command)
	  write(20,4) ilog,name
	  ilog=ilog+1
 3	format('  fits file# ',i4,': ',a20,' copying to tape...')
 31	format('  fits file# ',i4,': ',a20,' copying to disk...')
 4	format(5x,'#',i4,2x,a20)
 100	continue
	end if 
 998	close (unit=20)
 999	return1
	end
