C   parameters for PPP GALFIT wrapper 
c         igalfitpipe:   0 indivisual object, manual
c                            1 use .phm file 
c     (1) parameters for selecting galaxy sample and set up
c              snlim= S/N limit, S/N=1/err(small aperture)
c              rmlim= instrumental mag; not used if >-1.0 (dflt=0.)
c              ists = image stamp size in pixels
c            
c     (2) GALFIT parameters:
c              igalfittype=
c              igfitsave: 0 over write residual images
c                         1 save residual images as individual stamp
c                         2 save residual images as a mosaic
c                         3 save residual images in original image
c              igfout: 0 residual image
c                      1 don''t subtract
c              gsts:  stamp size of galaxy image in units of ppp optimal
c                                 aperture size
c              igsj, jgsj: size of convolution box (x,y)
c              igfout: 
c              iginit: 0 use fixed default
c                      1 use initial estimate from photometry
c              ngftype:  number of profile components to fit
c              gftype(ignp): profile type for ignp components
c              gzpt: magnitude zeropt
c              g
c              ngfneig: number of neighbours for simultaneous fitting
c                       max 20
c                gnzpt(20): zero pt for nth neighbour
c                gfntype(20): fitting type for nth neighbour
c                                (1 per obj only)
c      
c
c     (4) misc:  
c
c	character 
c these are settable parameters
	character gftype*20,galfitpath*48
 	common/galfitsetparm/igalfittype,snlim,rmlim,ists,igfitsave,
     *    igfout,gsts,igsj,jgsj,ngftype,gftype(10),nupsf,galfitpath,
     *    iginit,noo1,noo2
c these are computed parameters
 	common/galfitinit/xgc,ygc,gzpt,gfrad,gfpai,gfbarati,sersicexp
c  these are the other parameters
c	common/
