C**********************************************************************
C  SUBROUTINE PACKAGE TO DO ARITHMETICS AND OTHER OPERATIONS          *
C  ON ARRAYS FROM PPP                                                 *
C**********************************************************************
C
C/////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO SHRINK ARRAY BY INTEGRAL FACTOR INTO 0,0 CORNER
C
	SUBROUTINE SHRINKI(*,NFR,ISH,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
 	INTEGER IX(NU,NV,KF)
	CHARACTER*35 NCOMC,NCOMT,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
  849	CONTINUE
	IF (ISH.EQ.0) THEN
  850	  WRITE(6,805) nint(rish),fac
	  call read2r(rish,fac,*999,*998)
	  ish=nint(rish)
	  IF (FAC.EQ.0..OR.ISH.EQ.0) GO TO 850
	END IF
	NIS=NI/ISH
	NJS=NJ/ISH
	ISH1=ISH-1
	SQ=FAC/FLOAT(ISH*ISH)
	DO 800 J=1,NJS
	  JJ=(J-1)*ISH+1
	  DO 800 I=1,NIS
	    II=(I-1)*ISH+1
	    IXX=0
	    DO 801 K=JJ,JJ+ISH1
	      DO 801 L=II,II+ISH1
 801	        IXX=IXX+IX(L,K,NFR)
	    IX(I,J,NFR)=NINT(IXX*SQ)
 800	CONTINUE
	NII(NFR)=NIS
	NJJ(NFR)=NJS
	NCOMT=NCOMC(NFR)
	NCOMC(NFR)=NCOMT(1:25)//'shrunk'
 805	FORMAT ('   Enter shrink factor (integer) & scale factor[',
     *           I3,f5.2,']: ',$)
      WRITE(6,806) ISH,nii(nfr),njj(nfr)
	nfl(6,nfr)=1
  806 FORMAT (' ... Array shrunk by factor ',I2,', new size: ',2i6)
 999	RETURN1
 998	write(6,*) '  *** input error ***'
	return1
	END
C//////////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO SHRINK ARRAY BY FACTOR INTO 0,0 CORNER
C
	SUBROUTINE SHRINK(*,NFR,SHR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
 849	CONTINUE
	IF(SHR.EQ.0.) THEN
  850	  WRITE(6,805) SHR
	  CALL READ1R(SHR,*999,*850)
	  go to 849
	END IF
	NI=NII(NFR)
	NJ=NJJ(NFR)
	DO 800 L=1,NJ
	  DO 800 K=1,NI
	    KK=K/SHR
	    LL=L/SHR
	    AK=FLOAT(K)/SHR
	    AL=FLOAT(L)/SHR
	    IF(KK.GT.NI.OR.LL.GT.NJ) GO TO 801
	    A1=(IX(KK+1,LL,NFR)-IX(KK,LL,NFR))*(AK-KK)+IX(KK,LL,NFR)
	    A2=(IX(KK+1,LL+1,NFR)-IX(KK,LL+1,NFR))*(AK-KK)+IX(KK,LL+1,NFR)
	    IX(K,L,KF)=(A2-A1)*(AL-LL)+A1
C      CHECK THE ABOVE STATMENT, SHOULD USE IX1 AS SCRATCH
 	    GO TO 800
 801	    IX(K,L,KF)=0
 800	CONTINUE
	CALL MOVE(KF,NFR,IX,NU,NV,KF)
 805	FORMAT ('   Enter shrink factor (Real number, default',F6.2,
     *           ') :',$)
	nfl(6,nfr)=1
	WRITE(6,806) SHR
 806	FORMAT (' ',' ++++ ARRAY SHRUNK BY FACTOR ',F6.3,' ++++')
 999	RETURN1
	END
C////////////////////////////////////////////////////////////////////////
C
C   SUBROUTINE FOR MIRROR INVERSION
C           IPAR=0 : X(I,J)NEW = X(NI-I+1,J) MIRRORED IN J-AXIS
C           IPAR=1 : X(I,J)NEW = X(I,NJ-J+1) MIRRORED IN I-AXIS
C
	SUBROUTINE MIRROR(*,NFR,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
	IF (IPAR.EQ.1) THEN
	  DO 602 J=1,NJ
	    K=NJ+1-J
	    DO 602 I=1,NI
 602	      IX(I,K,KF)=IX(I,J,NFR)
	ELSE
	  DO 603 J=1,NJ
	    DO 603 I=1,NI
	      K=NI+1-I
 603 	      IX(K,J,KF)=IX(I,J,NFR)
	END IF
 605	CALL MOVE(KF,NFR,IX,NU,NV,KF)
	NFL(4,NFR)=NFL(4,NFR)+1
	nfl(6,nfr)=1
 999	RETURN1
	END
C////////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO TRANSPOSE PICTURE
C       IX(I,J)NEW=IX(J,I)OLD
C
	SUBROUTINE TRANSP(*,NFR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
	DO 100 J=1,NJ
	  DO 100 I=1,NI
 100	    IX(J,I,KF)=IX(I,J,NFR)
	NI=NJJ(NFR)
	NJ=NII(NFR)
	NII(NFR)=NI
	NJJ(NFR)=NJ
	CALL MOVE(KF,NFR,IX,NU,NV,KF)
	NFL(4,NFR)=NFL(4,NFR)+1
	nfl(6,nfr)=1
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO ROTATE PICTURE 90 OR 180 DEG 
C     IPAR=2  ROTATE 180 DEG
C     IPAR=0  CLOCKWISE IX(I,J)NEW=IX(NJ-J+1,I)OLD
C     IPAR=1  C-CLOKWISE  IX(I,J)NEW=IX(J,NI-I+1)OLD
C
	SUBROUTINE ROT90(*,NFR,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
	NIT=NI+1
	NJT=NJ+1
c! ROTATE 180 DEG 
	IF (IPAR.EQ.2) THEN 
	  DO 101 J=1,NJ
	    K=NJT-J
	    DO 101 I=1,NI
 101	      IX(NIT-I,K,KF)=IX(I,J,NFR)
	  GO TO 104
c ! COUNTER-CLOCKWISE
	ELSE IF (IPAR.EQ.1) THEN  
	  DO 100 I=1,NI
	    K=NIT-I
	    DO 100 J=1,NJ
 100	      IX(J,K,KF)=IX(I,J,NFR)
c ! CLOCKWISE
	ELSE                  
	  DO 103 J=1,NJ
	    K=NJT-J
	    DO 103 I=1,NI
 103	      IX(K,I,KF)=IX(I,J,NFR)
	END IF
 102	NI=NJJ(NFR)
	NJ=NII(NFR)
	NII(NFR)=NI
	NJJ(NFR)=NJ
 104	CALL MOVE(KF,NFR,IX,NU,NV,KF)
	NFL(4,NFR)=NFL(4,NFR)+1
	nfl(6,nfr)=1
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO SHIFT PICTURE TO NEW POSITION
C SHIFT IS DEFINED BY NEW IX(I,J)=OLD IX(I-SX,J-SY)
C
c  modified to include getting the shift from the transf common block
c    ipar=0: user entered shift
c    ipar=1: get shift from transf: sign convention: picture is shifted
c             to match the original picture (opposit to shifting of
c               position file --> negative sign)
c    ipar=2: same as 1, but use nearest integer shift only
c
	SUBROUTINE SHIFTP(*,NFR,DSX,DSY,IX,NU,NV,KF,ipar)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
c  transformation co-eff from simposmat
c  note that deltath is in radian
 	common/transf/dxmean,dymean,deltath,aadelxy,bbdelxy,istretch
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
	if (ipar.eq.0) then
	IF (abs(DSX).lt.0.00001.AND.abs(DSY).lt.0.00001) THEN
  160	  WRITE(6,150) SX,SY
  150	FORMAT('  ENTER X,Y shifts, REAL, (New IX(i+sx,j+sy)=Old Ix(i'
     *        ,',j)'/'      (default:',2F8.4,'):',$)
	  CALL READ2R(SX,SY,*999,*160)
	  continue
	ELSE
	  SX=DSX
	  SY=DSY
	END IF
	else
c get it from transf common block
	  if (abs(deltath).gt.0.001) then
	    write(6,1) deltath*57.269
 1	format('  *** warning, the transformation is not a pure shift',
     *         //'    rotation ',f7.2,' is ignored **')
	  end if
	  if (ipar.eq.1) then
	    sx=-dxmean
	    sy=-dymean
	  else if (ipar.eq.2) then
	    sx=float(nint(-dxmean))
	    sy=float(nint(-dymean))
	  end if
	  write(6,2) sx,sy
 2	format('  Shift from smat/p result [dx,dy] : ',2f7.3)
	end if
	IF (SX.GT.FLOAT(NI).OR.SY.GT.FLOAT(NJ)) GO TO 999
	IF (abs(SX).lt.0.001.AND.abs(SY).lt.0.001) RETURN1 
	IDI=0
	IDJ=0
	IF (abs(SX).gt.0.001) IDI=INT(SX+.5*SX/ABS(SX))
	IF (abs(SY).gt.0.001) IDJ=INT(SY+.5*SY/ABS(SY))
	DX=SX-FLOAT(IDI)
	DY=SY-FLOAT(IDJ)
	ISI=DX/(ABS(DX)-.0001)
	ISJ=DY/(ABS(DY)-.0001)
	DX=ABS(DX)
	DY=ABS(DY)
c see if it is an integer shift
	intsh=0
	if (dx.lt.0.001) then
	  dx=0.000000
	  intsh=intsh+1
	end if
	if (dy.lt.0.001) then
	  dy=0.000000
	  intsh=intsh+1
	end if
	if (intsh.le.1) then
	DO 100 J=1,NJ
	  DO 100 I=1,NI
	    IP=I-IDI
	    JP=J-IDJ
	    IF (IP.LT.1.OR.IP.GT.NI.OR.JP.LT.1.OR.JP.GT.NJ) then
c out of bound
 	      IX(I,J,KF)=0
	    else
	      IF ((IP-ISI).LT.1.OR.(IP-ISI).GT.NI) then
	        ix(i,j,kf)=0
	      else IF ((JP-ISJ).LT.1.OR.(JP-ISJ).GT.NJ) then
	        ix(i,n,kf)=0
	      else
	        IX(I,J,KF)=nint(IX(IP,JP,NFR)*(1.-DX)*(1.-DY) +
     *	         IX(IP-ISI,JP-ISJ,NFR)*DY*DX   +
     *           IX(IP,JP-ISJ,NFR)*DY*(1.-DX)  +
     *           IX(IP-ISI,JP,NFR)*DX*(1.-DY))
	      end if
	    end if
 100	CONTINUE
	else
c integer shift only, 
	DO 105 J=1,NJ
	  DO 105 I=1,NI
	    IP=I-IDI
	    JP=J-IDJ
	    IF (IP.LT.1.OR.IP.GT.NI.OR.JP.LT.1.OR.JP.GT.NJ) then
c out of bound
 	      IX(I,J,KF)=0
	    else
	      IF ((IP-ISI).LT.1.OR.(IP-ISI).GT.NI) then
	        ix(i,j,kf)=0
	      else IF ((JP-ISJ).LT.1.OR.(JP-ISJ).GT.NJ) then
	        ix(i,n,kf)=0
	      else
	        IX(I,J,KF)=IX(IP,JP,NFR)
	      end if
	    end if
 105	CONTINUE
	end if
	CALL MOVE(KF,NFR,IX,NU,NV,KF)
	NFL(5,NFR)=NFL(5,NFR)+1
	nfl(6,nfr)=1
	WRITE(6,652) NFR,SX,SY
652	FORMAT (1X,' +++ FRAME ',I2,' SHIFTED BY',2F7.2,' IN I, J +++')
	RETURN1
999	WRITE(6,*) ' ***** NO SHIFT PERFORMED *****'
	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO DO CONSTANT ARITHMETICS ON PICTURE
C
	SUBROUTINE CARITH(*,NFR,NOPER,CONST,OSTRING,STRBOX,IFL,
     *        IX,NU,NV,KF)
	CHARACTER*1 NOP(4),NOPER
	character ostring*60,strbox*60
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
c	character*64 fstring,fstr17
	COMMON/BOX/IBOX(4,10),NBOX
	DATA NOP/'+','-','*','/'/
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
	IF (IFL.NE.0) GOTO 20
	IF (OSTRING.EQ.' ') THEN
 600	  WRITE(6,10) 
 10	FORMAT('   Enter operation (*/+-) and constant : ',$)
	  call readstr(60,ostring,*999,*600)
 19	FORMAT(A1,F15.0)
	END IF
c	  DO 231 IB=3,9
c	    IF (OSTRING(IB:IB).EQ.' ') GO TO 232
c 231	  CONTINUE
c 232	  istatus=encode(fstring,float(ib-2),1,0,idum)
c	  fstr17='(A1,F'//fstring(1:lnblnk(fstring))//'.0)'
  	  READ(OSTRING,17,ERR=600) NOPER,CONST
 17	format(a1,f15.0)
 20	WRITE(6,18) NFR,NOPER,CONST
 18	FORMAT('  ...FRAME ',I1,1X,A1,F11.4)
	MBOX=0
	IF (STRBOX.NE.' ') READ(STRBOX(4:4),11) MBOX
 11	FORMAT(I1)
	IF (MBOX.LE.0.OR.MBOX.GT.9) THEN
	  J1=1
	  J2=NJ
	  I1=1
	  I2=NI
	ELSE
	  I1=IBOX(1,MBOX)
	  I2=IBOX(2,MBOX)
	  J1=IBOX(3,MBOX)
	  J2=IBOX(4,MBOX)
	  WRITE(6,178) I1,I2,J1,J2
 178	FORMAT('  ...operating on I=',I5,' to',I5,', J=',I5,' to',I5)
	END IF
  	IF (NOPER.NE.NOP(1).AND.NOPER.NE.NOP(2)) GO TO 31	
	IF (NOPER.EQ.NOP(2)) CONST=-CONST
	ICONST=NINT(CONST)
	DO 100 J=J1,J2
	  DO 100 I=I1,I2
	    IXX=IX(I,J,NFR)+ICONST
c	    IF (IABS(IXX).LE.32767) THEN
	      IX(I,J,NFR)=IXX
c	    ELSE
c	      WRITE(6,5) I,J,FLOAT(IXX)
c	      IX(I,J,NFR)=sign(32767.,rx)
c	    END IF
100	CONTINUE
	nfl(6,nfr)=1
	RETURN1
  31	IF (NOPER.NE.NOP(3).AND.NOPER.NE.NOP(4)) GO TO 41	
	IF (NOPER.EQ.NOP(4)) CONST=1./CONST
	DO 110 J=J1,J2
	  DO 110 I=I1,I2
	    RX=FLOAT(IX(I,J,NFR))*CONST
c	    IF (ABS(RX).LE.32767.) THEN
	      IX(I,J,NFR)=nint(RX)
c	    ELSE
c	      WRITE(6,5) I,J,RX
c 5	FORMAT(1X,2I4,' ** OVERFLOW ** IX=',F8.1,' SET TO 32767')
c	      IX(I,J,NFR)=sign(32767.,rx)
c	    END IF
 110 	CONTINUE
	nfl(6,nfr)=1
	RETURN1
 41	WRITE(6,*) '  **** INCORRECT INPUT ****'
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO ADD OR AVERAGE TWO FRAMES TOGETHER
C                      
	SUBROUTINE SUMPIC(*,NFR1,NFR2,NFR3,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*35 NCOMC,NCOMT,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR1,KF,1,*900,*20001)
20001	CALL QUERYNFR(NFR2,KF,2,*900,*20002)
20002	IF (NFR3.LE.0.OR.NFR3.GT.KF) THEN
 600	  WRITE(6,10)
 10	FORMAT( '   Enter frame # for storing result: ',$)
	  call read1i(nfr3,*900,*600)
	  IF (NFR3.GT.KF) GOTO 999
	END IF
	IF (NII(NFR1).NE.NII(NFR2).OR.NJJ(NFR1).NE.NJJ(NFR2))
     *            GO TO 100
	NCOMT=NCOMC(NFR1)
	IF (IPAR.EQ.1) THEN
	  DO 110 J=1,NJJ(NFR1)
	  DO 110 I=1,NII(NFR1)
	    RI=.5*(FLOAT(IX(I,J,NFR1))+FLOAT(IX(I,J,NFR2)))
c	    IF (ABS(RI).LE.32767) THEN
	      IX(I,J,NFR3)=NINT(RI)
c	    ELSE
c	      WRITE(6,200) I,J,RI
c	      IX(I,J,NFR3)=32767
c	    END IF
 200	FORMAT(1X,2I4,' *** OVERFLOW ***   IX=',F8.1,
     *          ' SET TO 32767')
 110	  CONTINUE
	  NCOMC(NFR3)=NCOMT(1:30)//'aver'
	ELSE
	  DO 111 J=1,NJJ(NFR1)
	    DO 111 I=1,NII(NFR1)
	      RI=FLOAT(IX(I,J,NFR1))+FLOAT(IX(I,J,NFR2))
c	      IF (ABS(RI).LE.32767) THEN
	        IX(I,J,NFR3)=NINT(RI)
c	      ELSE
c	        WRITE(6,200) I,J,RI
c	        IX(I,J,NFR3)=32767
c	      END IF
 111	  CONTINUE
	  NCOMC(NFR3)=NCOMT(1:30)//'sum'
	END IF
	NII(NFR3)=NII(NFR1)
	NJJ(NFR3)=NJJ(NFR1)
	NF(NFR3)=NF(NFR1)
	nfl(6,nfr3)=1
	RETURN1
100	WRITE(6,*) '  **** DISCREPANT NI, NJ;'
999	WRITE(6,*) '  **** INPUT ERROR ***, NO SUM TAKEN'
900	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO DIVIDE ONE FRAME BY A SCALED FRAMES
C
	SUBROUTINE PDIV(*,NFR1,NFR2,NFR3,CONST,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*35 NCOMC,NCOMT,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	INCLUDE 'picdir.inc'
	IF (NFR2.EQ.0.AND.NFR3.EQ.0) THEN
 600	  WRITE(6,10) 
 10	FORMAT('   Enter mult const.(C), F1, F2, F<RES>.'
     *            ,/'   (F<RES>=C*F1/F2), ctr d out: ',$)
	  READ(5,*,ERR=111,END=999) CONST,NFR1,NFR2,NFR3
	  GO TO 401
	END IF
 400	IF (CONST.EQ.0.) THEN
	  WRITE(6,440) NFR3,NFR1,NFR2
 440	FORMAT('   FRAME',I2,' = CONST * FRAME',I2,' / FRAME',I2)
 610	  WRITE(6,11)
 11	FORMAT('   Enter constant, (REAL), ctr d out: ',$)
	  call read1r(const,*999,*610)
	ELSE
	  WRITE(6,441) NFR3,CONST,NFR1,NFR2
 441	FORMAT('  FRAME',I2,' =',F12.3,' *FRAME',I2,' / FRAME',I2)
	END IF
 401	IF (CONST.EQ.0.) RETURN1
	IF (NFR1.GT.KF.OR.NFR2.GT.KF.OR.NFR3.GT.KF) GOTO 111
	IF (NII(NFR1).NE.NII(NFR2).OR.NJJ(NFR1).NE.NJJ(NFR2))
     *            GO TO 100
	nover=0
	DO 110 J=1,NJJ(NFR1)
	  DO 110 I=1,NII(NFR1)
	    RI=0.
	    IF (IX(I,J,NFR2).NE.0)
     *	         RI=CONST*FLOAT(IX(I,J,NFR1))/FLOAT(IX(I,J,NFR2))
c	    IF (ABS(RI).GT.32767) THEN
c	      WRITE(6,200) I,J,RI
c	      IX(I,J,NFR3)=32767
c	      nover=nover+1
c200	FORMAT(1X,2I4,' *** OVERFLOW ***   IX=',F8.1,
c    *          ' SET TO 32767')
c 	    ELSE
 	      IX(I,J,NFR3)=NINT(RI)
c 	    END IF
110	CONTINUE
	if (nover.gt.0) write(6,*) '  ....',nover,' pixels overflowed'
	NII(NFR3)=NII(NFR1)
	NJJ(NFR3)=NJJ(NFR1)
	NF(NFR3)=NF(NFR1)
	nfl(6,nfr3)=1
	NCOMT=NCOMC(NFR1)
	NCOMC(NFR3)=NCOMT(1:30)//'pdiv'
	RETURN1
100	WRITE(6,*) '   ***DISCREPANT NI, NJ****'
111	WRITE(6,*) '   *** NO DIVISION TAKEN ***'
999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO DO PICTURE ARITHMETICS
C
C     INPUT EXPRESSION OF THE FORM:
C    PN=CONS OPER1 PJ OPER2 CONS OPER1 PI OPER2 ...ETC
C    WHERE N=RESULT FRAME NUMBER
C          I,J,...=FRAME NUMBER 
C          OPER1'S= * OR /
C          OPER2'S= *,/,+,-
C          CONS'S= REAL CONSTANTS
C     E.G. P2=45.2*P3+3.4*P4
C     NOTE: CONS/PI MEANS  PI/CONS
C           *** AND OPERATIONS ARE SEQUENTIAL *******
C
	SUBROUTINE PARITH(*,STR,STRBOX,IX,NU,NV,KF)
	REAL CONS(6),XX(6)
c	INTEGER*2 IX(NU,NV,KF),IC,ICR,ICL,ICT
	INTEGER IX(NU,NV,KF),IC,ICR,ICL,ICT
	INTEGER NP(6)
	CHARACTER*35 NCOMC,NCOMT,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	CHARACTER*1 NPOP(5),NOP(6),CHAR
	CHARACTER*60 STR,STRBOX
	character*64 string,fstr13,fstr3
	INCLUDE 'picdir.inc'
	COMMON/BOX/IBOX(4,10),NBOX
	NOVF=0
	NOLIM=100
	NZ=0
	NZLIM=100
	DO 124 I=1,5
 124	NPOP(I)=' '
c ! no input, do whole picture
	IF (STR.EQ.' ') THEN 
 600      WRITE(6,164)
 164	FORMAT ('  Enter expression: (e.g. p1=2.5*p2+5.9*p3, ',
     *       'MAX 5 operations'/,'       : ',$)
	  call readstrd(60,str,*999,*600)
 161	  MBOX=0
C 601	  WRITE(6,165)
C 165	FORMAT('   Enter box number (1-9) (dflt or 0 = whole'
C    *          ,' picture): ',$)
C	  CALL READI4(1,MBOX,,,*999,*601,,)
c !  parse box number
	ELSE 
	  IF (STRBOX.EQ.' ') GO TO 161
	  READ(STRBOX(4:4),11) MBOX
	END IF
c 5	FORMAT(A50)
 10	FORMAT(A1)
 11	FORMAT(I1)
	DO 60 IC=1,50
	READ(STR(IC:IC),10) CHAR
 60	IF (CHAR.EQ.'p') GO TO 61
	GO TO 50
 61	READ(STR(IC+1:IC+1),11,ERR=50) NRES
 	ICL=IC+2
	DO 59 IC=ICL,50
 	READ(STR(IC:IC),10) CHAR
 59	IF (CHAR.EQ.'=') GO TO 100
	GO TO 50
 100	NOT=0
 102	ICL=IC+1
 	DO 62 IC=ICL,50
	READ(STR(IC:IC),10) CHAR
 62	IF (CHAR.EQ.'p') GO TO 63
	GO TO 101
 63	NOT=NOT+1
	READ(STR(IC+1:IC+1),11,ERR=50) NP(NOT)
	ICR=IC-1
	DO 64 IC=ICL,ICR
	READ(STR(IC:IC),10) CHAR
 64	IF (CHAR.EQ.'*'.OR.CHAR.EQ.'/') GO TO 65
	CONS(NOT)=1.
	NOP(NOT)='*'
	GO TO 66
 65	NOP(NOT)=CHAR
	ICT=IC-ICL
	istatus=encode(string,float(ict),1,0,idum)
	fstr13='(F'//string(1:lnblnk(string))//'.0)'
	READ(STR(ICL:IC-1),fstr13,ERR=50) CONS(NOT)
c 13	FORMAT(F<ICT>.0)
 66	DO 67 IC=ICR+2,60
	READ(STR(IC:IC),10) CHAR
	IF (CHAR.EQ.' ') GO TO 67
	IF (CHAR.EQ.'+'.OR.CHAR.EQ.'-') GO TO 69
	IF (CHAR.EQ.'*'.OR.CHAR.EQ.'/') GO TO 69
 67	CONTINUE
	GO TO 101
 69	NPOP(NOT)=CHAR
	GO TO 102
101	istatus=encode(string,float(not),1,0,idum)
	fstr3='(1X,''p'',I1,''='','//string(1:lnblnk(string))//
     *             '(F10.3,A1,''p'',I1,''  '',A1))'
 	WRITE(6,fstr3) NRES,(CONS(I),NOP(I),NP(I),NPOP(I),I=1,NOT)
c 3	FORMAT(1X,'p',I1,'=',<NOT>(F10.3,A1,'p',I1,'  ',A1))
	IF (MBOX.EQ.0) THEN
	  WRITE(6,*) '  ...operating on whole picture'
	  I1=1
	  I2=NII(NP(1))
	  J1=1
	  J2=NJJ(NP(1))
	  IPIC=0
	ELSE IF (MBOX.GT.9) THEN
	  WRITE(6,*) '  *** ERROR *** illegal box number'
	  RETURN1
	ELSE
	  WRITE(6,178) (IBOX(I,MBOX),I=1,4)
	  I1=IBOX(1,MBOX)
	  I2=IBOX(2,MBOX)
	  J1=IBOX(3,MBOX)
	  J2=IBOX(4,MBOX)
	  IPIC=1
	END IF
 178	FORMAT('  ...operating on I=',I5,' to',I5,', J=',I5,' to',I5)
	DO 200 I=2,NOT
	  IF (NII(NP(1)).NE.NII(NP(I)).OR.NJJ(NP(1)).NE.NJJ(NP(I))) THEN 
	    CALL RBELL(1)
 603	    WRITE(6,179)
 179	FORMAT('  ++++Warning: frames have different sizes,',/
     *         '    Do you want to continue (y=<cr>/n): ',$)
	    call readstr(1,char,*999,*603)
	    IF (CHAR.EQ.'n') RETURN1
	    GO TO 199
	  END IF
 200	CONTINUE
 199	NII(NRES)=NII(NP(1))
	NJJ(NRES)=NJJ(NP(1))
	NCOMT=NCOMC(NP(1))
	NCOMC(NRES)=NCOMT(1:30)//STR(1:3)
	IF (IPIC.EQ.1) THEN
C  final picture OUTSIDE of box is same as picture 1 IF none of the
C  pictures in the expression are used as final picture	
	  DO 140 N=1,NOT
	    IF (NP(N).EQ.NRES) GO TO 141
 140	  CONTINUE
	  CALL MOVE(NP(1),NRES,IX,NU,NV,KF)
	END IF
 141	CONTINUE
	DO 71 N=1,NOT
 75	  IF (NOP(N).EQ.'/') THEN
	    NOP(N)='*'
	    CONS(N)=1./CONS(N)
	  END IF
 71	CONTINUE
	DO 72 N=1,NOT-1
	  IF (NPOP(N).NE.'-') GO TO 72
	  NPOP(N)='+'
	  CONS(N+1)=-CONS(N+1)
 72	CONTINUE
	nfl(6,nres)=1
	DO 81 J=J1,J2
	  DO 81 I=I1,I2
	    DO 82 N=1,NOT
 82	      XX(N)=CONS(N)*IX(I,J,NP(N))
	    XSUM=XX(1)
	    DO 83 N=2,NOT
 	      IF (NPOP(N-1).NE.'/') GO TO 89
	      IF (XX(N).EQ.0.) GO TO 88
	        XSUM=XSUM/XX(N)
	      GO TO 83
 88	NZ=NZ+1
C	IF (NZ.LT.NZLIM) GO TO 87
C	WRITE(6,*) 'DO YOU WANT TO CONTINUE? y/n'
C	READ(5,10) CHAR
C	IF (CHAR.NE.'y') RETURN1
C	NZLIM=1000
 87	      XSUM=0.
C	      WRITE(6,123) I,J
	      GO TO 83
 89	      IF (NPOP(N-1).EQ.'+') XSUM=XSUM+XX(N)
	      IF (NPOP(N-1).EQ.'*') XSUM=XSUM*XX(N)
 83	    CONTINUE
c	    IF (ABS(XSUM).GT.32767.) THEN
c	      WRITE(6,9) I,J,XSUM
c	      NOVF=NOVF+1
c	      IF (NOVF.LT.NOLIM) GO TO 151
c 6111	      WRITE(6,*) '   DO YOU WANT TO CONTINUE? y/n'
c	      call readstr(1,char,*999,*6111)
c	      IF (CHAR.NE.'y') RETURN1
c 	      NOLIM=10000
c 151	      IX(I,J,NRES)=32767
c	    ELSE
 	      IX(I,J,NRES)=nint(XSUM)
c	    END IF
  81	CONTINUE
	RETURN1
 123	FORMAT('*** DIVIDE BY 0, PIXEL',2I5,' SET TO 0')
 9	FORMAT('***OVERFLOW*** PIXEL',2I5,' IX= ',F12.0,' SET TO 32767')
 50	WRITE(6,*) '   **** INCORRECT PARITH expression ****'
	RETURN1
 900	WRITE(6,*) '   **** PICTURE SIZE DISCREPANT, NO ACTION TAKEN **'
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR PICTURE ROTATION
C
	SUBROUTINE ROTATE(*,NFR,CX,CY,DEG,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
	IF (CX.EQ.0..AND.CY.EQ.0..AND.DEG.EQ.0.) THEN
 600	  WRITE(6,10) 
 10	FORMAT('   Enter center of rotation, (X,Y, REAL): ',$)
	  call read2r(cx,cy,*999,*600)
	END IF
	IF (DEG.EQ.0.) THEN
 6001	  WRITE(6,155)
  155	FORMAT ('   Enter rotation in degrees...CLOCKWISE +VE: ',$)
	  call read1r(deg,*999,*6001)
	END IF
 200	ROT=DEG/57.2958
      DO 100 J=1,NJ
	DY1=FLOAT(J)-CY
	SDY1=DY1*DY1
      DO 100 I=1,NI
	DX1=FLOAT(I)-CX
	DIST=SQRT(DX1*DX1+SDY1)
	IF (DY1.EQ.0.0.AND.DX1.EQ.0.0) GO TO 102
	THERES=ATAN2(DY1,DX1)
	THEOLD=THERES-ROT
	XOLD=DIST*COS(THEOLD)+CX
	YOLD=DIST*SIN(THEOLD)+CY
	IF (XOLD.LT.1..OR.XOLD.GT.(FLOAT(NI))) GO TO 101
	IF (YOLD.LT.1..OR.YOLD.GT.(FLOAT(NJ))) GO TO 101
	IP=INT(XOLD)
	JP=INT(YOLD)
	DX=XOLD-FLOAT(IP)
	DY=YOLD-FLOAT(JP)
	IX(I,J,KF)=IX(IP,JP,NFR)*(1.-DX)*(1.-DY) +
     *	         IX(IP+1,JP+1,NFR)*DY*DX   +
     *           IX(IP,JP+1,NFR)*DY*(1.-DX)  +
     *           IX(IP+1,JP,NFR)*DX*(1.-DY)
	GO TO 100
 102	IX(I,J,KF)=IX(I,J,NFR)
	GO TO 100
 101	IX(I,J,KF)=0
 100	CONTINUE
	CALL MOVE(KF,NFR,IX,NU,NV,KF)
	nfl(6,nfr)=1
      WRITE(6,650) NFR,DEG
  650 FORMAT(' ',' ...FRAME',I2,' ROTATED BY ',F5.2,' DEGREES'/)
	NFL(5,NFR)=NFL(5,NFR)+1
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR SMOOTHING
C   IPAR=0 TAPERED
C   IPAR=1 NO TAPERING
C   IPAR=2 TAPERED, RESULT STORED IN 5
C   IPAR=3 NO TAPERING, RESULT STORED IN 5
C
C
	SUBROUTINE SMOOTH(*,NFR,NSMO,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	dimension filter(11,11)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
	IF (NSMO.EQ.0) THEN
  620	  WRITE(6,61) NSMOO
   61	FORMAT('   N X N Pixel smoothing, Enter N (default',I3,'): ',$)
	  CALL READ1I(NSMOO,*999,*620)
	  continue
	ELSE
 	  NSMOO=NSMO
	END IF
	IF (MOD(NSMOO,2).EQ.0.OR.NSMOO.LE.0) THEN
 	  WRITE(6,64)
	  CALL RBELL(1)
   64  FORMAT('  +++++ Try again, N MUST BE POSITIVE ODD ++++')
 	  GO TO 620
	END IF
	N2=NSMOO/2
	nfl(6,nfr)=1
	IF (IPAR.EQ.1.OR.IPAR.EQ.3) then
        DO 165 J=1,NJ
	  JL=MAX0(J-N2,1)
	  JU=MIN0(J+N2,NJ)
	  sumt=ju-jl+1
	  DO 165 I=1,NI
 	    IL=MAX0(I-N2,1)
	    IU=MIN0(I+N2,NI)
	    TEMP=0.
 	    DO 166 JJ=JL,JU
	      DO 166 II=IL,IU
 	        TEMP=TEMP+IX(II,JJ,NFR)
 166	    continue
	    sumw=sumt*(iu-il+1)
 	    IX(I,J,KF)=TEMP/sumw
 165	continue
	else
c
c  tapered smoothing
c  create filter:  weight=1/(distance+1) from central point
	nfc=n2+1
	sumw=0.
	do 100 j=1,nsmoo
	  kw1=iabs(nfc-j)
	  do 100 i=1,nsmoo
	    filter(i,j)=1./(sqrt(float(kw1*kw1+(iabs(nfc-i))**2))+1.)
	    sumw=sumw+filter(i,j)
 100	continue 
	do 102 j=1,nsmoo
c	  write(6,*) (filter(i,j),i=1,nsmoo)
	  do 102 i=1,nsmoo
	    filter(i,j)=filter(i,j)/sumw
 102	continue
c note that the edge pixels are not smoothed
        DO 65 J=nfc,NJ-n2
	  JL=J-N2
	  JU=J+N2
	  DO 65 I=nfc,NI-n2
 	    IL=I-N2
	    IU=I+N2
	    TEMP=0.
	    kj=0
 	    DO 66 JJ=JL,JU
	      kj=kj+1
	      ki=0
	      DO 66 II=IL,IU
	        ki=ki+1
 	        TEMP=TEMP+IX(II,JJ,NFR)*filter(ki,kj)
 66	    continue
 	    IX(I,J,KF)=nint(TEMP)
 65	continue
	end if
	IF (IPAR.GT.1) THEN
	  NII(KF)=NI
	  NJJ(KF)=NJ
	ELSE
	  CALL MOVE(KF,NFR,IX,NU,NV,KF)
	END IF
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C   SUBROUTINE TO CONVERT BETWEEN LINEAR DU AND MAGNITUDE FORM
C   IPAR=1 NUMBER TO MAGN
C   IPAR=0 MAG TO NUMBER
C
      SUBROUTINE MAGN(*,NFR,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NI=NII(NFR)
	NJ=NJJ(NFR)
C   MAGNITUDE CONVERSION
	IF (IPAR.EQ.1) THEN
 600	  WRITE(6,640)
  640	FORMAT ('   Final pixel value = negative 100th mag',/
     *          ,'   ENTER zero point magnitude (in mag) (default',
     *          F7.3,'): ',$)
	ELSE
	  WRITE(6,641) PZP
 641	FORMAT('  Input pixel values assumed to be in -''ve 100th mag'/
     *          ,'   ENTER zero point magnitude (in mag) (default',
     *          F7.3,'): ',$)
	END IF
	CALL READ1R(PZP,*999,*600)
	PZP=PZP*100.
	nfl(6,nfr)=1
	IF (IPAR.EQ.1) THEN
	  DO 642 J=1,NJ
	    DO 642 I=1,NI
	      IF(IX(I,J,NFR).LE.0) THEN
	        IX(I,J,NFR)=0
	      ELSE
	        IX(I,J,NFR)=NINT(250.*ALOG10(FLOAT(IX(I,J,NFR)))-PZP)
	      END IF
 642	  CONTINUE 
	  WRITE(6,10)  NFR
   10	FORMAT ('   --- Frame',I2,' converted to mag, (-''ve 100th),'
     *	     /'           NOTE: NEGATIVE intensities set to ZERO')
	ELSE
	  DO 643 J=1,NJ
	    DO 643 I=1,NI
 643	      IX(I,J,NFR)=(10.**((IX(I,J,NFR)+PZP)/250.))
	END IF
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO MOVE PICTURE FROM ONE FRAME TO ANOTHER
C
	SUBROUTINE MOVE(NORIG,NDEST,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*35 NCOMC,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	INCLUDE 'picdir.inc'
	IF (NORIG.LT.KF) THEN
	  NI=NII(NORIG)
	  NJ=NJJ(NORIG)
	  NII(NDEST)=NII(NORIG)
	  NJJ(NDEST)=NJJ(NORIG)
	  NF(NDEST)=NF(NORIG)
 	  NCOMC(NDEST)=NCOMC(NORIG)
	  DO 101 I=1,5
 101	    NFL(I,NDEST)=NFL(I,NORIG)
	  nfl(6,ndest)=1
	else IF (NORIG.EQ.KF) THEN
	  NI=NII(NDEST)
	  NJ=NJJ(NDEST)
	END IF
	DO 111 J=1,NJ
	DO 111 I=1,NI
 111	  IX(I,J,NDEST)=IX(I,J,NORIG)
	RETURN
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CALCULATE MEDIAN OF 3 OR 4 PICTURES (ONLY!!!)
C
	SUBROUTINE SMEDIAN(*,STR,NFRS,NFRD,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),NFF(20),II(15)
	INTEGER IX(NU,NV,KF),NFF(20),II(15)
	CHARACTER*20 STR
	character*64 string,fstr10
	CHARACTER*35 NCOMC,NCOMT,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	INCLUDE 'picdir.inc'
	IF (NFRD.NE.0) THEN
	  WRITE(6,*) ' ***CHECK COMMAND ENTRY: medm S N(res) ',
     *               ' use " to enclose string with blanks!!'
	  WRITE(6,*) '   RE-ENTER required infomation...'
	  STR=' '
	  NFRS=0
	END IF
 600	IF (STR.EQ.' ') WRITE(6,11) kf-2
 11	FORMAT('   Enter frame numbers for medium filtering:',
     *       ' min 3, max ',i2,' mfo format,'/'  ....: ',$)
	CALL MFNUM(STR,20,NFF,20,NP,0) 
	IF (NP.EQ.0) RETURN1
	IF (NP.LT.3.OR.NP.GT.kf-2) THEN
	  STR=' '
	  GO TO 600
	END IF
	istatus=encode(string,float(np),1,0,idum)
	fstr10='(''  Medium filter for frs: '','
&		//string(1:lnblnk(string))//'I3)'
	WRITE(6,fstr10) (NFF(I),I=1,NP)
c10	FORMAT('  Medium filter for frs: ',<NP>I3)
C	IF (NFRS.EQ.0) 
	DO 240 I=1,NP-1
	  IF (NII(NFF(I)).NE.NII(NFF(I+1))) GO TO 241
 240	  IF (NJJ(NFF(I)).NE.NJJ(NFF(I+1))) GO TO 241
	NI=NII(NFF(1))
	NJ=NJJ(NFF(1))
	GO TO 601
 241	WRITE(6,*) '  ***** FRAME SIZE NOT EQUAL, NO MEDIAN DONE ****'
	RETURN1
 601	WRITE(6,12) 
 12	FORMAT('  Enter frame number for storing result, ctr d out: ',$)
	call read1i(nfrs,*900,*601)
	IF (NP.EQ.4) THEN
	  DO 101 J=1,NJ
	    DO 101 I=1,NI
	      ISUM=0
 	      DO 102 K=1,4
	        II(K)=IX(I,J,NFF(K))
 102	        ISUM=ISUM+II(K)
	    IX(I,J,NFRS)=(ISUM-MAX0(II(1),II(2),II(3),II(4))
     *                    -MIN0(II(1),II(2),II(3),II(4)))/2
 101	  CONTINUE
	else IF (NP.EQ.3) THEN
	  DO 103 J=1,NJ
	    DO 103 I=1,NI
 	      DO 104 K=1,3
 104	        II(K)=IX(I,J,NFF(K))
	    IX(I,J,NFRS)=MAX0(MIN0(II(1),II(2)),MIN0(II(2),II(3))
     *                    ,MIN0(II(3),II(1)))
 103	  CONTINUE
	else 
c greater than 4, use sort
	  if (mod(np,2).eq.1) then
	    nmed=np/2+1
	  write(6,*) nmed
	  else
	    nmed1=np/2
	    nmed2=nmed1+1
	    nmed=0
	  write(6,*) nmed,nmed1,med2
	  end if
	  do 106 j=1,nj
	    do 106 i=1,ni
	      do 107 k=1,np
	        ii(k)=ix(i,j,nff(k))
 107	    continue
	    call n2sort(np,ii)
	    if (nmed.ne.0) then
	      ix(i,j,nfrs)=ii(nmed)
	    else
	      ix(i,j,nfrs)=nint(0.5*(ii(nmed1)+ii(nmed2)))
	    end if
 106	  continue
	END IF
	NII(NFRS)=NII(NFF(1))
	NJJ(NFRS)=NJJ(NFF(1))
	NCOMT=NCOMC(NFF(1))
	NCOMC(NFRS)=NCOMT(1:30)//'medn'
	nfl(6,nfrs)=1
 900	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO SELF FLATTEN A PICTURE USING MODAL VALUES OF
C   SMALL BLOCKS
C
	SUBROUTINE SELFLAT(*,NFR,strbox,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	DIMENSION AA(0:155,0:155),SIG(0:155,0:155),AATEMP1(0:155),
     *           AATEMP2(0:155)
	character strbox*60
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
	common/box/ibox(4,10),nbox
	EQUIVALENCE (AATEMP1(0),iscr(1)),(AATEMP2(0),iscr(1001))
     *         ,(AA(1,1),iscr(10001)),(SIG(1,1),iscr(100001))
	CALL QUERYNFR(NFR,KF,0,*999,*600)
c20001	IF (NFRS.EQ.0) THEN
 600	  WRITE(6,10) NBLCK
 10	FORMAT('  Enter block size for determining bkgd',
     *         ' for self flattening [dflt',I3,']: ',$)
	  CALL READ1I(NBLCK,*999,*600)
c	  continue
c	ELSE
c	  NBLCK=NFRS
c	END IF
	IF (NBLCK.GT.MIN0(NII(NFR),NJJ(NFR))/4.OR.NBLCK.LT.3) THEN
 	  WRITE(6,*) ' ..Block size too large or too small, def=41 used'
	  NBLCK=41
	END IF
	NDELP=NBLCK/2
	DELP=NDELP
	NBJ=(NJJ(NFR)+NDELP)/NDELP
	NBI=(NII(NFR)+NDELP)/NDELP
	write(6,2) nbi,nbj
 2	format('  Dividing image into ',i3,' X ',i3,' blocks...')
	IF (NBJ.GT.155.OR.NBI.GT.155) THEN
	  WRITE(6,18) 
 18	FORMAT(' ***** Dividing picture into too many blocks,'/
     *    ,           '       ARRAY OVERFLOW, try again *******')
	  GO TO 600
	END IF
C determine mode array using overlapping boxes
	DO 100 J=1,NBJ
	    KY1=(J-1)*NDELP+1
	    KY2=MIN0(NJJ(NFR),KY1+2*NDELP-1)
	  DO 100 I=1,NBI
	    KX1=(I-1)*NDELP+1
	    KX2=MIN0(NII(NFR),KX1+2*NDELP-1)
	    CALL PSTAT(*100,NFR,KX1,KY1,KX2,KY2,AA(I,J),SIG(I,J),NDUM,
     *                  -1,IX,NU,NV,KF)
 100	CONTINUE
C  padd the edges for interpolation
	DO 200 J=1,NBJ
	  AA(0,J)=AA(1,J)
 200	  AA(NBI+1,J)=AA(NBI,J)
	DO 201 I=1,NBI
	  AA(I,0)=AA(I,1)
 201	  AA(I,NBJ+1)=AA(I,NBJ)
	AA(0,0)=AA(1,1)
	AA(0,NBJ+1)=AA(1,NBJ)
	AA(NBI+1,0)=AA(NBI,1)
	AA(NBI+1,NBJ+1)=AA(NBI,NBJ)
C Smooth the array
C  AATEMP1 is the temp array for storing the unsmoothed row above 
	DO 228 I=0,NBI+1
 228	 AATEMP1(I)=AA(I,0)
	DO 220 J=1,NBJ
C store the row being smoothed in AATEMP2
	  AATEMP2(0)=AA(0,J)
	  DO 221 I=1,NBI
 	    AATEMP2(I)=AA(I,J)
	    TT1=0.
	    TT2=0.
	    DO 222 K=I-1,I+1
	      TT1=TT1+AATEMP1(K)
	      TT2=TT2+AA(K,I+1)
 222	    CONTINUE
C taperred 3X3 smoothing is (1*point+1/2*surrounding 8 points)/5
	    AA(I,J)=.2*(AA(I,J)+.5*(AATEMP2(I-1)+AA(I+1,J)+TT1+TT2))
 221	  CONTINUE
C Replace AATEMP1 with AATEMP2
	  DO 223 I=0,NBI
	    AATEMP1(I)=AATEMP2(I)
 223	  CONTINUE
	    AATEMP1(NBI+1)=AA(NBI+1,J)
 220	CONTINUE
C  calucate normalization factor
	SUM=0.
	DO 230 J=1,NBJ
	  DO 230 I=1,NBI
 230	    SUM=SUM+AA(I,J)
	RAT=SUM/(NBJ*NBI)
	DO 211 J=0,NBJ+1
	  DO 211 I=0,NBI+1
 	    IF (AA(I,J).NE.0.) THEN
	      AA(I,J)=RAT/AA(I,J)
	    ELSE
	      AA(I,J)=1.
	    END IF
 211	CONTINUE
C interpolate the AA array and scale the pixels
        MBOX=0
        IF (STRBOX.NE.' ') READ(STRBOX(4:4),11) MBOX
 11     FORMAT(I1)
        IF (MBOX.LE.0.OR.MBOX.GT.9) THEN
          J1=1
          J2=NJJ(nfr)
          I1=1
          I2=NII(nfr)
        ELSE 
          I1=IBOX(1,MBOX)
          I2=IBOX(2,MBOX)
          J1=IBOX(3,MBOX)
          J2=IBOX(4,MBOX)
          WRITE(6,178) I1,I2,J1,J2
 178    FORMAT('  ...operating on I=',I5,' to',I5,', J=',I5,' to',I5)
        END IF
	DO 101 J=j1,j2
c check box
	  YYJ=(FLOAT(J-1))/DELP
	  JYY=YYJ
	  DY=YYJ-FLOAT(JYY)
	  DO 101 I=i1,i2
	    XXI=FLOAT(I-1)/DELP
	    IXX=XXI
	    DX=XXI-FLOAT(IXX)
	    IF (DY.EQ.0.0.AND.DX.EQ.0.0) THEN
	      RAT=AA(IXX,JYY)
	    ELSE
	      RAT=AA(IXX,JYY)*(1.-DX)*(1.-DY) +
     *	          AA(IXX+1,JYY+1)*DY*DX   +
     *            AA(IXX,JYY+1)*DY*(1.-DX)  +
     *            AA(IXX+1,JYY)*DX*(1.-DY)
	    END IF
	    IXT=IX(I,J,NFR)*RAT
	    IX(I,J,NFR)=INTLIMI(IXT)
 101	CONTINUE
	nfl(6,nfr)=1
	NFL(3,NFR)=NFL(3,NFR)+1
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO TRIM A PICTURE
C
	SUBROUTINE TRIMP(*,NFR,II1T,II2T,IJ1T,IJ2T,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	continue 
	IF (IPAR.EQ.0) THEN
	  WRITE(6,2) NFR,nii(nfr),njj(nfr)
 2	  FORMAT('   Trimming frame ',I1,'  SIZE ',I5,' X ',I5)
 600	  WRITE(6,10) II1,II2
 10	FORMAT('   Enter start & end of trimmed picture in I (deflt:',
     *        2I5,'): ',$)
	  CALL READ2I(II1,II2,*999,*600)
	  if (ii1.le.0.or.ii2.gt.nii(nfr).or.ii1.ge.ii2) then
	    write(6,*) ' +++ illegal values, try again +++ '
	    go to 600
	  end if
	  WRITE(6,*) II1,II2
 601	  WRITE(6,120) IJ1,IJ2
 120	FORMAT('   Enter start & end of trimmed picture in J (deflt:'
     *        ,2I5,'): ',$)
	  CALL READ2I(IJ1,IJ2,*999,*601)
          if (ij1.le.0.or.ij2.gt.njj(nfr).or.ij1.ge.ij2) then 
            write(6,*) ' +++ illegal values, try again +++ ' 
            go to 601 
          end if 
	  WRITE(6,*) IJ1,IJ2
	ELSE
	  II1=II1T
	  II2=II2T
	  IJ1=IJ1T
	  IJ2=IJ2T
	END IF
c new picture size
	NI=II2-II1+1
	NJ=IJ2-IJ1+1
c trim starts at (1,1) -- simply change size and return
	if (ii1.eq.1.and.ij1.eq.1) go to 200
	DO 101 J=1,NJ
	  JN=IJ1+J-1
	  DO 101 I=1,NI
	    IN=II1+I-1
 101	    IX(I,J,NFR)=IX(IN,JN,nfr)
c 100	CALL MOVE(NFR,KF,IX,NU,NV,KF)
c	DO 101 J=1,NJ
c	  JN=IJ1+J-1
c	  DO 101 I=1,NI
c	    IN=II1+I-1
c 101	    IX(I,J,NFR)=IX(IN,JN,KF)
c fill edges with 0's
 200	DO 102 J=nj+1,njj(nfr)
	  DO 102 I=1,nii(nfr)
 102	    IX(I,J,NFR)=0
	DO 103 J=1,nj
	  DO 103 I=ni+1,nii(nfr)
 103	    IX(I,J,NFR)=0
	WRITE(6,13) NFR,NI,NJ
 13	FORMAT('  ..... CURRENT PICTURE SIZE FOR FRAME',I2
     *          ,' IS ',I4,' X',I4,' .....')
  	NII(NFR)=NI
	NJJ(NFR)=NJ
	nfl(6,nfr)=1
	NFL(1,NFR)=NFL(1,NFR)+1
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C     SUBROUTINE TO DO PICTURE STATTISTICS, 
C     CALL PARAMETER IPAR:
C             IPAR < 0   NO TERMINAL OUTPUT
C             IPAR=0     SIMPLE AVERAGE OF BOX (CO-ORDINATES FROM "WINDOW")
C             IPAR=1     MODE (MMM) OF BOX (MAX 100000 PIXELS)
C             IPAR=2     SIMPLE AVERAGE OF A SINGLE COLUMN (FIXED I)
C             IPAR=3     MODE OF A SINGLE COLUMN
C             IPAR=4     SIMPLE AVERAGE OF A SINGLE ROW (FIXED J)
C             IPAR=5     MODE OF A SINGLE ROW
C             IPAR=6     SAME AS 2, BUT I IS PASSED THRU KX1
C             IPAR=7     SAME AS 3, BUT I IS PASSED THRU KX1
C             IPAR=8     SAME AS 4, BUT J IS PASSED THRU KX1
C             IPAR=9     SAME AS 5, BUT J IS PASSED THRU KX1
C
	SUBROUTINE PSTAT(*,NFR,KX1,KY1,KX2,KY2,AVE,SIG,NPIX,IPAR,
     *                    IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),ISTAT(300000)
	INTEGER IX(NU,NV,KF),ISTAT(300000)
	REAL ZRAY(100000)
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
	COMMON/BOX/IBOX(4,10),NBOX
	EQUIVALENCE (iscr(500001),ISTAT(1)),(iscr(800001),ZRAY(1))
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IPA=IPAR
	IIPA=IABS(IPA)
	NI=NII(NFR)
	NJ=NJJ(NFR)
	IF (NI.EQ.0.OR.NJ.EQ.0) THEN
	  WRITE(6,10) NFR
 10	FORMAT('     ***** FRAME ',I1,' NOT LOADED ******')
	  RETURN1
	END IF
	NPT=0
C  define window: note that the input IK''s are never changed
	IF (IIPA.LE.1) THEN
C BOX 
c! no input
	  IF (KX1.EQ.0) THEN   
c ! no box, takes middle 30 pixel square
	    IF (NBOX.EQ.0) THEN 
	      IKX1=NI/2-15
	      IKX2=IKX1+30
	      IKY1=NJ/2-15
	      IKY2=IKY1+30
c ! use box NBOX
	    ELSE    
	      IKX1=IBOX(1,NBOX)
	      IKX2=IBOX(2,NBOX)
	      IKY1=IBOX(3,NBOX)
	      IKY2=IBOX(4,NBOX)
	    END IF
c !  input from call statement
	  ELSE  
	    IKX1=KX1
	    IKY1=KY1
	    IKX2=KX2
	    IKY2=KY2
	  END IF
c! window outside
	  IF (IKX1.GT.NI.OR.IKY1.GT.NJ) GO TO 320 
	  IF (IKX2.GT.NI.OR.IKY2.GT.NJ) THEN
	    WRITE(6,13) 
	    IKX2=MIN0(NI,IKX2)
	    IKY2=MIN0(NJ,IKY2)
	  END IF
 13	FORMAT('   ///// limits out of bound, partial window used...')
	ELSE
C rows and columns
C column
	  IF (IIPA.EQ.7.OR.IIPA.EQ.6) THEN 
c! argument passed thru KX1
	    IKX1=KX1
	    GO TO 651
	  ELSE IF (IIPA.LE.3) THEN
 600	    WRITE(6,50) 
 50	FORMAT('   Enter column number (I): ',$)
	    call read1i(ikx1,*999,*600)
 651	    IF (IKX1.GT.NI.OR.IKX1.LE.0) WRITE (6,13)
	    IKX1=MAX0(1,IKX1)
	    IKX2=IKX1
	    IRC=IKX2
	    IKY1=1
	    IKY2=NJ
	  ELSE IF (IIPA.EQ.9.OR.IIPA.EQ.8) THEN
C ROW
	      IKY1=KX1
	      GO TO 653
	  ELSE IF (IIPA.EQ.5.OR.IIPA.EQ.4) THEN
 652	    WRITE(6,51) 
 51	FORMAT('   Enter row number (J): ',$)
	    call read1i(iky1,*999,*652)
 653	    IF (IKY1.GT.NJ.OR.IKY1.LE.0) WRITE (6,13)
	    IKY1=MAX0(1,IKY1)
	    IKY2=IKY1
	    IRC=IKY1
	    IKX1=1
	    IKX2=NI
	  END IF
	END IF
C DECIDE FOR MODE OR AVERAGE
c !    averge
 300	IF (MOD(IIPA,2).EQ.0) THEN   
C load array
	  DO 102 J=IKY1,IKY2
	    DO 102 I=IKX1,IKX2
	      NPT=NPT+1
 102	      ISTAT(NPT)=IX(I,J,NFR)
	  CALL AVSIG(ISTAT,AVE,SIG,IMAX,IMIN,NPT)
	  NPIX=NPT
	  IF (IPA.GE.0) THEN
c out put, if it is a box of 1 column or row, write out the the column
c     or row number
	    IF (IIPA.LE.1) THEN
	      if (iky1.eq.iky2) then
	        write(6,201) iky1,ave,sig,imax,imin
	      else if (ikx1.eq.ikx2) then
	        write(6,201) ikx1,ave,sig,imax,imin
	      else
	        WRITE(6,200) AVE,SIG,IMAX,IMIN
	      end if
	    ELSE
	      WRITE(6,201) IRC,AVE,SIG,IMAX,IMIN
	    END IF
	  END IF
 200	FORMAT(5X,'AVERAGE:',F10.2,'  SIGMA:',F9.3,'   MAX: ',I6,
     *              ' MIN: ',I6)
 201	FORMAT(1X,I4,'# AVERAGE:',F10.2,'  SIGMA:',F9.3,'   MAX: ',I6,
     *              '  MIN: ',I6)
	  RETURN1
	ELSE
C  mode
	  DO 107 J=IKY1,IKY2
	    DO 107 I=IKX1,IKX2
	      NPT=NPT+1
	      IF (NPT.GT.100000) GO TO 321
 107	      ZRAY(NPT)=FLOAT(IX(I,J,NFR))
	  GO TO 322
 321	  WRITE(6,*)' +++ WINDOW >100000 Pixels, partial window used'
	  NPT=100000
 322	  CALL MMM(ZRAY,NPT,NPIX,ZAVE,ZMEDS,AVE,SIG,ZSK,ZREJ,NIT,1.,OM)
	  IF (IPA.GE.0) THEN
	    IF (IIPA.GT.1) THEN
	      WRITE(6,251) IRC,AVE,ZMEDS,ZAVE,SIG,NPIX
	    ELSE
c  write out row or column # if only one row or column is used
	      if (iky1.eq.iky2) then
	        WRITE(6,251) iky1,AVE,ZMEDS,ZAVE,SIG,NPIX
	      else if (ikx1.eq.ikx2) then
	        WRITE(6,251) ikx1,AVE,ZMEDS,ZAVE,SIG,NPIX
	      else
	        WRITE(6,250) AVE,ZMEDS,ZAVE,SIG,NPIX
	      end if
	    END IF
 251	FORMAT(1X,'#',I4,': MODE:',F10.3,'  MED:',F10.3,
     *           '  MEAN:',F10.3,'  SIG:',F9.3,I6)
 250	FORMAT(3X,'MODE:',F10.3,'  MED:',F10.3,
     *           '  MEAN:',F10.3,'  SIG:',F9.3,I6)
	  END IF
	  RETURN1
	END IF
 320	WRITE(6,*) ' *** WINDOW OUTSIDE OF PICTURE ***'
 999	RETURN1
 	END
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CHANGE WINDOW OF PSTAT
C
	SUBROUTINE WINDOW(*,KX1,KY1,KX2,KY2,IPAR)
	IF (KX1.NE.0) THEN
	   WRITE(6,110) KX1,KY1,KX2,KY2
 110	FORMAT(' ...CURRENT WINDOW...  top right: ',2I4,
     *         '  lower left: ', 2I4)
	ELSE
	  WRITE(6,*) ' ...CURRENT WINDOW = DEFAULT ='
     *                         ,' Central 31X31 pixels'
	END IF
	IF (IPAR.NE.0) THEN
	  WRITE(6,*) '  ENTER new window (0 0 for default): '
 600	  WRITE(6,10) 
 10	FORMAT('        top right (smaller X,Y), integers: ',$)
	  call read2i(kx1,ky1,*999,*600)
	  IF (KX1.EQ.0) RETURN1
 601	  WRITE(6,11) 
 11	FORMAT('        lower left (larger X,Y), integers: ',$)
	  call read2i(kx2,ky2,*999,*601)
	  IF (KX2.EQ.0) THEN
	    KX1=0
	    RETURN1
	  END IF
	ELSE
	  RETURN
	END IF
	WRITE(6,111) KX2-KX1+1,KY2-KY1+1
 111	FORMAT(/'  ...WINDOW SIZE...', I4,' X ',I4,' PIXELS')
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO FUDGE DATA POINT ONE AT A TIME
C
	SUBROUTINE FUDGE(*,NFRA,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*1 IANS
	INTEGER NFRA(*)
	INCLUDE 'picdir.inc'
	NFR=NFRA(1)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFRA(2).EQ.0.AND.NFRA(4).EQ.0) THEN
 600	  WRITE(6,10) 
 10	FORMAT('  Enter pixel number (I,J) and new value.',
     *                ' (3 integers): ',$)
	  call readi4(3,ii,jj,new,*13,*600,*2010,*2010)
 2010	  continue
	ELSE
	  II=NFRA(2)
	  JJ=NFRA(3)
	  IF (NFRA(4).EQ.0) THEN
 601	    WRITE(6,9) II,JJ,IX(II,JJ,NFR)
	    call read1i(new,*13,*601)
	  ELSE
	    NEW=NFRA(4)
	  END IF
	END IF
  9	FORMAT('  Enter new value for pixel (',I4,',',I4,') OLD =',I6
     *           ,/'     .....: ',$)
 602	WRITE(6,15) II,JJ,IX(II,JJ,NFR),NEW
 15	FORMAT('  ....CHANGE PIXEL (',I3,',',I3,'), OLD VALUE=',
     *         I7,' TO NEW VALUE=',I6,/' OK? y/n: ',$)
	call readstr(1,ians,*999,*602)
	IF (IANS.NE.'y') GO TO 13
	IX(II,JJ,NFR)=NEW
	WRITE(6,*) '  ....CHANGE MADE'
	nfl(6,nfr)=1
	RETURN1
 13	WRITE(6,*) '  ....NO CHANGE MADE'
 999	RETURN1
	END 
C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO SCALE BAD COLUMNS OR ROWS
C     IPAR=0 NO SCALING, JUST PRINTING COLUMN MODES
C     IPAR=1 SCALE BAD COLUMNS
C     IPAR=2 NO SCALING, JUST PRINTING ROW MODES
C     IPAR=3 SCALE BAD ROWS
C     IPAR=-1 FILL LOW COLUMNS
C     IPAR=-3 FILL HIGH COLUMNS
C
	SUBROUTINE SCBC(*,NFR,IBCT,NCOLT,DSTR,IPAR,sigmed,rcmed,
     *        IX,NU,NV,KF)
	DIMENSION CM(56),SIG(56),SCALE(21),IFILL(21)
	CHARACTER*60 DSTR
	character*64 string,fstr20,fstr302,fstr307
c	INTEGER*2 IX(NU,NV,KF),IBC(56),IBCT(*)
	INTEGER IX(NU,NV,KF),IBC(56),IBCT(*)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IAP=IABS(IPAR)
	IF (NCOLT.EQ.0.) THEN
	  IF (DSTR.EQ.' ') THEN
	    IF (IPAR.EQ.0) THEN
	      WRITE(6,11) 
 11	FORMAT('   Enter COLUMN numbers (mfo file format): ',$) 
	    ELSE IF (IAP.EQ.1) THEN
	      WRITE(6,12) 
 12	FORMAT('   Enter bad COLUMN numbers (mfo file format): ',$) 
	    ELSE IF (IPAR.EQ.2) THEN
	      WRITE(6,13)
 13	FORMAT('   Enter ROW numbers (mfo file format): ',$)
	    ELSE IF (IAP.EQ.3) THEN
	      WRITE(6,14) 
 14	FORMAT('   Enter bad ROW numbers (mfo file format): ',$)
	    END IF
	  END IF
	  CALL MFNUM(DSTR,60,IBC,56,NCOL,0)
	  IF (NCOL.EQ.0) RETURN1
	ELSE
	  NCOL=NCOLT
	  DO 120 I=1,NCOL
 120	    IBC(I)=IBCT(I)
 	END IF
	IF (NCOL.GT.20) then
	  write(6,*) '  +++ too many columns/rows +++'
	  RETURN1
	end if
	IF (IAP.EQ.1.OR.IAP.EQ.3) THEN
C   set up 3 good columns/rows on each side of the bad columns
	  NBCOL=NCOL
	  NCOL=NCOL+6
	  DO 100 I=NCOL,NCOL-2,-1
 100	    IBC(I)=IBC(NBCOL)+4-(NCOL-I)
	  K=0
	  DO 101 I=NCOL-3,4,-1
	    IBC(I)=IBC(NBCOL-K)
 101	    K=K+1
	  DO 102 I=1,3
 102	    IBC(I)=IBC(4)-5+I
	END IF
	istatus=encode(string,float(ncol),1,0,idum)
	fstr20='(1X,'//string(1:lnblnk(string))//'I4)'
	WRITE(6,fstr20) (IBC(J),J=1,NCOL)
c 20	FORMAT(1X,<NCOL>I4)
c !       columns
	IF (IAP.LE.1) THEN   
	  DO 300 I=1,NCOL
	    IF (IBC(I).LT.1.OR.IBC(I).GT.NII(NFR)) THEN
	      WRITE(6,*) ' ***** COLUMN NUMBER PASS PICTURE LIMIT ***'
	      RETURN1
	    END IF
	    IBCD=IBC(I)
 	    CALL PSTAT(*300,NFR,IBCD,0,0,0,CM(I),SIG(I),NDUM,7,
     *                 IX,NU,NV,KF)
 300	  CONTINUE
c ! rows
	ELSE                
	  DO 400 I=1,NCOL
	    IF (IBC(I).LT.1.OR.IBC(I).GT.NJJ(NFR)) THEN
	      WRITE(6,*) ' ***** ROW NUMBER PASS PICTURE LIMIT ***'
	      RETURN1
	    END IF
	    IBCD=IBC(I)
 	    CALL PSTAT(*400,NFR,IBCD,0,0,0,CM(I),SIG(I),NDUM,9,
     *                 IX,NU,NV,KF)
 400	  CONTINUE
	END IF
	IF (MOD(IPAR,2).EQ.0) THEN
	  CALL SLOMED(NCOL,CM,RCMED)
	  CALL SLOMED(NCOL,SIG,SIGMED)
C	  RCAVE=0.
C	  DO 412 I=1,NCOL
C	    RCAVE=RCAVE+CM(I)
C 412	  CONTINUE
C	  WRITE(6,43) RCAVE/FLOAT(MAX0(1,NCOL))
C43	FORMAT('  Average of modes: ',F9.3)
	  WRITE(6,43) RCMED,SIGMED,SIGMED/(AMAX1(.0001,RCMED))
 43	FORMAT('  ... median of MODE:',F10.3,5X,'...median of sigma: '
     *          ,F8.3,/3X,'...sigma/mode :',F12.6)
	  RETURN1  
	END IF
C  else fix bad row/column
	TT1=0
	SCALET=CM(1)+CM(2)+CM(3)+CM(NCOL-2)+CM(NCOL-1)+CM(NCOL)
c ! scale
	IF (IPAR.GT.0) THEN   
	  DO 105 I=4,NBCOL+3
 105	    SCALE(I-3)=SCALET/(CM(I)*6.)
	    istatus=encode(string,float(nbcol),1,0,idum)
	    fstr302='('' SCALING FACTORS: '','
&		//string(1:lnblnk(string))//'F10.6)'
 	    WRITE(6,fstr302) (SCALE(I),I=1,NBCOL)
c 302	FORMAT(' SCALING FACTORS: ',<NBCOL>F10.6)
	ELSE
	  SCALET=SCALET/6.
	  DO 106 I=4,NBCOL+3
 106	    IFILL(I-3)=NINT(SCALET-CM(I))
	    fstr307='(''   FILL VALUES: '','
&		//string(1:lnblnk(string))//'I6)'
 	    WRITE(6,fstr307) (IFILL(I),I=1,NBCOL)
c 307	FORMAT('   FILL VALUES: ',<NBCOL>I6)
	END IF	  
c ! scale columns
	IF (IPAR.EQ.1) THEN    
 	  DO 301 J=1,NJJ(NFR)
	    KK=0
	    DO 301 I=IBC(4),IBC(NBCOL+3)
	      KK=KK+1
	      IXX=nint(FLOAT(IX(I,J,NFR))*SCALE(KK))
c	      IF (IABS(IXX).GT.32767) IXX=ISIGN(32767,IXX)
 301	      IX(I,J,NFR)=IXX
c ! scale rows
	ELSE IF (IPAR.EQ.3) THEN 
	  KK=0
 	  DO 401 J=IBC(4),IBC(NBCOL+3)
	    KK=KK+1
	    DO 401 I=1,NII(NFR)
	      IXX=nint(FLOAT(IX(I,J,NFR))*SCALE(KK))
c	      IF (IABS(IXX).GT.32767) IXX=ISIGN(32767,IXX)
 401	      IX(I,J,NFR)=IXX
c ! Fill columns
	ELSE IF (IPAR.EQ.-1) THEN    
 	  DO 311 J=1,NJJ(NFR)
	    KK=0
	    DO 311 I=IBC(4),IBC(NBCOL+3)
	      KK=KK+1
	      IXX=IX(I,J,NFR)+IFILL(KK)
c 	      IF (IABS(IXX).GT.32767) IXX=ISIGN(32767,IXX)
 311	      IX(I,J,NFR)=IXX
c ! scale rows
	ELSE IF (IPAR.EQ.3) THEN 
	  KK=0
 	  DO 411 J=IBC(4),IBC(NBCOL+3)
	    KK=KK+1
	    DO 411 I=1,NII(NFR)
	      IXX=IX(I,J,NFR)+IFILL(KK)
c 	      IF (IABS(IXX).GT.32767) IXX=ISIGN(32767,IXX)
 411	      IX(I,J,NFR)=IXX
	END IF
	NFL(3,NFR)=NFL(3,NFR)+1
	nfl(6,nfr)=1
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO CREATE MASK FOR FIXING BAD PIXELS
c   ipar=-1  filled mask without initializing  (added Aug 19, 1999)
c   ipar=0   filled mask
c   ipar=1   border of mask
C
	SUBROUTINE CRBPIX(*,IX,NU,NV,KF,ipar)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INTEGER IB(16),IE(16),IT(201)
	CHARACTER*30 STR
	character*64 string1,string2,string3,string4,string5
	character*64 string6,string7,fstr7,fstr8,fstr9
	CHARACTER*1 COD
	INCLUDE 'picdir.inc'
 600	WRITE(6,61) 
 61	FORMAT('  Enter <F> for storing mask: ',$)
	call read1i(nfr,*900,*600)
	CALL QUERYNFR(NFR,KF,4,*900,*20001)
20001	IF (NII(NFR).NE.0) then 
	   if (ipar.ge.0) then
	     WRITE(6,2) NFR
 2	FORMAT('  ++++ WARNING: FRAME ',I2,' WILL BE ERASED ++++')
	   else
	     write(6,*) '   mask map will be added to current frame ',
     *                  nfr
	   end if
	end if
	if (ipar.ge.0) then
 601	  WRITE(6,37) 
 37	FORMAT('   Enter size NI NJ, Ctr d out: ',$)
	  call read2i(nii(nfr),njj(nfr),*900,*601)
	  DO 200 J=1,NJJ(NFR)
	  DO 200 I=1,NII(NFR)
 	    IX(I,J,NFR)=0
 200	  continue
	end if
 603	WRITE(6,10) 
 10	FORMAT(' CODES: c n1 n2 n3 - column I=n1 from n2th to n3th pix'
     *        /'        r n1 n2 n3 - row J=n1 from n2th to n3th pix'
     *        /'        p n1 n2 n3 - pixel (n1,n2)=(I,J), diameter=n3,'
     *         ,' dflt: 1 (=point)'/
     *   '        b n1 n2 n3 n4 - Box (n1,n2)=smallest IJ;',
     *  ' n3,n4=largest IJ'/
     *   '        m n1 n2 n3 n4 - meteor trail: (n1,n2)=I1,J1;',
     *  ' n3,n4=I2,J2, plus thickness'/
     *'        h        - type CODES again'
     *       /'         <CR>       - end of defining mask')
 602	WRITE(6,62) 
 62	FORMAT('  Enter mask data -- format: CODE n1 etc..., h for help'
     *         /' : ',$)
	call readstr(30,str,*900,*602)
	CALL FSTR(STR,30,IB,IE,NE)
 3	FORMAT(A1)
	istatus=encode(string1,float(ie(2)-ib(2)+1),1,0,idum)
	istatus=encode(string2,float(ie(3)-ib(3)+1),1,0,idum)
	istatus=encode(string3,float(ie(4)-ib(4)+1),1,0,idum)
	istatus=encode(string4,float(ie(5)-ib(5)+1),1,0,idum)
	istatus=encode(string5,float(ib(3)-ie(2)-1),1,0,idum)
	istatus=encode(string6,float(ib(4)-ie(3)-1),1,0,idum)
	istatus=encode(string7,float(ib(5)-ie(4)-1),1,0,idum)
	fstr7='(I'//string1(1:lnblnk(string1))//','
     *          //string5(1:lnblnk(string5))//'X,I'
     *           //string2(1:lnblnk(string2))//','
&		 //string6(1:lnblnk(string6))//'X,I'
&		//string3(1:lnblnk(string3))//','
&		 //string7(1:lnblnk(string7))//'X,I'
&		//string4(1:lnblnk(string4))//')'
	fstr8='(I'//string1(1:lnblnk(string1))//','
&		 //string5(1:lnblnk(string5))//'X,I'
&		//string2(1:lnblnk(string2))//','
&		 //string6(1:lnblnk(string6))//'X,I'
&		//string3(1:lnblnk(string3))//')'
	fstr9='(I'//string1(1:lnblnk(string1))//','
&		 //string5(1:lnblnk(string5))//'X,I'
&		//string2(1:lnblnk(string2))//')'
c
c 7	FORMAT(I<IE(2)-IB(2)+1>,<IB(3)-IE(2)-1>X
c     *        ,I<IE(3)-IB(3)+1>,<IB(4)-IE(3)-1>X	
c     *        ,I<IE(4)-IB(4)+1>,<IB(5)-IE(4)-1>X,I<IE(5)-IB(5)+1>)
c 8	FORMAT(I<IE(2)-IB(2)+1>,<IB(3)-IE(2)-1>X
c     *        ,I<IE(3)-IB(3)+1>,<IB(4)-IE(3)-1>X,I<IE(4)-IB(4)+1>)
c 9	FORMAT(I<IE(2)-IB(2)+1>,<IB(3)-IE(2)-1>X,I<IE(3)-IB(3)+1>)	
c
  	IF (STR.EQ.' ') then
	  nfl(6,nfr)=1
c make border only
	  if (ipar.eq.1) call bpborder(*889,nfr,0,ix,nu,nv,kf)
 889	  RETURN1
	end if
	READ(STR(IB(1):IB(1)),3) COD
	IF (COD.EQ.'c') THEN
	  IF (NE.NE.4) GO TO 110
	  READ(STR(IB(2):IE(4)),fstr8,ERR=110) I1,J1,J2
	  I2=I1
	  GO TO 100
	else IF (COD.EQ.'r') THEN
	  IF(NE.NE.4) GO TO 110
	  READ(STR(IB(2):IE(4)),fstr8,ERR=110) J1,I1,I2
	  J2=J1
	  GO TO 100
	else IF (COD.EQ.'p') THEN
	  IF (NE.EQ.3) THEN
	    READ(STR(IB(2):IE(3)),fstr9,ERR=110) I1,J1
	    I2=I1
	    J2=J1
	    GO TO 100
	  ELSE
	    IF (NE.EQ.4) THEN
	      READ(STR(IB(2):IE(4)),fstr8,ERR=110) I1,J1,IR
	      CALL APARAY(IR,IT,IROW,QQ,RR,PP,NN,1)
	      K=0
	      DO 105 J=MAX0(1,J1-IROW),MIN0(NJJ(NFR),J1+IROW)
	        K=K+1
	        DO 105 I=MAX0(1,I1-IT(K)/2),MIN0(NII(NFR),I1+IT(K)/2)
 105	          IX(I,J,NFR)=1
	      GO TO 602
	    END IF
	  END IF
	  GO TO 110
	else IF (COD.EQ.'b') THEN
	  IF (NE.NE.5) GO TO 110
	  READ(STR(IB(2):IE(5)),fstr7,ERR=110) I1,J1,I2,J2
	  GO TO 100
	else if (cod.eq.'m') then
	  IF (NE.NE.5) GO TO 110
	  READ(STR(IB(2):IE(5)),fstr7,ERR=110) I1,J1,I2,J2
c  meteor trail
 610	  write(6,20) ithick
 20	format('   Enter thickness in pixel (-=between 2 pts',
     *          ' +=whole picture) [',i4,']: ',$)
	  call read1i(ithick,*602,*610)
	  call meteorline(i1,i2,j1,j2,ithick,ix(1,1,nfr),nu,nv,
     *            nii(nfr),njj(nfr))
	  go to 602
	else IF (COD.EQ.'h') then
	  GO TO 603
	end if
 110	WRITE(6,*) '  ****** INCORRECT INPUT *******'
	GO TO 602
c make mask for simple retangular geometry
 100	CONTINUE
	write(6,*) I1,J1,I2,J2
	DO 101 J=J1,J2
	  DO 101 I=I1,I2
	    IX(I,J,NFR)=1
 101	CONTINUE
	GO TO 602
 900	RETURN1
	END
c/////////////////////////////////////////////
c  subroutine to draw a line between (i1,i2), (j1,j2) with
c  thickness ithick
c      i1 should always be smaller than i2,
c
	subroutine meteorline(i1,i2,j1,j2,ithick,ix,nu,nv,ni,nj)
c	integer*2 ix(nu,nv)
	integer   ix(nu,nv)
c define line y=ax+b
	  a=float(j2-j1)/float(i2-i1)
	  b=j2-i2*a
c make meteor map
	  if (ithick.eq.0) ithick=-1
	  if (ithick.lt.0) then
	    ii1=i1
	    ii2=i2
	  else
	    ii1=1
	    ii2=ni
	  end if
	  thick=abs(float(ithick))/2
	  do 120 i=ii1,ii2
c compute j
	    y=a*i+b
	    jj1=max0(1,nint(y-thick))
	    jj2=min0(nint(y+thick),nj)
	    do 121 j=jj1,jj2
	      ix(i,j)=1
 121	    continue
 120	  continue
	return
	end
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR FIXING BAD PIXELS, GENERAL SHAPE
C
c   ipar=0 interpolate across shortest side
c   ipar=1 interpolate across I/x (first co-ordinate)
c   ipar=2 interpolate across J/y (2nd co-ordinate)
c     below not in effect
c   ipar=3 interpolate with a 2nd mask: if pix=100, across y
c                                       if pix= 10, across x
c   ipar=4 interpolate with a 2nd mask: if pix=100, across x
c                                       if pix= 10, across y
	SUBROUTINE BPFIX(*,NFR,NM,ipar,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	character*1 ian
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NM.EQ.0) THEN
 600	  WRITE(6,19) 
 19	FORMAT('   Enter frame number of mask, Ctr d = out: ',$)
	  call read1i(nm,*999,*600)
	END IF
	CALL QUERYNFR(NM,KF,0,*999,*20002)
20002	IF (NII(NFR).NE.NII(NM).OR.NJJ(NFR).NE.NJJ(NM)) WRITE(6,2)
 2	FORMAT(' +++++WARNING: MASK SIZE NOT EQUAL PICTURE SIZE +++')	
C  compute average noise of picture
	IF (INOISE.EQ.1) THEN
c	  ISEED=-NINT(SECNDS(0.)*100)
 	  CALL STRIPSKY(NFR,1,1,NII(NFR),NJJ(NFR),7,SKY,SKYNOISE,1,
     *                IX,NU,NV,KF)
	END IF
C	
C   spot check mask to make sure it isn''t a picture
	ibigz=0
	icb=nii(nm)/25
	jcb=njj(nm)/25
	ice=nii(nm)-icb
	jce=njj(nm)-jcb
	ncrit=min0(10,int(0.4*((ice-icb)/4+(jce-jcb)/4)))
	DO 101 J=jcb,jce,3
	DO 101 I=icb,ice,3
	  IF (IABS(IX(I,J,NM)).GT.9) then
	    ibigz=ibigz+1
	    if (ibigz.gt.ncrit) then
	      write(6,'(''  Frame '',i2,'' may not be a mask, do you'',
     *          '' want to continue (y/n=dflt): '',$)') nm
	      read(5,'(a1)',end=999) ian
	      if (ian.ne.'y') then
	        GO TO 901
	      else
	        go to 601
	      end if
	    end if
	  end if
 101	CONTINUE
c request 2nd mask
	if (ipar.gt.2) then
 602	  write(6,15) nmask2
 15	format('  Enter 2nd mask number [',i3,']: ',$)
	  call read1i(nmask2,*999,*602)
	  if (nmask2.gt.kf-1.or.nmask2.lt.1.or.nmask2.eq.nfr) then
	    write(6,*) '  +++ bad mask number ++'
	    go to 601
	  end if
	end if
C   loop for interpolation:
C       extensively revised April 20 1994
 601	continue
	DO 100 J=1,NJJ(NM)
	  DO 100 I=1,NII(NM)
	    IF (IX(I,J,NM).EQ.0) GO TO 100
C   a bad point is found!
c     decide what kind of interpolation
	    if (ipar.eq.0) then
C
C  check for extent in both I and J directions
	      DO 300 K=I-1,1,-1
 	        IF (IX(K,J,NM).EQ.0) GO TO 301
 300	      continue
 301	      IL=K
	      DO 302 K=I+1,NII(NM)
 	        IF (IX(K,J,NM).EQ.0) GO TO 303
 302	      continue
 303	      IR=K
	      IWD=IR-IL
 	      IWDD=IWD+1
	      jl=j+1
	      DO 304 K=J-1,1,-1
	        IF (IX(I,K,NM).EQ.0) GO TO 305
 	        IF ((JL-K).GT.IWDD) GO TO 305
 304	      continue
 305	      JU=K
c  i is already wider than j, so, don''t bother with the other side of j
	      if (jl-ju.le.iwd) then
	        DO 306 K=J+1,NJJ(NM)
 	          IF (IX(I,K,NM).EQ.0) GO TO 307
 306	        continue
 307	        JL=K
	      end if
	      IHT=JL-JU
c  interpolation
c    if j extend is larger, or j hits an edge, interpolate in i
	      if (iht.ge.iwd.or.ju.le.0.or.jl.gt.njj(nfr)) then
 	        IX(I,J,NFR)=INTLIMR(FLOAT(IX(IL,J,NFR))+(I-IL)*
     *	         FLOAT(IX(IR,J,NFR)-IX(IL,J,NFR))/FLOAT(IWD))
c  interpolate in j
	      else if (iwd.gt.iht.or.il.le.0.or.ir.gt.nii(nfr)) then
 	        IX(I,J,NFR)=INTLIMR(FLOAT(IX(I,JU,NFR))+(J-JU)*
     *	         FLOAT(IX(I,JL,NFR)-IX(I,JU,NFR))/FLOAT(IHT))
c	      else if (iht.eq.iwd) then
c iwd=iht, do binlinear iterpolation
C  changed May 30/94, if equal, interpolate in J
c 	        xt1=IX(IL,J,NFR)+(I-IL)*
c     *	          FLOAT(IX(IR,J,NFR)-IX(IL,J,NFR))/FLOAT(IWD)
c 	        xt2=IX(I,JU,NFR)+(J-JU)*
c     *	          FLOAT(IX(I,JL,NFR)-IX(I,JU,NFR))/FLOAT(IHT)
c	        ix(i,j,nfr)=intlimr(0.5*(xt1+xt2)) 
	      end if
c
	    else if (ipar.eq.1) then
c   worry about i only
	      DO 310 K=I-1,1,-1
 	        IF (IX(K,J,NM).EQ.0) GO TO 311
 310	      continue
 311	      IL=K
	      DO 312 K=I+1,NII(NM)
 	        IF (IX(K,J,NM).EQ.0) GO TO 313
 312	      continue
 313	      IR=K
c	write(6,*) ipar,il,ir
c make sure il and ir is not at the edge
	      if (il.le.0) then
	        ix(i,j,nfr)=ix(ir,j,nfr)
	      else if (ir.gt.nii(nfr)) then
	        ix(i,j,nfr)=ix(il,j,nfr)
	      else
	        IWD=IR-IL
 	        IX(I,J,NFR)=INTLIMR(FLOAT(IX(IL,J,NFR))+(I-IL)*
     *	          FLOAT(IX(IR,J,NFR)-IX(IL,J,NFR))/FLOAT(IWD))
	      end if
c
	    else if (ipar.eq.2) then
c   worry about j only
	      DO 314 K=J-1,1,-1
	        IF (IX(I,K,NM).EQ.0) GO TO 315
 314	      continue
 315	      JU=K
	      DO 316 K=J+1,NJJ(NM)
 	        IF (IX(I,K,NM).EQ.0) GO TO 317
 316	      continue
 317	      JL=K
c make sure jl and ju is not at the edge
	      if (ju.le.0) then
	        ix(i,j,nfr)=ix(i,jl,nfr)
	      else if (jl.gt.njj(nfr)) then
	        ix(i,j,nfr)=ix(i,ju,nfr)
	      else
	        IHT=JL-JU
 	        IX(I,J,NFR)=INTLIMR(FLOAT(IX(I,JU,NFR))+(J-JU)*
     *	          FLOAT(IX(I,JL,NFR)-IX(I,JU,NFR))/FLOAT(IHT))
	      end if
	    end if
c
C  add noise
 104	    IF (INOISE.EQ.1)
     *        IX(I,J,NFR)=IX(I,J,NFR)+NINT(SKYNOISE*GASDEV(ISEED))
 100	CONTINUE
	nfl(6,nfr)=1
	NFL(2,NFR)=NFL(2,NFR)+1
	GO TO 999
 901	WRITE(6,17) NM
 17	FORMAT(' ********* FRAME ',I2,' IS NOT A MASK *******')
 999	RETURN1
	END
c////////////////////////////////////////////////////////////
c  subroutine for fixing zero orders
c    input: 2 b entries in same format as bpfi
c           1st one to be fixed
c           2nd one to be used to create averge pixel value
c               for the y columns
c            the bad pixels are replaced column by column
	subroutine fixzerord(*,nfr,ix,nu,nv,kf)
c       INTEGER*2 IX(NU,NV,KF),ixz1(50),iyz1(50),ixz2(50),iyz2(50),
c    *     ixf1(50),iyf1(50),ixf2(50),iyf2(50)
        INTEGER*2 IX(NU,NV,KF),ixz1(50),iyz1(50),ixz2(50),iyz2(50),
     *     ixf1(50),iyf1(50),ixf2(50),iyf2(50)
	dimension  ib(5),ie(5)
        character string*40
        INCLUDE 'picdir.inc'
        INCLUDE 'ppparm.inc'
        CALL QUERYNFR(NFR,KF,0,*999,*600)
 600  	write (6,1)
 1	format('  Spectral Zero order interpolation: Enter 2 bpfi ',
     *     'boxes (b n1 n2 n3 n4)'/
     *     '  for each zero order, or file name')
	do 100, i=1,50
 601	  write(6,2)
 2	format('  Enter zero order corner co-ords(<cr>=end): ',$)
	  read(5,'(a40)',end=999) string
c parse string and read numbers, allow to have "b" in front
	  if (string.eq.' ') go to 103
	  if (i.eq.1) then
	    call fstr(string,40,IB,IE,np)
	    if (string(ib(1):ie(1)).eq.'b') goto 101
	    if (np.eq.1) then
c check if it is a file name by reading the first string 
	      read(string(ib(1):ie(1)),*,err=102) idum
c  it is a good number, 
	      go to 101
c  it is a character string:
c read data from a file
 102	      open(unit=25,file=string,status='old',err=997)
c check if it is an sao image
	      do 112 m=1,10
	        read(25,'(a40)') string
	        if (string(1:1).ne.'#') then
	          backspace 25
	          goto 113
	        end if
 112          continue
 113	      continue	
c read in xy data
	      do 110 k=1,50
	        read(25,'(a40)',end=111) string
	        call rdcoobox(string,ixz1(k),iyz1(k),
     *                            ixz2(k),iyz2(k),iorient,*998)
	        read(25,'(a40)',end=105) string
	        call rdcoobox(string,ixf1(k),iyf1(k),
     *                            ixf2(k),iyf2(k),iorient,*998)
 110	      continue
 111	      close(unit=25)
c    xxx tempcom
c	      i=k
	      goto 103
 105	      write(6,*) '  input error, odd number of boxes, aborted'
	      close(unit=25)
	      return1
	    end if
	  end if     
c
c read interactively
 101	  call rdcoobox(string,ixz1(i),iyz1(i),ixz2(i),iyz2(i),
     *         iorient,*601)
c
c  clean area box entry
 602	  write(6,3)
 3	format('  Enter clean area corner co-ords:      ',$)
	  read(5,'(a40)',end=999) string
	  if (string.eq.' ') go to 602
	  call rdcoobox(string,ixf1(i),iyf1(i),ixf2(i),iyf2(i),
     *         iorient,*602)
 100	continue
c
c fix data
 103	nzo=i-1 
	do 120 k=1,nzo
c compute average value for column from good area
          do 121 j=iyz1(k),iyz2(k)
	    sum=0.
	    do 122 i=ixf1(k),ixf2(k)
	      sum=sum+ix(i,j,nfr)
 122	    continue
	    isum=nint(sum/abs(float(ixf2(k)-ixf1(k)+1)))
c replace bad area
	    do 123 i=ixz1(k),ixz2(k)
	      ix(i,j,nfr)=isum
 123	    continue
 121	  continue
 120	continue
	nfl(6,nfr)=1
	write(6,4) nzo
 4	format(' ...',i3,' zero orders fixed..')
 999	return1
 998	write(6,*) '  *** input format error ***'
	return1
 997	write(6,*) '  *** No such file ** '
	return1
	end
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CLEAN COSMIC RAYS USING TWO PICTURES
C       THRES = THRESHOLD IN SIGMA OF SKY FOR WHICH PIXELS
C       WILL BE "CLEANED"
C
	SUBROUTINE CLCOS(*,NFR1,NFR2,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*1 NOPER
	CHARACTER*9 STRING,boxstr*60
	INCLUDE 'picdir.inc'
	DATA NOPER/'+'/
	CALL QUERYNFR(NFR1,KF,1,*999,*20001)
20001	CALL QUERYNFR(NFR2,KF,2,*999,*20002)
20002	NI=NII(NFR1)
	NJ=NJJ(NFR1)
	NF1=0
	NF2=0
 80	WRITE(6,15) NFR1,NFR2,ID,JD,NFR2,NFR1
 15	FORMAT('  Enter INT shift (IN I,J) of frame',I2,
     *         ' from frame',I2,' (deflt:',2I3,')'/
     *  '    i.e., SHIFT = co-ord of F',I2,' - co-ord of F',I2,' : ',$)
	CALL READ2I(ID,JD,*999,*80)
	IF (ID.GE.NI.OR.JD.GE.NJ) RETURN1
	K1=NI/2-15
	K2=K1+30
	K3=NJ/3-15
	K4=K3+30
	CALL PSTAT(*110,NFR1,K1,K3,K2,K4,RMODE1,SIG1,NPX1,1,IX,NU,NV,KF)
 110	CALL PSTAT(*111,NFR2,K1,K3,K2,K4,RMODE2,SIG2,NPX2,1,IX,NU,NV,KF)
 111	WRITE(6,190) NFR1,NFR2
 190	FORMAT('  ...FRAME ',I1,' IS MATCHED TO FRAME ',I1)
	CONST=RMODE2-RMODE1
	CALL  CARITH(*1112,NFR1,NOPER,CONST,STRING,boxstr,1,IX,NU,NV,KF)
 1112	CALL PSTAT(*1101,NFR1,K1,K3,K2,K4,RMODE1,SIG1,NPX1,1,IX,NU,NV,KF)
 1101	CALL PSTAT(*1111,NFR2,K1,K3,K2,K4,RMODE2,SIG2,NPX2,1,IX,NU,NV,KF)
 1111	RAT=RMODE1/RMODE2
	SIGF1=SIG1/RMODE1
	SIGF2=SIG2/RMODE2
	SIGT=SQRT(SIGF1*SIGF1+SIGF2*SIGF2)
 88	WRITE(6,16) THRES
 16	FORMAT('   Enter threshold in units of sigma [',F5.2,']: ',$)
	CALL READ1R(THRES,*999,*88)
	RATU=RAT+SIGT*THRES
	RATL=1./RATU
	RATU2=RATU+SIGT*THRES*2.
	RATL2=1/RATU2
	write(6,*) RATU,RATL
	IB1U=RMODE1+THRES*SIG1
	IB1L=RMODE1-THRES*SIG1
	IB2U=RMODE2+THRES*SIG2
	IB2L=RMODE2-THRES*SIG2
	write(6,*) IB1U,IB1L
	write(6,*) IB2U,IB2L
	IB1UU=IB1U+TRES*SIG1
	IB2UU=IB2U+TRES*SIG2
	IB1LL=IB1L-THRES*SIG1
	IB2LL=IB2L-THRES*SIG2
C  
C big loop  for each pixel
	DO 101 J=1,NJ
	  J2=J+JD
	  DO 101 I=1,NI
	    I2=I+ID
	    IX1=IX(I,J,NFR1)
	    IX2=IX(I2,J2,NFR2)
	    IF (IX2.EQ.0) IX2=1
	    RATIO=FLOAT(IX1)/FLOAT(IX2)
	    IF (RATIO.LT.RATU.AND.RATIO.GT.RATL) GO TO 101
C
C	DETERMINE WHICH PICTURE HAS THE LIKELY BOGUS PIXEL
C
C  IBP =1 0 -1 if the pixel is above, within or below the expected range
	    IF (IX1.LT.IB1L) THEN
	      IBP1=-1
	    ELSE IF (IX1.GT.IB1U) THEN
	      IBP1=1
	    ELSE
	      IBP1=0
	    END IF
	    IF (IX2.LT.IB2L) THEN
	      IBP2=-1
	    ELSE IF (IX2.GT.IB2U) THEN
	      IBP2=1
	    ELSE
	      IBP2=0
	    END IF
	    IF (IBP1.NE.IBP2) THEN
C	CASE 1: one of the pixel is high, and the other is within range
C               or below, if below, only swap if the high one is 2*thres
C                too high
C              
	      IF (IBP1.EQ.1) THEN
	        IF (IBP2.EQ.0.OR.IX1.GT.IB1UU) THEN
	          IX(I,J,NFR1)=INTLIMR(IX2*RAT)
	          NF1=NF1+1
	        END IF
	      ELSE IF (IBP2.EQ.1) THEN
	        IF (IBP1.EQ.0.OR.IX2.GT.IB2UU) THEN
	          IX(I2,J2,NFR2)=INTLIMR(IX1/RAT)
	          NF2=NF2+1
	        END IF
	      ELSE IF (IBP1.EQ.-1) THEN
	        IF (IX1.LT.IB1LL) THEN
	          IX(I,J,NFR1)=INTLIMR(IX2*RAT)
	          NF1=NF1+1
	        END IF
	      ELSE IF (IBP2.EQ.-1) THEN
	        IF (IX2.LT.IB2LL) THEN
	          IX(I2,J2,NFR2)=INTLIMR(IX1/RAT)
	          NF2=NF2+1
	        END IF
	      END IF
	    ELSE 
	      IF (IBP1.EQ.1) THEN
C	
C	CASE 2: BOTH PIXELS ARE ABOVE THE EXPECTED RANGE
C	        ASSUME THE HIGH ONE IS THE BOGUS PIXEL
C               AFTER TESTING WITH A LOOSER TEST
	        IF (RATIO.GT.RATU2.OR.RATIO.LT.RATL2) THEN
	          IF (IX1.LE.IX2) THEN
	            IX(I2,J2,NFR2)=INTLIMR(IX1/RAT)
	            NF2=NF2+1
	          ELSE
	            IX(I,J,NFR1)=INTLIMR(IX2*RAT)
	            NF1=NF1+1
	          END IF
	        END IF
	      ELSE IF (IBP1.EQ.-1) THEN
C
C	CASE 3: both pixels are below range, swap if one of them is below
C                2* thres
C
	        IF (IX2.LT.IX1) THEN
	          IF (IX2.LT.IB2LL) THEN
	            IX(I2,J2,NFR2)=INTLIMR(IX1/RAT)
	            NF2=NF2+1
	          END IF
	        ELSE IF (IX1.LT.IX2) THEN
	          IF (IX1.LT.IB1LL) THEN
	            IX(I,J,NFR1)=INTLIMR(IX2*RAT)
	            NF1=NF1+1
	          END IF
	        END IF
	      END IF
	    END IF
 101	CONTINUE
	WRITE(6,*) NF1,' PIXELS CLEANED FOR FRAME',NFR1
	WRITE(6,*) NF2,' PIXELS CLEANED FOR FRAME',NFR2
	nfl(6,nfr1)=1
	nfl(6,nfr2)=1
 999	RETURN1
	END

C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO DO MEDIAN FILTERING OF A PART OF A PICTURE
C     NFRA(1) =  NFR
C     NFRA(2),(3) =  CENTER OF SUBSECTION
C     NFRA(4),(5) =  EXTEND (TOTAL) IN I AND J
C     NRES    =  RESULT FRAME
C     NSFIL   =  SIZE OF FILTER < MIN(NFRA(4),(5))
C   A HISTOGRAM OF SIZE 33000 IS SET UP FOR INT*2, IF MEDIAN
C     OF THE DATA IS <-232, IT WILL GIVE -232 AS THE ANSWER
C
	SUBROUTINE MEDFIL(*,NFRA,NREST,NSFILT,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),IBOX(10000),IRO(100),IRN(100)
	INTEGER IX(NU,NV,KF),IBOX(10000),IRO(100),IRN(100)
	INTEGER NFRA(5),IHIST(-232:32767)
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
	EQUIVALENCE (IBOX(1),iscr(1)),(iro(1),iscr(100001)),
     *    (irn(1),iscr(100501)),(IHIST(-232),iscr(200001))
	NFR=NFRA(1)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
C
C check inputs, request info if missing
20001	IF (NFRA(2).LE.0.OR.NFRA(2).GT.NII(NFR).OR.NFRA(3).LE.0
     *      .OR.NFRA(3).GT.NJJ(NFR)) THEN
 600	  WRITE(6,10) ICEN,JCEN
 10	FORMAT('  Enter CENTER of picture section to be filtered '
     *         ,' [',2I5,']: ',$)
	  CALL READ2I(ICEN,JCEN,*999,*600)
	  continue
	ELSE
	  ICEN=NFRA(2)
	  JCEN=NFRA(3)
	END IF
	IF (NFRA(4).LE.0.OR.NFRA(4).GT.NII(NFR).OR.NFRA(5).LE.0
     *      .OR.NFRA(5).GT.NJJ(NFR)) THEN
 601	  WRITE(6,31) IEX,JEX
 31	FORMAT('   Enter I J total extend of picture subsection,'
     *        /'     (if even, next odd integer is taken) ['
     *        ,2I5,']: ',$)
	  CALL READ2I(IEX,JEX,*999,*601)
	ELSE
	  IEX=NFRA(4)
	  JEX=NFRA(5)
	END IF
	IEX=(IEX/2)*2+1
	JEX=(JEX/2)*2+1
	IF (NREST.EQ.0.OR.NREST.GT.KF) THEN
 602	  WRITE(6,11) 
 11	FORMAT('  Enter frame # for storing result: ',$)
	  call read1i(nres,*999,*602)
	ELSE
	  NRES=NREST
	END IF
	NII(NRES)=IEX
	NJJ(NRES)=JEX
	IF (NSFILT.LE.0.OR.NSFILT.GT.MIN0(NII(NFR),NJJ(NFR)).OR.
     *         NSFILT.GT.50) THEN
 603	  WRITE(6,12)
 12	FORMAT('  Enter filter (square) size: (ODD Integer) ',$)
	  call read1i(nsfil,*999,*603)
	ELSE
	  NSFIL=NSFILT 
	END IF
C pull the initial filtering area out and create initial histogram
	IBEG=ICEN-IEX/2
	JBEG=JCEN-JEX/2
	IEND=IBEG+IEX-1
	JEND=JBEG+JEX-1
	NSH=NSFIL/2
	NSH1=NSH+1
	K=0
	DO 101 J=JBEG-NSH,JBEG+NSH
	  DO 101 I=IBEG-NSH,IBEG+NSH
	    K=K+1
 101	    IBOX(K)=IX(I,J,NFR)
	NOP=NSFIL*NSFIL
	CALL INITHISTO(IBOX,NOP,IHIST,MED,IMO)
	IX(1,1,NRES)=MED
C
C move window and adjust IBOX
C
	DO 100 I=IBEG,IEND
	  IT=I-IBEG+1
	  IB1=I-NSH
	  IB2=I+NSH
C  the moving window preforms a zig zag pattern on the area
C   going along the J direction.  
C
C  determine which way to go by setting up DO LOOP variable
	  IF (MOD(IT,2).EQ.1) THEN 
c ! ZIG, foreward
	    JBB=JBEG+1             
	    JEE=JEND
	    JB1=JBEG-NSH
	    JIN=1
	  ELSE
c ! ZAG, backward  
	    JBB=JEND-1             
	    JEE=JBEG
	    JB1=JEND-NSH	    
	    JIN=-1
	  END IF
	  NSHO=JIN*NSH1
	  NSHN=JIN*NSH
C
C now for the first window of a new row, the shifting is in the
C   I direction,  
C    except for the case of (1,1), done by INITHIST already
	  IF (I.EQ.IBEG) GO TO 103 
	    DO 120 K=1,NSFIL
c  IRO= pixel values to be deleted
c  IRN= pixel values to be  added  
	      IRO(K)=IX(IB1-1,JB1+K-1,NFR)
 120	      IRN(K)=IX(IB2,JB1+K-1,NFR)	    
	    CALL REPROW(IHIST,NOP,IRO,IRN,NSFIL,MED,IMO)
	    IX(IT,JBB-JIN-JBEG+1,NRES)=MED
C	WRITE(6,*) ' NEW row ',IT,JBB-JIN-JBEG+1, ' original ',I,JBB,MED
C
C now that the first point of a new J row has been determined
C  shift the window in the J direction
C
 103	  DO 102 J=JBB,JEE,JIN
	    L=0
	    JO=J-NSHO
	    JN=J+NSHN
C
C two separate loops for more efficient access to array
	    DO 121 K=IB1,IB2
	      L=L+1
c ! points to be deleted
 121	      IRO(L)=IX(K,JO,NFR) 
	    L=0
	    DO 122 K=IB1,IB2
	      L=L+1
c ! points to be added
 122	      IRN(L)=IX(K,JN,NFR) 
	    CALL REPROW(IHIST,NOP,IRO,IRN,NSFIL,MED,IMO)
C	WRITE(6,*) ' co-ord ',IT,J-JBEG+1, ' original ',I,J,MED
 102	    IX(IT,J-JBEG+1,NRES)=MED
 100	CONTINUE
	NFL(6,NRES)=1
 999	RETURN1
	END
c
C///////////////////////////////////////////////////////////////////////
C  Nov 4 1998
C SUBROUTINE TO DO MEDIAN FILTERING OF A PART OF A PICTURE with
c    both dimensions of the smoothing box specifiable.
C     NFRA(1) =  NFR
C     NFRA(2),(3) =  CENTER OF SUBSECTION
C     NFRA(4),(5) =  EXTEND (TOTAL) IN I AND J
C     NRES    =  RESULT FRAME
C     NSFIL1 nsfil2   =  SIZEs OF FILTER in I and J
C   A HISTOGRAM OF SIZE 33000 IS SET UP FOR INT*2, IF MEDIAN
C     OF THE DATA IS <-232, IT WILL GIVE -232 AS THE ANSWER
C
	SUBROUTINE MEDFIL2(*,NFRA,NREST,NSFILT,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),IBOX(10000),IRO(100),IRN(100)
	INTEGER IX(NU,NV,KF),IBOX(10000),IRO(100),IRN(100)
	INTEGER NFRA(5),IHIST(-232:32767)
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
	EQUIVALENCE (IBOX(1),iscr(1)),(iro(1),iscr(100001)),
     *    (irn(1),iscr(100501)),(IHIST(-232),iscr(200001))
	NFR=NFRA(1)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
C
C check inputs, request info if missing
20001	IF (NFRA(2).LE.0.OR.NFRA(2).GT.NII(NFR).OR.NFRA(3).LE.0
     *      .OR.NFRA(3).GT.NJJ(NFR)) THEN
 600	  WRITE(6,10) ICEN,JCEN
 10	FORMAT('  Enter CENTER of picture section to be filtered '
     *         ,' [',2I5,']: ',$)
	  CALL READ2I(ICEN,JCEN,*999,*600)
	  continue
	ELSE
	  ICEN=NFRA(2)
	  JCEN=NFRA(3)
	END IF
	IF (NFRA(4).LE.0.OR.NFRA(4).GT.NII(NFR).OR.NFRA(5).LE.0
     *      .OR.NFRA(5).GT.NJJ(NFR)) THEN
 601	  WRITE(6,31) IEX,JEX
 31	FORMAT('   Enter I J total extend of picture subsection,'
     *        /'     (if even, next odd integer is taken) ['
     *        ,2I5,']: ',$)
	  CALL READ2I(IEX,JEX,*999,*601)
	ELSE
	  IEX=NFRA(4)
	  JEX=NFRA(5)
	END IF
	IEX=(IEX/2)*2+1
	JEX=(JEX/2)*2+1
	IF (NREST.EQ.0.OR.NREST.GT.KF) THEN
 602	  WRITE(6,11) 
 11	FORMAT('  Enter frame # for storing result: ',$)
	  call read1i(nres,*999,*602)
	ELSE
	  NRES=NREST
	END IF
	NII(NRES)=IEX
	NJJ(NRES)=JEX
 603	WRITE(6,12) nsfil1, nsfil2
 12	FORMAT('  Enter filter dimensions(2 ODD Integers) [',2i4,']: ',$)
	call read2i(nsfil1,nsfil2,*999,*603)
C pull the initial filtering area out and create initial histogram
	IBEG=ICEN-IEX/2
	JBEG=JCEN-JEX/2
	IEND=IBEG+IEX-1
	JEND=JBEG+JEX-1
	write(6,44) ibeg,iend,jbeg,jend
 44	format('  Image section co-ords: I:',2I5,'  J:',2I5)
	NSHI=NSFIL1/2
	NSHI1=NSHI+1
	NSHJ=NSFIL2/2
	NSHJ1=NSHJ+1
	K=0
c  the initial pixel is (ibeg, jbeg)
c fill the ibox array with pixel values around the initial pixel
	DO 101 J=JBEG-NSHJ,JBEG+NSHJ
	  DO 101 I=IBEG-NSHI,IBEG+NSHI
	    K=K+1
 	    IBOX(K)=IX(I,J,NFR)
 101	continue
	NOP=NSFIL1*NSFIL2
c compute first median point
	CALL INITHISTO(IBOX,NOP,IHIST,MED,IMO)
	IX(1,1,NRES)=MED
C
C do-loop move window to next pt and adjust IBOX
C
	DO 100 I=IBEG,IEND
c  I co-ordinate of the next point (doing a fix I, running J)
c     IB1 and IB2 are I co-od of left and right columns to be 
c       removed or added
	  IT=I-IBEG+1
	  IB1=I-NSHI
	  IB2=I+NSHI
c  determine with J to do
c
C  the moving window preforms a zig zag pattern on the area
C   going along the J direction.  In one instant, it is counting
c   up in J, and in the other it is counting down, depending on
c   whether IT (the ith I) is odd or even.
C
C  determine which way to go in J by setting up DO LOOP variable.
c    note that the first pt of the J colum is already done when
c     I shifted.  JIN = increment in J. JBB = 1st J, JEE last J
	  IF (MOD(IT,2).EQ.1) THEN 
c  I is odd ! ZIG, J goes foreward from jbeg+1 to jend
	    JBB=JBEG+1             
	    JEE=JEND
	    JB1=JBEG-NSHJ
	    JIN=1
	  ELSE
c I is even ! ZAG, J goes backward from jend-1 to jbeg.
	    JBB=JEND-1             
	    JEE=JBEG
	    JB1=JEND-NSHJ	    
	    JIN=-1
	  END IF
	  NSHO=JIN*NSHJ1
	  NSHN=JIN*NSHJ
C
C now for the first window of a new row, the shifting is in the
C   I direction,  
C    except for the case of (1,1), done by INITHIST already
	  IF (I.ne.IBEG) then
	    DO 120 K=1,NSFIL2
c  IRO= pixel values to be deleted
c  IRN= pixel values to be  added  
	      IRO(K)=IX(IB1-1,JB1+K-1,NFR)
 120	      IRN(K)=IX(IB2,JB1+K-1,NFR)	    
	    CALL REPROW(IHIST,NOP,IRO,IRN,NSFIL2,MED,IMO)
	    IX(IT,JBB-JIN-JBEG+1,NRES)=MED
C	WRITE(6,*) ' NEW row ',IT,JBB-JIN-JBEG+1, ' original ',I,JBB,MED
C
C now that the first point of a new J row has been determined
C  shift the window in the J direction
C
	  end if
	  DO 102 J=JBB,JEE,JIN
	    L=0
	    JO=J-NSHO
	    JN=J+NSHN
C
C two separate loops for more efficient access to array
	    DO 121 K=IB1,IB2
	      L=L+1
c ! points to be deleted
 121	      IRO(L)=IX(K,JO,NFR) 
	    L=0
	    DO 122 K=IB1,IB2
	      L=L+1
c ! points to be added
 122	      IRN(L)=IX(K,JN,NFR) 
	    CALL REPROW(IHIST,NOP,IRO,IRN,NSFIL1,MED,IMO)
C	WRITE(6,*) ' co-ord ',IT,J-JBEG+1, ' original ',I,J,MED
 102	    IX(IT,J-JBEG+1,NRES)=MED
 100	CONTINUE
	NFL(6,NRES)=1
 999	RETURN1
	END
c
C///////////////////////////////////////////////////////////////////////
C  Nov 4 1998
C SUBROUTINE TO DO MEDIAN FILTERING OF A PART OF A PICTURE, using a
c  brute force median, with
c    both dimensions of the smoothing box specifiable.
C     NFRA(1) =  NFR
C     NFRA(2),(3) =  CENTER OF SUBSECTION
C     NFRA(4),(5) =  EXTEND (TOTAL) IN I AND J
C     NRES    =  RESULT FRAME
C     NSFIL1 nsfil2   =  SIZEs OF FILTER in I and J
C   A HISTOGRAM OF SIZE 33000 IS SET UP FOR INT*2, IF MEDIAN
C     OF THE DATA IS <-232, IT WILL GIVE -232 AS THE ANSWER
C
	SUBROUTINE MEDFIL3(*,NFRA,NREST,NSFILT,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INTEGER NFRA(5)
	dimension xxx(10000)
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
	EQUIVALENCE (xxx(1),iscr(1))
	NFR=NFRA(1)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
C
C check inputs, request info if missing
20001	IF (NFRA(2).LE.0.OR.NFRA(2).GT.NII(NFR).OR.NFRA(3).LE.0
     *      .OR.NFRA(3).GT.NJJ(NFR)) THEN
 600	  WRITE(6,10) ICEN,JCEN
 10	FORMAT('  Enter CENTER of picture section to be filtered '
     *         ,' [',2I5,']: ',$)
	  CALL READ2I(ICEN,JCEN,*999,*600)
	  continue
	ELSE
	  ICEN=NFRA(2)
	  JCEN=NFRA(3)
	END IF
	IF (NFRA(4).LE.0.OR.NFRA(4).GT.NII(NFR).OR.NFRA(5).LE.0
     *      .OR.NFRA(5).GT.NJJ(NFR)) THEN
 601	  WRITE(6,31) IEX,JEX
 31	FORMAT('   Enter I J total extend of picture subsection,'
     *        /'     (if even, next odd integer is taken) ['
     *        ,2I5,']: ',$)
	  CALL READ2I(IEX,JEX,*999,*601)
	ELSE
	  IEX=NFRA(4)
	  JEX=NFRA(5)
	END IF
	IEX=(IEX/2)*2+1
	JEX=(JEX/2)*2+1
	IF (NREST.EQ.0.OR.NREST.GT.KF) THEN
 602	  WRITE(6,11) 
 11	FORMAT('  Enter frame # for storing result: ',$)
	  call read1i(nres,*999,*602)
	ELSE
	  NRES=NREST
	END IF
	NII(NRES)=IEX
	NJJ(NRES)=JEX
 603	WRITE(6,12) nsfil1, nsfil2
 12	FORMAT('  Enter filter dimensions(2 ODD Integers) [',2i4,']: ',$)
	call read2i(nsfil1,nsfil2,*999,*603)
C pull the initial filtering area out and create initial histogram
	IBEG=ICEN-IEX/2
	JBEG=JCEN-JEX/2
	IEND=IBEG+IEX-1
	JEND=JBEG+JEX-1
	write(6,44) ibeg,iend,jbeg,jend
 44	format('  Image section co-ords: I:',2I5,'  J:',2I5)
	NSHI=NSFIL1/2
	NSHJ=NSFIL2/2
  	NOP=NSFIL1*NSFIL2
	jt=0
c  the initial pixel is (ibeg, jbeg)
	do 100 jj=jbeg,jend
	  jt=jt+1
	  it=0
	  do 100 ii=ibeg,iend
	    it=it+1
c fill the ibox array with pixel values around the initial pixel
	    K=0
	    DO 101 J=JJ-NSHJ,JJ+NSHJ
	      DO 101 I=II-NSHI,II+NSHI
	        K=K+1
 	        xxx(K)=IX(I,J,NFR)
 101	    continue
c compute median 
	    CALL slomed(nop,xxx,rmed)
	    IX(IT,JT,NRES)=nint(rmed)
 100	CONTINUE
	NFL(6,NRES)=1
 999	RETURN1
	END

C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROTUINE TO INITIALIZE HISTOGRAM
C     (FOR INTEGER*2 NUMBER STREAMS)
C
	SUBROUTINE INITHISTO(INS,NOP,IHIST,MED,IMO)
c	INTEGER*2 INS(*)
	INTEGER INS(*)
	INTEGER IHIST(-232:32767)
	DO 101 I=-232,32767
 101	  IHIST(I)=0
	IMIN=32767
	DO 100 I=1,NOP
	  IK=MAX0(-232,INS(I))
	  IHIST(IK)=IHIST(IK)+1
	  IF (IK.LT.IMIN) IMIN=IK
 100	CONTINUE
C    determin median
	NUM=0
	NOPH=(NOP+1)/2
	DO 102 I=IMIN,32767
	  NUM=NUM+IHIST(I)
	  IF (NUM.GE.NOPH) GO TO 103
 102	CONTINUE
c ! median
 103	MED=I                      
c ! correction for the actual NOP/2 point
	IMO=IHIST(I)-NUM+NOPH      
	RETURN
	END
C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO ADJUST HISTOGRAM AND DERIVE NEW MEDIAN, GIVEN 
C     ARRAYS   IRO = NUMBERS TO BE DELETED
C              IRN = NUMBERS TO BE ADDED
C     AND EXISTING MEDIAN AND INTRABIN CORRECTION
C     RETURNS NEW MEDIAN AND INTRABIN CORRECTION
C
	SUBROUTINE REPROW(IHIST,NOP,IRO,IRN,NS,MED,IMO)
c	INTEGER*2 IRO(NS),IRN(NS)
	INTEGER IRO(NS),IRN(NS)
	INTEGER IHIST(-232:32767)
	IHISTMED=IHIST(MED)
C  subtract points
	ILOWS=0
	DO 100 I=1,NS
	  IHIST(IRO(I))=IHIST(IRO(I))-1
	  IF (IRO(I).LT.MED) ILOWS=ILOWS+1
 100	CONTINUE
C  add points
	ILOWA=0
	DO 200 I=1,NS
	  IHIST(IRN(I))=IHIST(IRN(I))+1
	  IF (IRN(I).LT.MED) ILOWA=ILOWA+1
 200	CONTINUE
C 
C determine new MED and IMO
c ! the net change in count to left of med bin
	ILOWNET=ILOWA-ILOWS 
	ICOUNT=0
c ! count foreward for ILOWNET+IMO
	IF (ILOWNET.LE.0) THEN   
	  NSHIFT=-ILOWNET+IMO
	  DO 300 I=MED,37267
	    ICOUNT=ICOUNT+IHIST(I)
	    IF (ICOUNT.GE.NSHIFT) GO TO 301
 300	  CONTINUE
c ! case for more points added to left of historgram
	ELSE  
	  NSHIFT=ILOWNET-IMO
c ! count foreward again
	  IF (NSHIFT.LT.0) THEN 
	    NSHIFT=-NSHIFT
	    DO 303 I=MED,37267
	      ICOUNT=ICOUNT+IHIST(I)
	      IF (ICOUNT.GE.NSHIFT) GO TO 301
 303	    CONTINUE
c ! count backward for ILOWNET-IMO
	  ELSE  
	    DO 302 I=MED-1,-232,-1
	      ICOUNT=ICOUNT+IHIST(I)
	      IF (ICOUNT.GT.NSHIFT) GO TO 304
 302	    CONTINUE
	  END IF
c   !  new median
 304	  MED=I        
	  IMO=ICOUNT-NSHIFT
	END IF
	RETURN
c !  new median
 301	MED=I          
	IMO=IHIST(I)-ICOUNT+NSHIFT
	RETURN
	END
C///////////////////////////////////////////////////////////////////
C
C SCALE PICTURE ACCORDING TO ROW MODES
C
C   IPAR=0 WHOLE PICTURE
C   IPAR=1 SCALE ONE PART OF PICTURE TO ANOTHER
C
	SUBROUTINE FLATROW(*,NFR,IU,IL,JD1,JD2,JD3,JD4,IPAR,IX,NU,NV,KF,
     *                       JEX,IPRT)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	REAL ROWM(2100)
	INCLUDE 'picdir.inc'
	include 'pppcore.inc'
	equivalence (rowm(1),iscr(1))
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NJJ(NFR).GT.2100) THEN
	  WRITE(6,*)  '  **** too many rows for RFLAt ****'
	  RETURN1
	END IF
	IF (IU.EQ.0.OR.IL.EQ.0) THEN
 600	  WRITE(6,19) iu,il
 19	FORMAT( '   Enter UPPER & LOWER bound (in I) to be used',
     *                ' in each row[',2i5,']: ',$)
	  call read2i(iu,il,*999,*600)
	END IF
	IF (IPRT.EQ.0) THEN
	  IMU=-1
	ELSE
	  IMU=1
	END IF
	IF (IPAR.EQ.1) THEN
C row index for fixing only part of picture
	  IF (JD1.EQ.0.OR.JD2.EQ.0.OR.JD3.EQ.0.OR.JD4.EQ.0) THEN
 601	    WRITE(6,15) jf1,jf2
 15	FORMAT('   Enter 1st and last row (in J) to be fixed [',2i5,
     *      ']: ',$)
	    call read2i(jf1,jf2,*999,*601)
 602	    WRITE(6,16) jr1,jr2
 16	FORMAT('   Enter 1st & last reference rows [',2i5,']: ',$)
	    call read2i(jr1,jr2,*999,*602)
	  ELSE                    
c ! J index included in call statement
	    JF1=JD1           
	    JF2=JD2
	    JR1=JD3
	    JR2=JD4
	  END IF
	  DO 90 J=MAX0(1,JF1-JEX),MIN0(NJJ(NFR),JF2+JEX)
 	    CALL PSTAT(*90,NFR,IU,J,IL,J,ROWM(J),SIG,NDUM,IMU,
     *                 IX,NU,NV,KF)
 90	  CONTINUE
	ELSE
C row index for fixing whole picture
	  JF1=1
	  JF2=NJJ(NFR)
	  JR1=1
	  JR2=NJJ(NFR)
	END IF	
	RMAV=0.
C calculate average row mode
	DO 100 J=JR1,JR2
	  CALL PSTAT(*100,NFR,IU,J,IL,J,ROWM(J),SIG,NDUM,IMU,
     *               IX,NU,NV,KF)
 100	  RMAV=RMAV+ROWM(J)
 	RMAV=RMAV/FLOAT(JR2-JR1+1)
C scale rows that need fixing
	DO 101 J=JF1,JF2
	  KK=0
	  ROWMT=0.
	  DO 102 K=MAX0(1,J-JEX),MIN0(NJJ(NFR),J+JEX)
	    KK=KK+1
 102	    ROWMT=ROWMT+ROWM(K)
 	  SCALE=KK*RMAV/ROWMT
	  WRITE(6,14) J,SCALE
 14	FORMAT(3X,I4,2X,F9.5)
	  DO 101 I=1,NII(NFR)
	    IX(I,J,NFR)=INTLIMR(IX(I,J,NFR)*SCALE)
 101	CONTINUE
	nfl(6,nfr)=1
	NFL(3,NFR)=NFL(3,NFR)+1
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C SCALE PICTURE ACCORDING TO COLUMN MODES
C
	SUBROUTINE FLATCOL(*,NFR,JUT,JLT,ID1,ID2,ID3,ID4,IPAR,
     *                  IX,NU,NV,KF,IEX,IPRT)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	REAL ROWM(2100),SCALE(2100)
	INCLUDE 'picdir.inc'
	include 'pppcore.inc'
	equivalence (rowm(1),iscr(1)),(scale(1),iscr(10001))
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (JUT.EQ.0.OR.JLT.EQ.0) THEN
 600	  WRITE(6,15) ju,jl
 15	FORMAT('  Enter upper & lower bound (in J) for the column(s)'
     *          ,'[',2i5,']: ',$)
	  call read2i(ju,jl,*999,*600)
	else
	  ju=jut
	  jl=jlt
	END IF
	IF (IPRT.EQ.0) THEN
	  IMU=-1
	ELSE
	  IMU=1
	END IF
	IF (IPAR.EQ.1) THEN
C col index for fixing only part of picture
	  IF (ID1.EQ.0.OR.ID2.EQ.0.OR.ID3.EQ.0.OR.ID4.EQ.0) THEN
 601	    WRITE(6,16) if1,if2
 16	FORMAT('   Enter 1st and last col (in I) to be fixed [',
     *       2i5,']: ',$)
	    call read2i(if1,if2,*999,*601)
 602	    WRITE(6,17) ir1,ir2
 17	FORMAT('   Enter 1st and last reference cols [',2i5,']: ',$)
	    call read2i(ir1,ir2,*999,*602)
	  ELSE                    
c ! I index included in call statement
	    IF1=ID1           
	    IF2=ID2
	    IR1=ID3
	    IR2=ID4
	  END IF
	  DO 90 I=MAX0(1,IF1-IEX),MIN0(NII(NFR),IF2+IEX)
 	    CALL PSTAT(*90,NFR,I,JU,I,JL,ROWM(I),SIG,NDUM,IMU,
     *                 IX,NU,NV,KF)
 90	  CONTINUE
	ELSE
C col index for fixing whole picture
	  IF1=1
	  IF2=NII(NFR)
	  IR1=1
	  IR2=NII(NFR)
	END IF	
	RMAV=0.
	DO 100 I=IR1,IR2
	  CALL PSTAT(*100,NFR,I,JU,I,JL,ROWM(I),SIG,NDUM,IMU,
     *               IX,NU,NV,KF)
 100	  RMAV=RMAV+ROWM(I)
 	RMAV=RMAV/FLOAT(IR2-IR1+1)
	DO 101 I=IF1,IF2
	  KK=0
	  ROWMT=0.
	  DO 102 K=MAX0(1,I-IEX),MIN0(NII(NFR),I+IEX)
	    KK=KK+1
 102	    ROWMT=ROWMT+ROWM(K)
 	  SCALE(I)=KK*RMAV/ROWMT
 101	  WRITE(6,14) I,SCALE(I)
 14	FORMAT(3X,I4,3X,F9.5)
	DO 103 J=1,NJJ(NFR)
	  DO 103 I=IF1,IF2
	    IX(I,J,NFR)=INTLIMR(IX(I,J,NFR)*SCALE(I))
 103	CONTINUE
	nfl(6,nfr)=1
	NFL(3,NFR)=NFL(3,NFR)+1
 999	RETURN1
	END
c////////////////////////////////////////////////////
c  subroutine to combine two images weighted by S/N of each pixel
c     above sky
c    modified Dec 23 2004: allow pipeline call (not request ish,jsh)
c
	subroutine combine2(*,nfra,ix,nu,nv,kf)
	integer ix(nu,nv,kf),ibct(21),isky1,isky2
	dimension nfra(5)
	CHARACTER*35 NCOMC,ians*1,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	common/transf/dxmean,dymean,deltath,aadelxy,bbdelxy,istretch
	include 'picdir.inc'
	include 'ppparm.inc'
	include 'pipeparm.inc'
	nfr1=nfra(1)
	nfr2=nfra(2)
	nfrs=nfra(3)
	call querynfr(nfr1,kf,0,*999,*2001)
 2001	call querynfr(nfr2,kf,0,*999,*2002)
 2002	if (nfrs.gt.kf-1.or.nfrs.le.0) then
 600	  write(6,1) nfrs
 1	format('  Enter frame# for result (can overwrite 1 of 2 images)'
     *       ,'[',i1,']: ',$)
	  call read1i(nfrs,*999,*600)
 	end if
c ask for shift
	if (ircspipe.eq.1) then
	  ish=-999
	  jsh=-999
	else
 601	  write(6,2) ish,jsh
 2	format('  Enter shift in IJ (2nd image - 1st image)'/
     *      '(enter -999 -999 for using smat/p resut):[',2i4,
     *     ']: ',$)
	  call read2i(ish,jsh,*999,*601)
	end if
	if (ish.eq.-999) then
	write(6,*) deltath,dxmean,dymean
	  if (abs(deltath).gt.0.001) then
	    write(6,21) deltath*57.269
 21	format('  *** warning, the transformation is not a pure shift',
     *         //'    rotation ',f7.2,' is ignored **')
	  end if
	  ish=nint(dxmean)
	  jsh=nint(dymean)
	  write(6,22) ish,jsh
 22	format('  Shift (fr 2- fr 1) from smat/p result [dx,dy]: ',
     *           2i5)
	end if
c get the shift from common block transf
c check picture sizes
	if (nii(nfr1).ne.nii(nfr2).or.njj(nfr1).ne.njj(nfr2)) then
	  write(6,3) nii(nfr1),njj(nfr1),nii(nfr2),njj(nfr2)
 3	format(' +++ warning, image sizes not equal (',2I5,'):(',2i5,
     *       ')'/' .... Do you want to continue (y/n=dflt): ',$)
	  read(5,'(a1)') ians
	  if (ians.ne.'y') return1
	end if
c determine global sky using columns
	ncol=20
        ibct(1)=njj(nfr1)*0.2
	idelc=nint(njj(nfr1)*.6/20)
        do 181 i=2,ncol
          ibct(i)=ibct(i-1)+idelc
 181    continue
	call scbc(*200,nfr1,ibct,ncol,' ',2,sig1,sky1,ix,nu,nv,kf)
 200	call scbc(*201,nfr2,ibct,ncol,' ',2,sig2,sky2,ix,nu,nv,kf)
 201	isky1=nint(sky1)
	isky2=nint(sky2)
c determine range of pixels to combine
	ni=min0(nii(nfr1),nii(nfr2)-ish)
	nj=min0(njj(nfr1),njj(nfr2)-jsh)
	i1=max(1,1-ish)
	j1=max(1,1-jsh)
	isat=adusat-50.
c pixel by pixel averaging
	npix=0
	do 100 j=j1,nj
	  jo=j+jsh
	  do 101 i=i1,ni
	    io=i+ish
c (1) if one of the pixel is saturated, the result pixel is saturated
	    if (ix(i,j,nfr1).ge.isat.or.ix(io,jo,nfr2).ge.isat) then
	      ix(i,j,nfrs)=max0(ix(i,j,nfr1),ix(io,jo,nfr2))
	      goto 101
	    end if
c subtract sky
	    z1=ix(i,j,nfr1)-sky1
	    z2=ix(io,jo,nfr2)-sky2 
 	    if (z1.gt.0..or.z2.gt.0.) then
c (2) both pixels above threshold
c     (S/N)^2=z*ccdgain, new pixel value=(z1**2+z2**2)/(z1+z2)
c	      w1sq=(1.+sqrt(abs(z1)*ccdgain))**2
c	      w2sq=(1.+sqrt(abs(z2)*ccdgain))**2
 	      w1sq=(1.+z1/sig1)**2
 	      w2sq=(1.+z2/sig2)**2
c	      w1sq=(1.+z1*ccdgain)**2
c	      w2sq=(1.+z2*ccdgain)**2
	      ix(i,j,nfrs)=nint((z1*w1sq+z2*w2sq)/(w1sq+w2sq)+sky1)
	      npix=npix+1
 	    else
 	      ix(i,j,nfrs)=nint(0.5*(z1+z2)+sky1)
 	    end if
 101	  continue
 100	continue
	NCOMC(NFRS)=NCOMC(nfr1)(1:30)//'wt-av'
	nfl(6,nfrs)=1
	write(6,*) '  # of pixels wt averaged: ',npix
 999	return1
	end
c/////////////////////////////////////////////////////////
c  subroutine to replace pixels outside of the pfbound with a fixed
c   ADU value.  This is used to zero the Elixir mask pixel from edges,
c   so as not cause problem in bpfi.  It can also be used to replace
c      edge pixels with a fixed proxy sky pixel value.
c
	subroutine repborder(nfr,nrpl,scom,ix,nu,nv,kf,*)
	integer ix(nu,nu,kf)
	character scom*60
	include 'objcat.inc'
	include 'picdir.inc'
	call querynfr(NFR,KF,0,*999,*2000)
 2000	if (scom.eq.' ') then
 600	  write(6,1) 
 1	format('  Enter boder replacement ADU value [',i5,']: ',$)
	  call read1i(nrpl,*999,*600)
	end if
c bottom section
	do 100 j=1,jlpos(1)-1
	  do 101 i=1,nii(nfr)
	    ix(i,j,nfr)=nrpl
 101	  continue
 100	continue
c top section
	do 110 j=jupos(1)+1,njj(nfr)
	  do 111 i=1,nii(nfr)
	    ix(i,j,nfr)=nrpl
 111	  continue
 110	continue
c left section
	do 120 j=jlpos(1),jupos(1)
	  do 121 i=1,ilpos(1)-1
	    ix(i,j,nfr)=nrpl
 121	  continue
 120	continue
c right  section
	do 130 j=jlpos(1),jupos(1)
	  do 131 i=iupos(1)+1,nii(nfr)
	    ix(i,j,nfr)=nrpl
 131	  continue
 130	continue
 999	return1
	end	
