C*********************************************************************
C  SUBROUTINE PACKAGE FOR PPP USING PGPLOT
C
C///////////////////////////////////////////////////////////////////////
C
C  CONTOUR PLOT
C
	SUBROUTINE CONTOURPG(*,NFR,DEVICE,icent,jcent,inputpar,
     *          IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER IAN*1,DEVICE*60,IAN1*1,IAN2*1,str1*20,NAM*12
 	DIMENSION ARRAY(670,670),TR(6),idumnfr(5)
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	character*18 HPLOT,SPLOT,dumstr1,dumstr2,obnum*5
	common/PLOTDEV/HPLOT,SPLOT,ipinit
	COMMON/CLEVEL/CTL(20)
	EQUIVALENCE (iscr(1),ARRAY(1,1))     
C	DATA TR/0.,-1.,0.,0.,0.,-1./
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	idumnfr(1)=nfr
	IF (DEVICE.NE.' '.AND.DEVICE.NE.'*') THEN
	  READ(DEVICE,9,ERR=400) FDUM
	  DEVICE=' '
	  WRITE(6,*) '  ---default device assigned--- '
	END IF
 9	FORMAT(F10.0)
	IF (DEVICE.EQ.'*') THEN
	  IF (ICEN.EQ.0) THEN
	    GO TO 400
	  ELSE
 	    GO TO 699
	  END IF
	END IF
 400	if (inputpar.eq.0) then
	  if (icent.gt.0.and.jcent.gt.0) then
	    icen=icent
	    jcen=jcent
	  else
 600	    WRITE(6,10) ICEN,JCEN
 10	FORMAT('  Enter center of plot in I,J [',2I5,']: ',$)
	    CALL READ2I(ICEN,JCEN,*999,*600)
	  end if
	  IF (ICEN.GT.NII(NFR).OR.JCEN.GT.NJJ(NFR).OR.
     *            ICEN.LT.0.OR.JCEN.LE.0) THEN
	    WRITE(6,*)  '  **** Co-ord too large or too small ****'
	    GO TO 600
	  END IF
 601	  WRITE(6,11) IEX,JEX
 11	FORMAT('  Enter extend of plot in I and J direction [',
     *           2I5,']: ',$)
	  CALL READ2I(IEX,JEX,*999,*601)
 699	  IF (IEX.GT.670.OR.JEX.GT.670) THEN
	    WRITE(6,*) ' *** can only plot 670x670 maximum ***'
	    GO TO 601
	  END IF
	  IBEG=MAX0(1,ICEN-IEX/2)
	  IEND=MIN0(NII(NFR),ICEN+IEX/2)	
	  JBEG=MAX0(1,JCEN-JEX/2)
	  JEND=MIN0(NJJ(NFR),JCEN+JEX/2)
	else
C  enter co-ordinate of two corners
 6001	  write(6,28) ibeg,jbeg
 28	format('  Enter upper right co-ord (small IJ) (dflt:',2I5,'): ',$)
	  call read2i(ibeg,jbeg,*999,*6001)
 6002	  write(6,29) iend,jend
 29	format('  Enter lower left co-ord (large IJ) (dflt:',2I5,'): ',$)
	  call read2i(iend,jend,*999,*6002)
 	  iend=min0(iend,nii(nfr))
	  jend=min0(jend,njj(nfr)) 
 	  ibeg=max0(1,ibeg)
	  jbeg=max0(1,jbeg) 
	  if (iend.lt.ibeg.or.jend.lt.jbeg) then
	    write(6,*) ' *** incorrect range input, try again....'
	    go to 6001
	  end if
	  iex=iend-ibeg+1
	  jex=jend-jbeg+1
	  icen=ibeg+iex/2
	  jcen=jbeg+jex/2
	end if	
	  TR(2)=0.
	  TR(6)=0.
	IF (ITRANS.GE.1) THEN
 651	  WRITE(6,50) TR(1),TR(4)
 50	  FORMAT('  User-entered co-rodinate transformation:'/
     *       '   Enter initial co-ord (Dflt: horiz. Jo:',F5.1,
     *          ' vert. Io:',F5.1,'): ',$)
	    CALL READ2R(TR(1),TR(4),*999,*651)
 652	  WRITE(6,51) TR(3),TR(5)
 51	  FORMAT('  Enter scaling (Dflt: horiz. (J):',F5.2,
     *         ' vert. (I):',F5.2,'): ',$)
	    CALL READ2R(TR(3),TR(5),*999,*652)
	    IF (ABS(TR(3)).LT.0.0001.OR.ABS(TR(5)).LT.0.0001) GOTO 652
	ELSE
	  TR(1)=JEND
	  TR(4)=IEND
	  TR(3)=-1.
	  TR(5)=-1.
	END IF
	XMIN=TR(1)
	YMIN=TR(4)
	XMAX=XMIN+TR(3)*(JEND-JBEG+1)
	YMAX=YMIN+TR(5)*(IEND-IBEG+1)
	CALL BORDERSKY(NFR,ICEN,JCEN,IEX/2,JEX/2,2,RM,SIG,1,nsky,IX,NU,NV,KF)
C	CALL PSTAT(*200,NFR,IBEG+IEX/4,0,0,0,RM1,SIG1,NDUM,-8,IX,NU,NV,KF)
C 200	CALL PSTAT(*201,NFR,ICEN,0,0,0,RM2,SIG2,NDUM,-8,IX,NU,NV,KF)
C 201	CALL PSTAT(*202,NFR,IEND-IEX/4,0,0,0,RM3,SIG3,NDUM,-8,IX,NU,NV,KF)
C 202	RM=(RM1+RM2+RM3)/3.
C	SIG=(SIG1+SIG2+SIG3)/3.
	IF (DEVICE.NE.'*') 
     *     CALL CSKY(*200,NFR,ICEN,JCEN,RM,SIG,nsky,IX,NU,NV,KF,' ')
 200	MAX=IX(IBEG,JBEG,NFR)
	LL1=1
	LL2=JEND-JBEG+1
	KK1=1
	KK2=IEND-IBEG+1	
	L=LL2
	DO 100 J=JBEG,JEND
	  L=L-1
	  K=KK2
	  DO 100 I=IBEG,IEND
	    K=K-1
	    IF (IX(I,J,NFR).GT.MAX) MAX=IX(I,J,NFR)
 100	    ARRAY(K,L)=IX(I,J,NFR)
c	IF (NC.LE.0) NC=20
	nc=20
 602	WRITE(6,13) MAX,NC
 13	FORMAT(2X,' MAX pixel= ',I6,
     *     '   Enter number of levels, MAX=20, [',I3,']: ',$)
	IF (DEVICE.EQ.'*') THEN
	  IF (IAN.EQ.'s') THEN 
	    GO TO 6991
	  ELSE
	    GO TO 6994
	  END IF
	END IF
	CALL READ1I(NC,*999,*602)
	IF (lnblnk(IAN).EQ.0) IAN='s'
 6021	WRITE(6,14) IAN
 14	FORMAT('  Contour level types: l=previous levels, u=user input'/
     *    '         e=2*CPL*sigma*i*i, s=scaled by peak'/
     *    '         (default: ',A1,'): ',$)
	call readstrd(1,ian,*999,*6021)
c	IF (IAN1.NE.' ') IAN=IAN1
	if (ian.eq.' ') ian='s'
	IF (IAN.EQ.'l') THEN
	  NL=0
	  DO 108 I=1,NC
	    IF (CTL(I).NE.0.) NL=NL+1
 108	  CONTINUE
	  NC=NL
	ELSE IF (IAN.EQ.'e') THEN
	  DO 111 I=1,NC
 111	    CTL(I)=RM+I*I*2.*CPLX*SIG
	ELSE IF (IAN.EQ.'s') THEN
	  IF (ABS(FRACP).LT.0.0001) FRACP=1.
 609	  WRITE(6,16) FRACP
 16	FORMAT( '   Enter top-most level desired (as fraction of peak)'/
     *          '    +''ve = exp increments, -''ve=equal increments ',
     *     '[dflt',F5.2,']: ',$)
	  CALL READ1R(FRACP,*999,*609)
 6991	  IF (FRACP.LT.-.01) THEN
	    DLEVEL=(MAX-RM)*(-FRACP)/FLOAT(NC)
	    DO 1110 I=1,NC
 1110	      CTL(I)=RM+I*DLEVEL
	  ELSE IF (FRACP.GT..01) THEN
	    DLEVEL=(MAX-RM)*FRACP
	    DO 1111 I=NC,1,-1
	      CTL(I)=RM+DLEVEL
	      IF (DLEVEL.LT.CPLX*SIG) GO TO 1113
C   lowest level must be larger than 1 sigma
 1111	      DLEVEL=DLEVEL*CPLEVEL
 18	FORMAT(5x,'////',I4,' levels will be plotted ////')
 1113	    CONTINUE
	    NC=NC-I
	    DO 1112 J=1,NC
 1112	      CTL(J)=CTL(J+I)
	    DO 1114 J=NC+1,20
 1114	      CTL(J)=0.
	    WRITE(6,18) NC
	  ELSE
	    WRITE(6,*) ' *** ABS(fraction) must be >0.01 ***'
	    GO TO 609
	  END IF
	ELSE
	  DO 110 I=1,NC
 603	    WRITE(6,15) I,ctl(i)
 15	FORMAT('    Enter level ',I2,' (df:',f7.1,'): ',$)
	    call read1r(ctl(i),*6021,*603)
 110	  CONTINUE
	END IF
	WRITE(6,17)
 17	FORMAT('  cplt subcommands:  h = exit, return to ppp;'
     *        /'                     p = replot with new device;'
     *        /'                   l,r = zoom within L,R limits;'/
     * '   c = cursor co-ordinate, d+d = distance between cursors;'
     *        /'   n,N,m,M,a,x,t,w,+,* = same as sdis commands')
 6994	  WRITE(6,21) RM,SIG
 21	FORMAT(' Contour levels: background=',F9.2,'  sigma=',F9.3)
	IF (NC.LE.0) THEN
	  DEVICE=' '
	  GO TO 602
	END IF
 	  NCL=(NC+3)/4
	  DO 143 M=1,NCL
	    M1=(M-1)*4+1
	    M2=M1+3
 143	    WRITE(6,144) (L,CTL(L),L=M1,M2)
 144	FORMAT(4(4X,I2,1X,F7.1))
 619	WRITE(6,22)
 22	FORMAT('  Are contour levels OK? y=<cr>/n :',$)
	call readstr(1,ian1,*999,*619)
	IF (IAN1.EQ.'n') THEN
	  DEVICE=' '
	  GO TO 602
	END IF
	jtop=1
 301	IF (DEVICE.EQ.' '.OR.DEVICE.EQ.'*') DEVICE=SPLOT
	call openpg(device,ipinit,*999) 
 888	CONTINUE
	if (device.eq.'/sun'.or.device.eq.'/xwin') then
	  call pgscr(0,red,green,blue)
	  call pgshls(0,hue,light,sat)
	  call pgsci(ici)  
	end if
	if (itrans.eq.2) then
	  write (6,*) ' ... large character'
           call pgsch(1.8)
	end if
	IF (ILABEL.ge.1) THEN
	  CALL PLABELS(XMIN,XMAX,YMIN,YMAX,1,0,tr,iend,jend,itrans,ilabel,
     *           *999)
	ELSE
	  CALL PGENV(XMIN,XMAX,YMIN,YMAX,1,0)
	END IF
	CALL PGCONS(ARRAY,670,670,KK1,KK2,LL1,LL2,CTL,NC,TR)
	if (jtop.ne.1) call pglabel('','',str1)
	IF (device.eq.'/tek'.or.device.eq.'/sun'.or.device.eq.'/xwin'
     *      ) THEN
	  go to 799
	else
	  if (ipgdate.gt.0) call pgiden
	  CALL closepg(ipinit)
	  RETURN1
	END IF
799	icl=1
c	ICL=0
	IAN1='c'
 800	if (device.eq.'/tek') call sleep(1)
	CALL PGCURSE(CX,CY,IAN1)
	iit=IEND-NINT((CY-TR(4))/TR(5))
	jjt=JEND-NINT((CX-TR(1))/TR(3))
	IF (IAN1.EQ.'h') THEN
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *        call closepg(ipinit)
	  if (itran.eq.2) call pgsch(1.)
	  RETURN1
	ELSE IF (IAN1.EQ.'p') THEN
810	  WRITE(6,23)
 23	  FORMAT('  Replot with same parameter: enter DEVICE name, '/
     *         '    ( /xwin,/tek,/sun,/ps,/vps): ',$)
	  call readstr(18,device,*999,*810)
	  if (device.ne.'/sun'.and.device.ne.'/tek'.or.device.eq.'/xwin'
     *      ) then
	     jtop=0
 610	     WRITE(6,*) '  Enter title,    20 characters maximum:'
	     call readstr(20,str1,*999,*610)
	     DO 309 K=1,12
	       IAN2=STR1(K:K)
	       IF (IAN2.NE.' ') GO TO 308
 309	     CONTINUE
 308	     DO 310 I=K,12
	       IAN2=STR1(I:I)
	       IF (IAN2.EQ.' '.OR.IAN2.EQ.'.'.OR.IAN2.EQ.'-'.OR.
     *                      IAN2.EQ.'+')      GO TO 311
 310	     CONTINUE
 311	     IF (I-1.GE.K) THEN
	       NAM=STR1(K:I-1)//'.'//device(2:lnblnk(device))
	     ELSE
	       NAM='contour.'//device(2:lnblnk(device))
	     END IF
 19	     FORMAT(A20)
	     device=NAM//device
	     CALL closepg(ipinit)
	     write(6,24) nam
24	     format('*** plotfile is named: ',A12)
             GO TO 301
	  else 
	     go to 301
	  end if
	ELSE IF (IAN1.EQ.'l') THEN
	  XMIN=CX
	  YMIN=CY
 303	  CALL PGCURSE(CX,CY,IAN1)
	  IF (IAN1.EQ.'r') THEN
	    XMAX=CX
	    YMAX=CY
	  ELSE
	    GO TO 303
	  END IF
	  GO TO 888
	ELSE IF (IAN1.EQ.'c') THEN
	  TCY=CY
	  TCX=CX
	  if (device.ne.'/sun'.and.device.ne.'/xwin') then
	    DO 140 M=1,ICL
c    ! make blank lines for writing in Alpha mode
 140	      WRITE(6,141)      
 141	FORMAT(1X)
	    ICL=ICL+1
	  end if
	  WRITE(6,142) TCY,TCX,iit,jjt,IX(iit,jjt,NFR)
	  IAN1='1'
 142	FORMAT(1X,2F8.2,3X,2I5,I6)
c measuring distance between 2 points
	else if (ian1.eq.'d') then
	  tcx=cx
	  tcy=cy
 	  CALL PGCURSE(CX,CY,IAN1)
	  dis=sqrt((tcx-cx)**2+(tcy-cy)**2)
	  write(6,45) cx,cy,tcx,tcy,dis
 45	format('  distance: (',f7.2,',',f7.2,') - (',f7.2,',',
     *      f7.2,') ==',f8.3)
	  go to 800
c 'n' or 'N' for plotting object file
	else if (ian1.eq.'n'.or.ian1.eq.'N') then
C plot object file
	  IF (NFR.GT.6) THEN
	    WRITE(6,*) ' *** OBJECT FILE NUMBER MUST BE <=6 ****'
	    go to 800
	  END IF
	  call pgsci(7)
	  UP=ABS(YMIN-YMAX)*.019
	  DO 105 I=1,NOB(NFR)
	    XB=tr(5)*(iend-ijoi(i,nfr))+tr(4)
	    YB=tr(3)*(jend-ijoj(i,nfr))+tr(1)
	    CALL PGPOINT(1,YB,XB,10)
	    if (ian1.eq.'N') then 
	      istat=encode(obnum,float(i),1,0,idum)
	      CALL PGTEXT(YB,XB-UP,obnum)
	    end if
 105	  CONTINUE
	  call pgsci(ici)
c 'm' for plotting object file from another frame
	else if (ian1.eq.'m'.or.ian1.eq.'M') then
	  if (device.ne.'/sun'.and.device.ne.'/xwin') then
	    DO 1401 M=1,ICL
 1401	      WRITE(6,141)      
	    ICL=ICL+1
	  end if
 606	  write(6,20) 
 20	format(' Enter posf number: ',$)
	  call read1i(ipf,*800,*606)
	  if (ipf.gt.6.or.ipf.lt.1) go to 606
	  UP=ABS(ymin-ymax)*.018
	  call pgsci(5)
	  DO 106 I=1,NOB(ipf)
	    XB=tr(5)*(iend-ijoi(i,ipf))+tr(4)
	    YB=tr(3)*(jend-ijoj(i,ipf))+tr(1)
	    CALL PGPOINT(1,YB,XB,7)
	    if (ian1.eq.'M') then
	      istat=encode(obnum,float(i),1,0,idum)
	      CALL PGTEXT(YB,XB+UP,obnum)
	    end if
 106	  CONTINUE
	  call pgsci(ici)
c 'a' for adding an object to the position file
	else if (ian1.eq.'a') then
	  IF (NFR.GT.6) THEN
	    WRITE(6,*) ' FRAME #>=6, NO POSITION FILE'
	    GO TO 800
	  END IF
C  check for neighboring pixels for largest value
	  II=IIT
	  JJ=JJT
	  if (device.ne.'/sun'.and.device.ne.'/xwin') then
	    DO 1402 M=1,ICL
 1402	      WRITE(6,141)      
	    ICL=ICL+1
	  end if
	  WRITE(6,142) cy,cx,ii,jj,ix(ii,jj,nfr) 
 70	format(1x,2F7.1,3x,i6)
	  DO 190 M=MAX0(1,IJT-1),MIN0(NJJ(NFR),IJT+1)
	    DO 190 L=MAX0(1,IIT-1),MIN0(NII(NFR),IIT+1)
	      IF (IX(L,M,NFR).GT.IX(II,JJ,NFR)) THEN
	        II=L
	        JJ=M
 	      END IF
 190	  CONTINUE
	  CALL ADDOBJ(II,JJ,INN,NFR)
	  call pgsci(1)
	    XB=tr(5)*(iend-ii)+tr(4)
	    YB=tr(3)*(jend-jj)+tr(1)
	write(6,*) xb,yb
	  CALL PGPOINT(1,yb,xb,8)
	  call rbell(1)
	  call pgsci(ici)
c
c 'x' for deleting an object from the position file
	else if (ian1.eq.'x') then
	  if (device.ne.'/sun'.and.device.ne.'/xwin') then
	    DO 1403 M=1,ICL
 1403	      WRITE(6,141)      
	    ICL=ICL+1
	  end if
	  WRITE(6,71) cy,cx
 71	format(1x,2F7.1)
	  CALL ZAPOBJ(NFR,IIT,JJT,II,JJ,IDEL)
	  IF (IDEL.EQ.1) THEN
	    call pgsch(2.)
	    call pgsci(4)
	    XB=tr(5)*(iend-ii)+tr(4)
	    YB=tr(3)*(jend-jj)+tr(1)
	    call pgpoint(1,yb,xb,5)
	    call pgsci(ici)
	    call pgsch(1.)
	    call rbell(1)
	  END IF
c 'w' for computing FWHM
	else if (ian1.eq.'w') then
	  write(6,*) ' -- estimated FWHM for ',iit,jjt
	  idumnfr(2)=iit
	  idumnfr(3)=jjt
	  idumnfr(4)=21
	  idumnfr(5)=55
	  call apdri(*800,idumnfr,dumstr1,dumstr2,3,ix,nu,nv,kf)
c 't' for type out a region of 10X10 around cursor
	else if (ian1.eq.'t') then
	  idumnfr(2)=iit
	  idumnfr(3)=jjt
	  idumnfr(4)=11
	  idumnfr(5)=11
	  if(device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	  call printz(*800,idumnfr,dumstr1,0,ix,nu,nv,kf)
c '+' for computing centroid
	else if (ian1.eq.'+') then
	  write(6,*) '  -- iterative centroid from ',iit,jjt
	  idumnfr(2)=iit
	  idumnfr(3)=jjt
	  idumnfr(4)=5
	  idumnfr(5)=49
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	  call dpcent(*800,idumnfr,ix,nu,nv,kf,0)
c '*' for aperture photometry
	else if (ian1.eq.'*') then
	  write(6,*) ' -- aperture photometry around ',iit,jjt
	  idumnfr(2)=iit
	  idumnfr(3)=jjt
	  idumnfr(4)=0
	  idumnfr(5)=0
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	  call phodri(*800,idumnfr,dumstr1,dumstr2,1,ix,nu,nv,kf)
	ELSE IF (IAN1.EQ.'1') THEN
	  GO TO 800
	END IF
	GO TO 800
C
 999	RETURN1
	END
C/////////////////////////////////////////
C
C Subroutine to input labels
C
	SUBROUTINE PLABELS(XMIN,XMAX,YMIN,YMAX,IA,IB,tr,iend,jend,itrans,
     *          ilabel,*)
	CHARACTER TEXTFILE*20,TEXT(100)*30
	DIMENSION XTEXT(100),YTEXT(100),ANG(100),FJUST(100),tr(6)
 610	  WRITE (6,59)
 59	FORMAT('  Labelling: enter filename or t for terminal input: ',$)
	  READ(5,1,ERR=610,END=999) TEXTFILE
 1	FORMAT(A20)
	  IF (TEXTFILE.EQ.'t') THEN
	    IF (WLD.LT..99) WLD=1.
	    IF (CSIZ.LE..1) CSIZ=1.
 617	    WRITE(6,60) WLD,CSIZ
 60	FORMAT('  Enter label plot thickness and char. siz:'
     *        ,'(dflt:',F4.0,F6.2,'): ',$)
	    CALL READ2R(WLD,CSIZ,*999,*617)
	    IWLD=NINT(WLD)
	    DO 340 I=1,100
 611	      WRITE(6,61) XTEXT(I),YTEXT(I)
	      CALL READ2R(XTEXT(I),YTEXT(I),*999,*611)
 612	      WRITE(6,62) ANG(I),FJUST(I)
	      CALL READ2R(ANG(I),FJUST(I),*999,*612)
 61	FORMAT('   Enter unscaled co-ordinates (horiz, vert) '
     *         ,'(dflt:',2F6.1,'):',$)
 62	FORMAT('   Enter angle(horiz=0) and Fjust(0.0-1.0)'
     *         ,' (dflt:',F6.1,F4.2,'): ',$)
 613	      WRITE(6,63)
 63	FORMAT('   Enter text string (30 chars. max., end to end): ',$)
	      CALL readstr(30,text(i),*999,*613)
	      IF (TEXT(I).EQ.'end') GO TO 341
 340	    CONTINUE
	  ELSE
C read text intruction from file
	    OPEN(UNIT=26,FILE=TEXTFILE,STATUS='OLD',ERR=610)
	    READ(26,*,ERR=6151,END=6151) IWLD,CSIZ
	    DO 342 I=1,100
 6101	      READ(26,*,ERR=6151,END=343) XTEXT(I),YTEXT(I),
     *	                ANG(I),FJUST(I)
 	      READ(26,64,ERR=6101,END=343) TEXT(I)
	      if (text(i).eq.'end') go to 343
 64	format(a20)
 342	    CONTINUE
 343	    CLOSE(UNIT=26)
	    GO TO 341
 6151	    WRITE(6,*) '  ***ERROR in input file *** ',I
	    close(unit=26)
	    GO TO 610
	  END IF
 341	  NTEXT=I-1	
	  WRITE(6,*) NTEXT,' strings will be labelled..'
C   special section for adding numbers
	  IF (IWLD.LE.0) IWLD=1
	  IF (CSIZ.LE.0.1) CSIZ=1.
	  CALL pgslw(IWLD)
	  CALL PGSCH(CSIZ)        
	  CALL PGENV(XMIN,XMAX,YMIN,YMAX,IA,IB)
	  DO 344 I=1,NTEXT
	    if (itrans.ne.0) then
	      ytem=tr(5)*(float(iend)-ytext(i))+tr(4)   
	      xtem=tr(3)*(float(jend)-xtext(i))+tr(1)   
	    else
	      xtem=xtext(i)
	      ytem=ytext(i)
	    end if
	write(6,*) xtext(i),xtem,ytext(i),ytem
c	    if (xtem.lt.xmin.or.xtem.gt.xmax) go to 344
c	    if (ytem.lt.ymin.or.ytem.gt.ymax) go to 344
 	    CALL PGPTEXT(XTEM,YTEM,ANG(I),FJUST(I),TEXT(I))
 344	  continue
c  plot scale and NE direction
	  if (ilabel.eq.2) call drawscale(*999,itran,iend,jend,tr,
     *               ilabel)
	  CALL pgslw(1)
	  CALL PGSCH(1.)        
	  RETURN
 999	RETURN1
	END
c//////////////////////////////////////////////////////////////////
c      subroutine to draw directional axis and scale on image
c
	subroutine drawscale(*,itran,iend,jend,tr,ilabel)
	dimension x(2),y(2),tr(6)
 600	write(6,1) angle
 1	format('  Enter angle of rotation for direction bar [',
     *     f6.2,']: ',$)
	call read1r(angle,*999,*600)
	if (ilabel.eq.3) then
	  if (h0.lt.0.001) h0=50.
	  if (abs(q0).lt.0.0001) q0=0.
 6001	  write(6,11) h0,q0
 11	format('  Enter Hubble constant and q_0 [',f4.0,f5.1,']: ',$)
	  call read2r(h0,q0,*999,*6001)
 6002	  write(6,12) z,sizekpc
	  call read2r(z,sizekpc,*999,*6002)
 12	format('  Enter z and size of bar in kpc [',f7.5,f6.2,']: ',$)
c compute length
	  size=sizekpc*h0*206265.*(1.+z)/
     *           (299792500.*COSTERM(q0,z))
	  write(6,13) sizekpc,z,size
 13	format('  angular size for',f6.2,' kpc at z=',f7.5,': ',f6.2,'"')
	else
 601	  write(6,2) size
	  call read1r(size,*999,*601)
 2	format('  Enter size of bar in the appropriate units [',
     *     f6.2,']: ',$)
	end if
 602	write(6,3) x1,y1
	call read2r(x1,y1,*999,*602)
 3	format('  Enter horizontal & vertical pos of bar origin ['
     *     ,2f7.2,']: ',$)
	if (itrans.ne.0) then
	  y(1)=tr(5)*(float(iend)-y1)+tr(4)   
	  x(1)=tr(3)*(float(jend)-x1)+tr(1)   
	else
	  x(1)=x1
	  y(1)=y1
	end if
	aa=size*sin(angle/57.2958)
	bb=size*cos(angle/57.2958)
	if (ilabel.eq.2) then
c  	define upper point of N axis
	  x(2)=x(1)-aa
	  y(2)=y(1)+bb
	  call pgline(2,x,y)
	  call pgptext(x(2),y(2),angle,1.2,'N')
c       define left point of E axis
	  x(2)=x(1)-bb
	  y(2)=y(1)-aa
	  call pgline(2,x,y)
	  call pgptext(x(2),y(2),angle,1.2,'E')
	else
c       define left point of E axis
	  x(2)=x(1)+bb
	  y(2)=y(1)-aa
	  call pgline(2,x,y)
c	  call pgptext(x(2),y(2),angle,1.2,'kpc')
	end if
	return
 999	return1
	end
	
C///////////////////////////////////////////////////////////////
C   SUBROUTINE TO PLOT CROSS SECTION CUTS
C         IPAR=0  X-CUT (CONSTANT I)
C         IPAR=1  Y-CUT (CONSTANT J)
C         IGRAPH=0 NON-GRAPHIC TERMINAL  (option of printronix plot)
C         IGRAPH=1 GRAPHIC TERMINAL  (PGPLOT)
	SUBROUTINE CSCUT(*,NFR,KA,KB,STR1,STR2,IPAR,IGRAPH,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER ANS*1,STR1*60,STR2*60,DEVICE*60
	DIMENSION X(5000),P(5000)
	INCLUDE 'pppcore.inc'
	character*18 HPLOT,SPLOT
	common/PLOTDEV/HPLOT,SPLOT,ipinit
	INCLUDE 'picdir.inc'
	EQUIVALENCE (X(1),iscr(1)),(P(1),iscr(100001))
	CALL QUERYNFR(NFR,KF,0,*900,*20001)
20001	IF (IGRAPH.EQ.1) WRITE(6,40)
 40	FORMAT('  ...Cross-sectional plot:'/'   [enter command m'
     *  ,' (while in graphic mode) for cursor command menu]')
	IF (KA.EQ.0.AND.KB.EQ.0) THEN
 600	  IF (IPAR.EQ.1) THEN
	    WRITE(6,433) K1,K2
	  ELSE 
	    WRITE(6,432) K1,K2
	  END IF
 432	FORMAT('   Enter limits of rows to be averaged (deflt:',
     *             2I4,'): ',$)
 433	FORMAT('   Enter limits of columns to be averaged (deflt:',
     *            2I4,'): ',$)
	  CALL READ2I(K1,K2,*900,*600)
	  IF (K1.LE.0.AND.K2.LE.0) THEN
	    WRITE(6,*) ' **** ILLEGAL ENTRY **** try again'
	    GO TO 600
	  END IF
	ELSE 
	  K1=KA
	  K2=KB
	END IF
	IF (K2.EQ.0) K2=K1
	IF (K1.EQ.0) K1=K2
	RMAX=0.
	RMIN=40000.
	KK=K2-K1+1
c !  Constant I or I's (columns)
        IF (IPAR.EQ.1)  THEN  
	  NN=NJJ(NFR)
	  DO 101 J=1,NN
	    X(J)=0.
	    P(J)=J
	    DO 110 I=K1,K2
 110 	      X(J)=X(J)+IX(I,J,NFR)
c  ! averaging KK columns
 	    X(J)=X(J)/FLOAT(KK)   
	    IF (X(J).GT.RMAX) RMAX=X(J)
	    IF (X(J).LT.RMIN) RMIN=X(J)
 101	  CONTINUE
c  !   Constant J  or J's (rows)
	ELSE          
 	  NN=NII(NFR)
	  DO 103 I=1,NN
	    X(I)=0.
	    P(I)=I
	    DO 113 J=K1,K2
 113	      X(I)=X(I)+IX(I,J,NFR)
 	    X(I)=X(I)/FLOAT(KK)
 	    IF (X(I).GT.RMAX) RMAX=X(I)
 103	    IF (X(I).LT.RMIN) RMIN=X(I)
	END IF
c  ! non graph-plot
	IF (IGRAPH.EQ.0) THEN 
	  WRITE(6,*) '  MAX SIZE =',NN
 102	  WRITE(6,*) '  ENTER LEFT AND RIGHT LIMITS, 0 0 TO STOP'
	  call read2i(il,ir,*900,*102)
	  IF (IL.EQ.0.AND.IR.EQ.0) GO TO 199
	  NK=IR-IL+1
c	  CALL PLOT_NOGRAPHICS(X(IL),NK,IL)
	  GO TO 102
 199      WRITE(6,*) ' DO you want PLXY printer plot? y/n'
	  call readstr(1,ans,*900,*199)
c 10	  FORMAT(A1)
	  IF (ANS.NE.'y') RETURN1
c	  CALL PLOTCUT(NN,X)
c  ! pgplot
	ELSE 
C  check device
C first check if STR1 is a number, if so, it is an err -- request device name
	  READ(STR1,300,ERR=301) DUM
 300	FORMAT(F10.1)
	  IF (STR1.EQ.' '.OR.STR2.EQ.' ') THEN
	    DEVICE=splot 
	  ELSE
	    DEVICE=STR2
	  END IF
	  GO TO 302
C    device name is a string
 301	  DEVICE=STR1
 302	  CALL GRAPHCUT(DEVICE,ipinit,K1,K2,RMIN,RMAX,MAX0(1,NN),X,
     *             P,IPAR)
	END IF
 900	RETURN1
	END
C///////////////////////////////////////////////////////////////
C   Subroutine to plot Nod & shuffle spectrum
c          always plot as a function of x (horizontal spectrum)
	SUBROUTINE nodshuf(*,NFR,IX,NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER DEVICE*60
	DIMENSION X(5000),P(5000)
	INCLUDE 'pppcore.inc'
	character*18 HPLOT,SPLOT
	common/PLOTDEV/HPLOT,SPLOT,ipinit
	INCLUDE 'picdir.inc'
	EQUIVALENCE (X(1),iscr(1)),(P(1),iscr(100001))
	CALL QUERYNFR(NFR,KF,0,*900,*600)
 600	WRITE(6,432) k1,k2
	CALL READ2I(K1,K2,*900,*600)
 432	FORMAT('   Enter limits in y for negative spectrum [',2i5,
     *             ']: ',$)
	IF (K1.LE.0.or.K2.LE.0) THEN
	  WRITE(6,*) ' **** ILLEGAL ENTRY **** try again'
	  GO TO 600
	END IF
 601	WRITE(6,433) ka,kb
	CALL READ2I(ka,kb,*900,*601)
 433	FORMAT('   Enter limits in y for positive spectrum [',2i5,
     *             ']: ',$)
	IF (ka.LE.0.or.kb.LE.0) THEN
	  WRITE(6,*) ' **** ILLEGAL ENTRY **** try again'
	  GO TO 601
	END IF
	RMAX=-100000.
	RMIN=100000.
	KK=K2-K1+1
	kab=kb-ka+1
c  !   Constant J  or J's (rows)
 	NN=NII(NFR)
	DO 101 I=1,NN
	  X(I)=0.
	  P(I)=I
	  DO 102 J=K1,K2
 	    X(I)=X(I)-IX(I,J,NFR)
 102	  continue
	  DO 103 J=ka,kb
 	    X(I)=X(I)+IX(I,J,NFR)
 103	  continue
 	  X(I)=X(I)/FLOAT(KK+kab)
 	  IF (X(I).GT.RMAX) RMAX=X(I)
 	  IF (X(I).LT.RMIN) RMIN=X(I)
 101	continue
c  ! pgplot
C  check device
	DEVICE=splot 
 302	CALL GRAPHCUT(DEVICE,ipinit,K1,k2,RMIN,RMAX,MAX0(1,NN),X,
     *             P,0)
 900	RETURN1
	END

C///////////////////////////////////////////////////////////////////////
C
C  PG plot of a cut: IPAR=0,1,2
C
	SUBROUTINE GRAPHCUT(DEVICE,ipinit,K1,K2,RMIN1,RMAX1,NN,X,P,IPAR)
	  DIMENSION X(NN),P(NN),XT(1100)
	  CHARACTER DEVICE*60,TOP*22,NUM1*4,NUM2*4
	  include 'pppcore.inc'
	  equivalence (iscr(1),xt(1))
	  call openpg(device,ipinit,*999)
	  RMIN=INT(RMIN1/100.)*100.
	  RMAX=(INT(RMAX1/100.)+1)*100.
	  RMINT=RMIN
	  RMAXT=RMAX
	  RL=1.
	  RR=NN
 790	  CALL PGENV(RL,RR,RMINT,RMAXT,0,0)
	  CALL NTOCHA4(K1,NUM1)
	  CALL NTOCHA4(K2,NUM2)
	  IF (IPAR.EQ.1) THEN
	    TOP='Column(s) '//NUM1//' to '//NUM2
	  ELSE IF (IPAR.EQ.0) THEN
	    TOP='Row(s) '//NUM1//' to '//NUM2
	  ELSE IF (IPAR.EQ.2) THEN
	    TOP='cut from pt. '//NUM1//' '//NUM2
	  END IF
	  CALL PGLABEL(' pixel','ADU',TOP)
	  CALL PGLINE(NN,P,X)
 799	  if (device.eq.'/tek') call sleep(1) 
	  CALL ITACURB(RL,RR,RMINT,RMAXT,CX,CY,p,x,nn,
     *          DEVICE,ipinit,IRET)
	  IF (IRET.EQ.1.OR.IRET.EQ.2) THEN
	    GO TO 790
	  ELSE IF (IRET.EQ.-1) THEN
	    WRITE(6,*) CX,CY
	    GO TO 799
	  ELSE IF (IRET.EQ.0) THEN
	    if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *         call closepg(ipinit)
	    RETURN
	  ELSE IF (IRET.EQ.3) THEN
	    GO TO 790
	  ELSE IF (IRET.EQ.4) THEN
	    RMINT=RMIN
	    RMAXT=RMAX
	    RL=1.
	    RR=NN
	  ELSE IF (IRET.EQ.10) THEN
C compute average and sum between XMAX and XMIN
	    IF (CX.GT.CY) THEN
	      IMAX=NINT(CX)
	      IMIN=NINT(CY)
	    ELSE
	      IMAX=NINT(CY)
	      IMIN=NINT(CX)
	    END IF
	    I1=0
	    DO 120 I=IMIN,IMAX
	      I1=I1+1
 120	      XT(I1)=X(I)
	    NPA=IMAX-IMIN+1
	    CALL AVSIGR(XT,AVE,SIG,RMAXX,RMINN,NPA)
	    NTOT=(K2-K1+1)*NPA
	    IF (IPAR.EQ.1) THEN
	      WRITE(6,20) K1,K2,IMIN,IMAX,NTOT,AVE,SIG,NTOT*AVE
	    ELSE IF (IPAR.EQ.0) THEN
	      WRITE(6,21) K1,K2,IMIN,IMAX,NTOT,AVE,SIG,NTOT*AVE
	    ELSE IF (IPAR.EQ.2) THEN
	      WRITE(6,22) IMIN,IMAX,NTOT,AVE,SIG,NTOT*AVE
	    END IF
 20	FORMAT('  ...Columns:',I5,' to',I5,', pix',I5,' to',I5,'.  Tota'
     *   ,'l no. of pixels:',I10,/,3X,'AVERAGE:',F11.3,3X,'SIGMA:',F8.3,
     *   '      SUM:',F13.2)
 21	FORMAT('  ...Rows:',I5,' to',I5,', pix',I5,' to',I5,'.  Total '
     *    ,'no. of pixels:',I10,/,3X,'AVERAGE:',F11.3,3X,'SIGMA:',F8.3,
     *   '      SUM:',F13.2)
 22	FORMAT('  ..., pixels',I5,' to',I5,'.  Tota'
     *   ,'l no. of pixels:',I10,/,3X,'AVERAGE:',F11.3,3X,'SIGMA:',F8.3,
     *   '      SUM:',F13.2)
	    GO TO 799
	  END IF
c	CALL PGEND
 999	RETURN
	END
C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO PLOT INTERPOLATED CUT BETWEEN TWO POINTS
C    IPAR=0 PLOT
C    IPAR=1 FIT LINE 
C
	SUBROUTINE P2PTCUT(*,NFRA,IX,NU,NV,KF,IPAR)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	DIMENSION NFRA(5),XLINE(1000),P(1000)
	CHARACTER DEVICE*60
	INCLUDE 'pppcore.inc'
	character*18 HPLOT,SPLOT
	common/PLOTDEV/HPLOT,SPLOT,ipinit
	INCLUDE 'picdir.inc'
	EQUIVALENCE (XLINE(1),iscr(1)),(P(1),iscr(10001))
	NFR=NFRA(1)
	CALL QUERYNFR(NFR,KF,0,*999,*101)
 101	IF (NFRA(2).LE.0.OR.NFRA(3).LE.0) THEN
 600	  WRITE(6,10) IX1,IY1
	  CALL READ2I(IX1,IY1,*999,*600)
 10	FORMAT('  Enter 1st point (2 int., default:',2I4,'):',$)
	ELSE
	  IX1=NFRA(2)
	  IY1=NFRA(3)
	END IF
	IF (NFRA(4).LE.0.OR.NFRA(5).LE.0) THEN
 601	  WRITE(6,11) IX2,IY2
	  CALL READ2I(IX2,IY2,*999,*601)
 11	FORMAT('  Enter 2nd point (2 int., default:',2I4,'):',$)
	ELSE
	  IX2=NFRA(4)
	  IY2=NFRA(5)
	END IF
	IF ((IX2-IX1)*(IX2-IX1)+(IY2-IY1)*(IY2-IY1).GT.1000000) THEN
	  WRITE(6,*) ' ++++ DISTANCE BETWEEN POINTS > 1000, TRY AGAIN '
	  NFRA(2)=0
	  NFRA(4)=0
	  GO TO 101
	END IF
	CALL MKLINE(IX1,IY1,IX2,IY2,NPT,1000,XLINE,NII(NFR),NJJ(NFR),
     *               IX(1,1,NFR),NU,NV)
	RMAX=XLINE(1)
	RMIN=XLINE(1)
	DO 110 I=1,NPT
	  P(I)=I
	  IF (XLINE(I).GT.RMAX) RMAX=XLINE(I)
	  IF (XLINE(I).LE.RMIN) RMIN=XLINE(I)
 110	CONTINUE
	DEVICE=splot
	CALL GRAPHCUT(DEVICE,ipinit,IX1,IY1,RMIN,RMAX,MAX0(1,NPT),
     *     XLINE,P,2)
 999	RETURN1
	END	
C///////////////////////////////////////////////////////////////////////
C
C  PGPLOT SUBROUTINE FOR PLOTTING CLASSIFIERS 
C                                     C2 (SHAPE DIFF VS MAG)	
c  modified jan 12 97: objs with s/n<5 are plotted only as pts
c           May  6 97: class 4 objects are underlined with arrows
c  modified Jun  4 99: if there are more than 3000 objs, objects
c                      with s/n<10 and C2< 0.1 are plotted only as pts
C
	SUBROUTINE PGLTC2(TMAG,SUMDEL,ERR,NOB,IREF,NREF,CLSC,
     *            icl,FILOUTT,DEV,nsec)
	DIMENSION TMAG(*),SUMDEL(*),ERR(*),CLSC(3),XX(25),YY(25)
	INTEGER IREF(*) 
c	integer*2 icl(*)
	integer icl(*)
c   ** need to deal with short name (only 14 character + .phm)
	CHARACTER FILOUT*18,NUM*4,DEV*18,DEVICE*28,TITLE*18,NUM1*4
     *      ,DUM*18,FILOUTT*28,hplot*18,splot*18,secstr*1
	common/plotdev/hplot,splot,ipinit
	ipgdate=1
	DUM=' '
	IF (DEV.EQ.' ') DEV=splot 
	RL=-16
	RR=-4
	RMINT=-1.2
	RMAXT=.5
	DO 125 K=1,25
 125	  XX(K)=-16.+.45*K
c !  create plotfile
 770	IF (DEV.eq.'/tek'.or.dev.eq.'/sun'.or.dev.eq.'/xwin') THEN  
	  DEVICE=DEV
	ELSE
	  IF (FILOUTT.EQ.'n'.OR.FILOUTT.EQ.' ') THEN
 600	    WRITE(6,11)
 11	FORMAT('  Plot file will be named _____.pc2 ;')
	   CALL READFN(TITLE,DUM,FILOUT,'pc2','o',12,*999,*600,*20001)
c ! use PHM file name
	  ELSE 
 	    DO 140 I=1,18
 	      IF (FILOUTT(I:I).EQ.'.') GO TO 141
  140	    CONTINUE
c   +++ currently name of pc2 file limited to 14 characters
 141	    FILOUT=FILOUTT(1:MIN0(14,I-1))//'.pc2'
	write(6,*) ' +++ pc2 output name ', filout,' ',filoutt
	    if (nsec.gt.0) then
	      istatus=encode(secstr,float(nsec),1,0,idum)
	      filout=filout(1:lnblnk(filout))//'.'//secstr
	    end if
	    WRITE(6,31) FILOUT
 31	FORMAT('  Plot file is named ',A18,' ...')
	  END IF
20001	  DEVICE=FILOUT(1:lnblnk(filout))//DEV
	END IF
	call openpg2(device,ipinit,*999)
 790	CALL PGSCH(1.)
  	CALL PGENV(RL,RR,RMINT,RMAXT,0,0)
	CALL PGLABEL('Instrumental Mag','C2',FILOUTT)
C
C PLOT C2 VS MAG
C
	if (dev.eq.'/sun'.or.dev.eq.'/xwin') then
	  CALL PGSCH(.72)
	  call pgsci(3)
	else
	  call pgsch(.5)
	end if
	SHIF=0.013*(RMAXT-RMINT)/1.7
	if (nob.le.3000) then
	  snthres=5.
	else if (nob.lt.5000) then
	  snthres=10.
	else 
	  snthres=12.5
	end if
	DO 202 I=1,NOB
	  IF (ERR(I).gt.snthres) then
c objects with s/n>5
	    CALL NTOCHA4(I,NUM)
	    DO 100 J=1,3
	      IF (NUM(J:J).NE.'0') GO TO 101
 100	    CONTINUE
 101	    NUM1=NUM(J:4)
	    CALL PGPTEXT(TMAG(I),SUMDEL(I)-SHIF,0.,.5,NUM1)
c  check if class 4
	    if (icl(i).eq.4) then
	      CALL PGPOINT(1,TMAG(I),SUMDEL(I)-.02,28)
c  plot marker for class 2 objects classified as star
	    else if (icl(i).eq.3) then
	      if (sumdel(i).lt.clsc(2)) 
     *	        CALL PGPOINT(1,TMAG(I)-.03,SUMDEL(I)-.02,5)
	    end if
	  else
	    CALL PGPOINT (1,TMAG(I),SUMDEL(I),20)
	  end if
 202	CONTINUE
	DO 115 K=1,NREF
 115	  CALL PGPOINT(1,TMAG(IREF(K)),SUMDEL(IREF(K))-.04,30)
	DO 120 K=1,25
 120	  YY(K)=CLSC(2)
	CALL PGPOINT(25,XX,YY,1)
	DO 121 K=1,25
 121	  YY(K)=CLSC(3)
	CALL PGPOINT(25,XX,YY,1)
	XX(1)=-16.
	XX(2)=-15.
	YY(1)=CLSC(1)
	YY(2)=CLSC(1)
	CALL PGLINE(2,XX,YY)
	if (ipgdate.eq.1) call pgiden
 799	  CALL ITACUR(RL,RR,RMINT,RMAXT,CX,CY,DEVICE,ipinit,IRET)
	  IF (IRET.EQ.1) THEN
	    GO TO 790
	  ELSE IF (IRET.EQ.2) THEN
	    if (device.ne.'/sun'.and.device.ne.'/xwin')
     *         call closepg(ipinit)
	    GO TO 770
	  ELSE IF (IRET.EQ.-1) THEN
	    WRITE(6,*) CX,CY
	    GO TO 799
	  ELSE IF (IRET.EQ.0) THEN
	    if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *        call closepg(ipinit)
	    RETURN
	  ELSE IF (IRET.EQ.3.OR.IRET.EQ.4) THEN
	    GO TO 790
	  ELSE IF (IRET.EQ.10) THEN
	    GO TO 790
	  END IF
 999	  RETURN
	  END 
C///////////////////////////////////////////////////////////////////////
C
C  PGPLOT SUBROUTINE FOR interactive CLASSIFIER plot
C                                     C2 (SHAPE DIFF VS MAG)	
c  modified Jun  4 99: if there are more than 3000 objs, objects
c                      with s/n<10 and C2< 0.1 are plotted only as pts
c  modified Sep 17 99: interactive additional allow hdrfix 
C
	subroutine pc2plot(nfr,TMAG,SUMDEL,ERR,IREF,NREF,CLSC,
     *     icl,FILOUTT,nsec,nfix,ichn,newcl,newap,ix,nu,nv,kf)
	DIMENSION TMAG(1),SUMDEL(1),ERR(1),CLSC(3),XX(25),YY(25)
	INTEGER IREF(*) 
c	integer*2 icl(1),ichn(1),newcl(1),newap(1),ix(nu,nv,kf)
	integer icl(*),ichn(*),newcl(*),newap(*),ix(nu,nv,kf)
	CHARACTER FILOUT*18,DEV*18,DEVICE*18,TITLE*18,ch*1
     *      ,DUM*18,FILOUTT*18,hplot*18,splot*18,secstr*1
	common/plotdev/hplot,splot,ipinit
	include 'objcat.inc'
	ipgdate=1
	DUM=' '
	DEV=splot 
c plot limits
	RL=-16
	RR=-4
	RMINT=-1.2
	RMAXT=.5
	nfix=0
	DO 125 K=1,25
 125	  XX(K)=-16.+.45*K
c !  create plotfile
c   interactive
 770	IF (DEV.eq.'/tek'.or.dev.eq.'/sun'.or.dev.eq.'/xwin') THEN  
	  DEVICE=DEV
	ELSE
c out put plot file
	  IF (FILOUTT.EQ.'n'.OR.FILOUTT.EQ.' ') THEN
 600	    WRITE(6,11)
 11	FORMAT('  Plot file will be named _____.pc2 ;')
	    CALL READFN(TITLE,DUM,FILOUT,'pc2','o',12,*999,*600,*2001)
c ! use PHM file name
	  ELSE 
	    DO 140 I=1,18
	      IF (FILOUTT(I:I).EQ.'.') GO TO 141
 140	    CONTINUE
 141	    FILOUT=FILOUTT(1:MIN0(10,I-1))//'.pc2'
	    if (nsec.gt.0) then
	      istatus=encode(secstr,float(nsec),1,0,idum)
	      filout=filout(1:lnblnk(filout))//'.'//secstr
	    end if
	    WRITE(6,31) FILOUT
 31	FORMAT('  Plot file is named ',A18,' ...')
	  END IF
 2001	  DEVICE=FILOUT(1:lnblnk(filout))//DEV
	END IF
c plot
	call openpg(device,ipinit,*999)
 790	CALL PGSCH(1.)
  	CALL PGENV(RL,RR,RMINT,RMAXT,0,0)
	CALL PGLABEL('Instrumental Mag','C2',FILOUTT)
C
C PLOT C2 VS MAG
C
	if (dev.eq.'/sun'.or.dev.eq.'/xwin') then
	  CALL PGSCH(.85)
	  call pgsci(3)
	else
	  call pgsch(.65)
	end if
	SHIF=0.013*(RMAXT-RMINT)/1.7
	if (nob(nfr).le.3000) then
	  snthres=5.
	else if (nob(nfr).lt.5000) then
	  snthres=10.
	else 
	  snthres=12.5
	end if
	DO 202 I=1,NOB(nfr)
	  IF (ERR(I).gt.snthres) then
c objects with s/n>5, determine what symbol to use
	    if (icl(i).eq.4) then
c solid star for saturated stars (light blue)
	      call pgsci(5)
	      CALL PGPOINT(1,TMAG(I),SUMDEL(I),18)
	    else if (icl(i).eq.3) then
c star for stars
	      call pgsci(3)
	      CALL PGPOINT(1,TMAG(I),SUMDEL(I),12)
	    else if (icl(i).eq.0) then
c triangle for CR
	      call pgsci(3)
	      CALL PGPOINT(1,TMAG(I),SUMDEL(I),7)
	    else 
c circle for galaxies (both 1 and 2)
	      call pgsci(3)
	      CALL PGPOINT(1,TMAG(I),SUMDEL(I),22)
	    end if
	  else
c faint objects
	    call pgsci(3)
	    CALL PGPOINT (1,TMAG(I),SUMDEL(I),20)
	  end if
 202	CONTINUE
c over plot reference stars with square (yellow)
	call pgsci(7)
	call pgsch(1.0)
	DO 115 K=1,NREF
 115	  CALL PGPOINT(1,TMAG(IREF(K)),SUMDEL(IREF(K)),10)
c over plot objects with modified classification, color change to red
	call pgsci(2)
	do 116,k=1,nfix
	  if (newcl(k).eq.3) then
	    ipo=12
	  else if (newcl(k).eq.4) then
	    ipo=18
	  else if (newcl(k).eq.0) then
	    ipo=7
	  else 
	    ipo=22
	  end if
	  CALL PGPOINT (1,TMAG(ichn(k)),SUMDEL(ichn(k)),ipo)
 116	continue
c plot classifier lines change color first
	call pgsci(7)
	call pgsch(.75)
	DO 120 K=1,25
 120	  YY(K)=CLSC(2)
	CALL PGPOINT(25,XX,YY,1)
	DO 121 K=1,25
 121	  YY(K)=CLSC(3)
	CALL PGPOINT(25,XX,YY,1)
	XX(1)=-16.
	XX(2)=-15.
	YY(1)=CLSC(1)
	YY(2)=CLSC(1)
	CALL PGLINE(2,XX,YY)
	if (ipgdate.eq.1) call pgiden
 799	  CALL ITACUR(RL,RR,RMINT,RMAXT,CX,CY,DEVICE,ipinit,IRET)
	  IF (IRET.EQ.1) THEN
	    GO TO 790
	  ELSE IF (IRET.EQ.2) THEN
	    if (device.ne.'/sun'.and.device.ne.'/xwin')
     *         call closepg(ipinit)
	    GO TO 770
	  ELSE IF (IRET.EQ.-1) THEN
	    WRITE(6,*) CX,CY
	    GO TO 799
	  ELSE IF (IRET.EQ.0) THEN
	    if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *        call closepg(ipinit)
	    RETURN
	  ELSE IF (IRET.EQ.3) THEN
	    GO TO 790
	  else if (iret.eq.4) then
c plot with original limits
	    RL=-16
	    RR=-4
	    RMINT=-1.2
	    RMAXT=.5
	    go to 790
	  ELSE IF (IRET.EQ.10) THEN
	    GO TO 790
	  else if (iret.eq.7) then
c  interactive fixing
	    delx=.02
	    dely=0.01
 610	    write(6,1) 
 1	format('    .... classification editing commands ',
     *         '    t - show info on marked object.'/
     *         '    d - display saoimage of marked object.'/
     *       '    1,2,3,4,0 - change classification of marked obj.'/
     *         '    a - change aperture of marked object.'/
     *         '    R - return to general cursor command.'/
     *         '    w - exit pc2 plot and save hdr.fix.'/
     *         '    ? - display this help menu.')
 300	    call pgcurse(cx,cy,ch)
	    if (ch.eq.'R') then
	      write(6,*) ' ...returning to general cursor command menu'
	      goto 799
	    else if (ch.eq.'w') then
	      return
	    else if (ch.eq.'?') then
	      goto 610
	    else 
	      call fobjnum(cx,cy,nob(nfr),tmag,sumdel,
     *                      delx,dely,nmark,ifind)
	      if (ifind.eq.0) then
	        write(6,21) cx,cy
 21	format('   ++ no object found near:',2f9.1)
	        goto 300
	      else
	        write(6,22) nmark,cx,cy
 22	format(' ... obj#',i5, ' @rmag,c2 ',f8.2,f7.2)
	      end if
	      call pgsci(2)
	      call pgsch(1.5)
	      if (ch.eq.'t') then
	        write(6,20) ijoi(nmark,nfr),ijoj(nmark,nfr),icl(nmark)
 20	format('        @I,J:',2i6,'  cl:',i2)
	      else if (ch.eq.'d') then
	        write(6,20) ijoi(nmark,nfr),ijoj(nmark,nfr),icl(nmark)
	        call dispobj(*300,nfr,nmark,koldobj,ix,nu,nv,kf,0)
	      else if (ch.eq.'1') then
	        nfix=nfix+1
	        newcl(nfix)=1
	        newap(nfix)=-99
	        ichn(nfix)=nmark
	        CALL PGPOINT (1,TMAG(nmark),SUMDEL(nmark),24)
	      else if (ch.eq.'2') then
	        nfix=nfix+1
	        newcl(nfix)=2
	        newap(nfix)=-99
	        ichn(nfix)=nmark
	        CALL PGPOINT (1,TMAG(nmark),SUMDEL(nmark),24)
	      else if (ch.eq.'3') then
	        nfix=nfix+1
	        newcl(nfix)=4
	        newap(nfix)=-99
	        ichn(nfix)=nmark
	        CALL PGPOINT (1,TMAG(nmark),SUMDEL(nmark),18)
	      else if (ch.eq.'4') then
	        nfix=nfix+1
	        newcl(nfix)=4
	        newap(nfix)=-99
	        ichn(nfix)=nmark
	        CALL PGPOINT (1,TMAG(nmark),SUMDEL(nmark),12)
	      else if (ch.eq.'0') then
	        nfix=nfix+1
	        newcl(nfix)=0
	        newap(nfix)=-99
	        ichn(nfix)=nmark
	        CALL PGPOINT (1,TMAG(nmark),SUMDEL(nmark),7)
	      else if (ch.eq.'a') then
	        nfix=nfix+1
	        newcl(nfix)=icl(nmark)
 611	        write(6,13) idstem
 13	format('   Enter new IDS aperture number [',i3,'[: ',$)
	        call read1i(idstem,*999,*611)
	        newap(nfix)=idstem
	      end if
	    end if
	    call pgsch(1.)
	    goto 300
	  END IF
 999	  RETURN
	  END 
c///////////////////////////////////////////////////////
c  subroutine to locate object marked on a plot with
c      co-ordinate (cx,cy) from array xx yy, within delx dely.
c        matching area is a square, not an ellipse or circle
c      
c      return nmark=obj # of marked object
c             ifind=0 if none found, =1 if found
c
	subroutine fobjnum(cx,cy,npt,xx,yy,delx,dely,nmark,ifind)
	dimension xx(1),yy(1)
	do 100 i=1,npt
	  if (abs(cx-xx(i)).le.delx) then
	    if (abs(cy-yy(i)).le.dely) then
	      nmark=i
	      ifind=1
	      return
	    end if
	  end if
 100	continue
c no object found
	ifind=0
	imark=0
	return
	end
