C
c  subroutine to write fits format disk files to tape using Unix command dd
c
c    ipar=0:  write using ppp directory file number as input
c         1:  write using file name as input
C
	SUBROUTINE mwfits(*,FILSTR,ix,nu,nv,kf,ipar,tape)
c	INTEGER*2 NFF(300),ix(nu,nv),NFLAG,NID,NJD
	INTEGER NFF(300),ix(nu,nv),NFLAG,NID,NJD
	logical ex
	CHARACTER*60 FILSTR,cstring,temname*8
	CHARACTER*12 NFILEN*24,NFILDUM,filen,skipstr,tape*18
	CHARACTER*36 NCOM,filenf*18,logname*18
	character bname*10,string*60,version*3,fdate*24,oldlog*79
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254)
     *	            ,NID(254),NJD(254)
	NFILDUM=' '
	WRITE(6,*) ' MULTIPLE fits writer'
	write(6,1) tape
 1	format('  Default tape device (change via SET): ',a18)
	if (ipar.eq.0) then
	  CALL MFNUM(FILSTR,60,NFF,300,NFILE,1)
	  IF (NFILE.EQ.0) RETURN1
	else
 601	  write(6,*) ' enter first part of fits file name: '
	  call readstr(10,bname,*999,*601)
 600	  write(6,13) string
 13	format(' enter file numbers (mfo format, dflt:',a30,'): ')
	  call readstr(60,string,*999,*600)
	  call mfnum(string,60,nff,300,nfile,1)
	end if  
 602	write(6,9) iskip
 9	format('  How many files to skip? ',$)
	call read1i(iskip,*999,*602)
c  prepare tapelog file
 603	write(6,10) logname
 10	format('  Enter tape log file name (full name) [',a18,
     *    ']: ',$)
	call readstrd(18,logname,*999,*603)
 2	format(a18)
	open(unit=20,file=logname,status='old',err=105)
	ilog=1
	do 200 i=1,1000
 	  read(20,11,end=106) oldlog
	  if (oldlog(1:3).eq.' ') ilog=ilog+1
 200	continue
 11	format(a79)
	goto 106
 105	close(unit=20)
	ilog=1
	open(unit=20,file=logname,status='new',err=999)
 106	write(20,5) fdate()
 5	format(' fits files copied to tape, date: ',a24)	
c skip initial files
	if (iskip.ne.0) then
	  idum=encode(skipstr,float(iskip),1,0,idum)
	  cstring='mt -f '//tape(1:lnblnk(tape))//' fsf '//skipstr 
	  idum=system(cstring)
	end if
	temname='tempfits'
	DO 100 I=1,NFILE
	  nft=nff(i)
	  if (ipar.eq.1) then
	    call ntocha(nft,version)
	    filenf=bname(1:lnblnk(bname))//version//'.fits'
	  else
	    filenf=nfilen(nft)(1:lnblnk(nfilen(nft)))//'.fits'
	  end if
c check to see what type of file the ith one is
	  inquire(file=filenf,exist=ex)
	  if (ex.eqv..true.) then
	    cstring='dd if='//filenf//' of='//
     *          tape(1:lnblnk(tape))//' bs=2880'
	  else
c  read the .pic file and rewrite as fits and output
	    filen=filenf(1:lnblnk(filenf)-4) 
	    CALL rdkfits(*83,1,NFILEN(NFF(I))//NFILDUM,1,IX,NU,NV,KF,IR)
 83	    CALL wdkfits(*84,1,temname//NFILDUM,4,IX,NU,NV,KF,IR)
 84	    cstring='dd if='//temname//'.fits of='
     *                //tape(1:lnblnk(tape))//' bs=2880'
	  end if
	  idum=system(cstring)
c  get object name

	  write(6,3) ilog, name
	  write(20,4) ilog,name
	  ilog=ilog+1
 3	format('  fits file# ',i4,': ',a20,' copied to tape...')
 4	format(5x,'#',i4,2x,a20)
 100	CONTINUE
	close(unit=20)
 	WRITE(6,23) NFILE
 23	FORMAT(/,' ++++ Total ',I4,' fits files written to tape ++++')
 999	RETURN1
	END

