C
C             SUBROUTINE PACKAGE TO MANIPULATE POSITION FILES
C               CREATED BY OBJECT FINDING PROGRAM
C
C
	SUBROUTINE POSFIL(*,CSTR,LCOM,ITM2,ITS2,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*60 COMM,SC(3)
	CHARACTER*80 CSTR(LCOM)
	CHARACTER ATIME*24,mnd*4
	character*64 string1,string2,fstr301,fstr302
	INTEGER NFP(3),IB(30),IE(30)
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	include 'apert.inc'
 	WRITE(6,*) ' /// POSITION FILE MANIPULATOR, '
     *             , ' "ppp" to return to ppp ///'
 99	CALL fdate(ATIME)
	READ(ATIME(15:19),3) ITM1,ITS1
	IF (((ITM1-ITM2)*60+ITS1-ITS2).GE.IBELLTIME) CALL RBELL(IBELL)
 3	FORMAT(I2,1X,I2)
	WRITE(6,20) 
 20	FORMAT(1X,'posf> ',$)
	DO 120 I=1,3
	  SC(I)=' '
 120	  NFP(I)=0
	call readstr(60,comm,*999,*99)
	CALL fdate(ATIME)
	READ(ATIME(15:19),3) ITM2,ITS2
	CSTR(LCOM)='posf : '//COMM
	DO 121 I=1,LCOM-1
 121	  CSTR(I)=CSTR(I+1)
	IF (COMM(1:1).EQ.'%') THEN
	  istatus=system(comm(2:60))
c	  CALL LIB$SPAWN(COMM(2:60),,,,,'PPP')
	  GO TO 99
	END IF
	CALL FSTR(COMM,60,IB,IE,NS)
	IF (NS.EQ.0) GO TO 99
	ICL=MIN0(4,IE(1)-IB(1)+1)
	istatus=encode(string1,float(icl),1,0,idum)
	fstr301='(A'//string1(1:lnblnk(string1))//')'
 311	READ(COMM(IB(1):IB(1)+ICL-1),fstr301) MND
c 301	FORMAT(A<ICL>)
c 302	FORMAT(I<ICL>)
	DO 100 I=2,MIN0(4,NS)
	  ICL=IE(I)-IB(I)+1
	  istatus=encode(string1,float(icl),1,0,idum)
	  fstr301='(A'//string1(1:lnblnk(string1))//')'
	  istatus=encode(string2,float(icl),1,0,idum)
	  fstr302='(I'//string2(1:lnblnk(string2))//')'
	  READ(COMM(IB(I):IE(I)),fstr302,ERR=101) NFP(I-1)
 101	  READ(COMM(IB(I):IE(I)),fstr301,ERR=100) SC(I-1)
 100	CONTINUE
	IF (IECHO.EQ.1) WRITE(6,26) COMM
 26	FORMAT(1X,A60)
 202	IF (MND.EQ.'ppp')     RETURN1
	IF (MND.EQ.'q')       RETURN1
	IF (MND.EQ.'help')    CALL HELP(*99,'TT','pf')
	IF (NFP(1).GT.6) THEN
	  WRITE(6,*) '  **** Max POSITION buffer NUMBER = 6 ****'
	  GO TO 99
	END IF
	IF (MND.EQ.'t')       CALL PTYPE(*99,NFP(1),SC(2),SC(3),
     *                              NFP(2),NFP(3),0,IX,NU,NV,KF)
	IF (MND.EQ.'tp')      CALL PTYPE(*99,NFP(1),SC(2),SC(3),
     *                              NFP(2),NFP(3),1,IX,NU,NV,KF)
	IF (MND.EQ.'save')    CALL PTYPE(*99,NFP(1),SC(2),SC(3),
     *                              NFP(2),NFP(3),2,IX,NU,NV,KF)
	IF (MND.EQ.'edit')    CALL PEDIT(*99,NFP(1),IX,NU,NV,KF)
	IF (MND.EQ.'trim')    CALL PTRIM(*99,NFP(1))
	if (mnd.eq.'coo')     call makecoo(*99,nfp(1),1)
	if (mnd.eq.'dcoo')    call makecoo(*99,nfp(1),0)
	if (mnd.eq.'scoo')    call saocoo(*99,nfp(1),1)
	if (mnd.eq.'spos')    call saoposf(*99,nfp(1),in,nu,nv,kf,1)
	IF (MND.EQ.'scpf')    CALL SCALEPF(*99,NFP(1),kf)
	IF (MND.EQ.'rot')     CALL rotpof(*99,NFP(1),kf)
	IF (MND.EQ.'tfpo')    CALL transpof(*99,NFP(1),nfp(2),ix,
     *                             nu,nv,kf)
	IF (MND.EQ.'miri')    CALL mirrorpf(*99,NFP(1),1,kf)
	IF (MND.EQ.'mirj')    CALL mirrorpf(*99,NFP(1),0,kf)
	IF (MND.EQ.'tran')    CALL transppf(*99,NFP(1),kf)
	IF (MND.EQ.'r90')     CALL rot90pf(*99,NFP(1),0,kf)
	IF (MND.EQ.'r90c')    CALL rot90pf(*99,NFP(1),1,kf)
	IF (MND.EQ.'r180')    CALL rot90pf(*99,NFP(1),2,kf)
	IF (MND.EQ.'frpo')    CALL FRPOF(*99,NFP(1))
	IF (MND.EQ.'rpof')    CALL RPOF(*99,NFP(1),SC(2),nfp(2),0)   
	IF (MND.EQ.'rpau')    CALL RPOF(*99,NFP(1),SC(2),nfp(2),-1)   
	IF (MND.EQ.'rrpa')    CALL RPOF(*99,NFP(1),SC(2),nfp(2),-2)   
	if (mnd.eq.'pfli')    call pfbound(nfp(1),*99)
	IF (MND.EQ.'matp')    CALL posmatch(*99,NFP(1),nfp(2),0)   
	IF (MND.EQ.'matc')    CALL posmatch(*99,NFP(1),nfp(2),1)   
	IF (MND.EQ.'del')     CALL DELREC(*99,NFP(1),NOB,nposfil,0)
	IF (MND.EQ.'rec')     CALL DELREC(*99,NFP(1),NOB,nposfil,1)
	IF (MND.EQ.'merp')    CALL MEROBJD(*99,NFP(1),IX,NU,NV,KF)
	IF (MND.EQ.'zapc')    CALL ZAPCOSRAY(*99,NFP(1),IX,NU,NV,KF)
	IF (MND.EQ.'objn')    CALL objnum(*99,NFP(1),nfp(2),nfp(3),
     *                                 IX,NU,NV,KF)
	IF (MND.EQ.'shif')    CALL PFSHIFT(*99,NFP(1),NFP(2),NFP(3),
     *                                     SC(3),0)   
	IF (MND.EQ.'shtr')    CALL PFSHIFT(*99,NFP(1),NFP(2),NFP(3),
     *                                     SC(3),1)   
C Commands that takes 2 frame numbers
C
	IF (MND.EQ.'comb')    CALL PFCOMBIN(*99,NFP(1),NFP(2),KF)
c	IF (MND.EQ.'matp')    CALL matchpos(*99,NFP(1),NFP(2),KF)
	IF (MND.EQ.'move')    CALL PFMOVE(*99,NFP(1),NFP(2))
	IF (MND.EQ.'copy')    CALL PFMOVE(*99,NFP(1),NFP(2))
	IF (MND.EQ.'icro'.OR.MND.EQ.'rcro'.OR.MND.EQ.'pcro') THEN
	  CALL QUERYNFR(NFP(1),nposfil+1,1,*99,*20001)
20001	  CALL QUERYNFR(NFP(2),nposfil+1,2,*99,*20002)
20002	IF (MND.EQ.'pcro') CALL PCROSS(*99,IJOI(1,NFP(1)),IJOJ(1,NFP(1))
     *         ,IJOI(1,NFP(2)),IJOJ(1,NFP(2)),NOB(NFP(1)),NOB(NFP(2)))
	IF (MND.EQ.'rcro') CALL RCROSS(*99,IJOI(1,NFP(1)),IJOJ(1,NFP(1))
     *          ,IJOI(1,NFP(2)),IJOJ(1,NFP(2)),NOB(NFP(1)),NOB(NFP(2)),
     *          NFP(1),NFP(2),IX,NU,NV,KF)
	IF (MND.EQ.'icro') CALL ICROSS(*99,IJOI(1,NFP(1)),IJOJ(1,NFP(1))
     *          ,IJOI(1,NFP(2)),IJOJ(1,NFP(2)),NOB(NFP(1)),NOB(NFP(2)),
     *          NFP(1),NFP(2),IX,NU,NV,KF)
	END IF
 401	WRITE(6,*) '#### Invalid posf command ####'
 	GO TO 99
  999	RETURN
	END
C
C//////////////////////////////////////////////////////////////////////
C
C IPAR=0: SET NOB TO 0
C IPAR=1: SET NOB TO INPUT
C	
	SUBROUTINE DELREC(*,NFP,NOB,nposfil,IPAR)
	INTEGER NOB(6)
	CALL QUERYNFR(NFP,nposfil+1,0,*999,*20001)
20001	IF (IPAR.EQ.0) THEN
	  NOB(NFP)=0
	  RETURN1
	ELSE
 600	  WRITE(6,10) nob(nfp)
 10	FORMAT('  Enter NOB (number of objects) (df:',i5,'): ',$)
	  call read1i(nob(nfp),*999,*600)
	  RETURN1
	END IF
 999	RETURN1
	END
C	
C//////////////////////////////////////////////////////////////////////
C
C IPAR=0/1: TYPE POSITION FILE, 0 with option between objects J1 and J2
C                               1 with option for all objects with co-or
C                                 between J1 and J2
C IPAR=2: SAVE POSITION FILE ON DISK
C	
c  modification Feb 23/24 1999
c    output names are tagged with the section number if nsct(nfp) is
c     not zero, or if another integer input is included in the
c     call input.  The section number is passed through as js1.
c
	SUBROUTINE PTYPE(*,NFP,STRF,strf2,js1,J2,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER*28 FILT,FILOUT
	character*24 fdate
	CHARACTER*60 STRF,COMMENT,strf2,secstr*1
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	include 'ppparm.inc'
	include 'pipeparm.inc'
	CALL QUERYNFR(NFP,KF,0,*900,*2001)
 2001	IF (NFP.GT.nposfil) THEN
	  WRITE(6,*) '  *** OBJECT FILE NUMBER MUST BE <= ',nposfil
	  RETURN1
	END IF
	IF (IPAR.EQ.2) THEN
	  if (ireadsaoreg.eq.0) then
c sound alarm
	    call rbell(1)
	    write(6,*) '  ++++ warning, SAOreg file has not been read +'
	  end if
c create out name
c
c  first check if a name has been passed through
	  if (js1.eq.0) then
	    filt=strf(1:28)
	  else
	    filt=strf2(1:28)
	  end if
c 
c 600	  CALL READFN(FILT,STRF(1:18),FILOUT,'pos','o',11,*900,
c       *** Dec 29, 2004: this limits name to 12 characeter, need to fix
  600	  CALL READFN2(FILT,filt,FILOUT,'pos','o',22,*900,
     *           *6100,*2002)
 6100	  write(6,*) ' *** output aborted *** '
	   return1
 2002	  continue
c check if name is .pos
	  namelen=lnblnk(filout)
	  if (filout(namelen-2:namelen).ne.'pos')
     *        filout=filout(1:namelen)//'.pos'
	  IF (FILOUT.EQ.'n') GOTO 900
c append section number, j1 over-rides nsec
	  if (js1.eq.0) then
	    if (nsct(nfp).ne.0) js1=nsct(nfp)
	  else
	    write(6,37) nsct(nfp),js1
 37	    format('  Section number',i3,' over-ridden by ',i3)
	  end if
	  if (js1.gt.0) then
	    istatus=encode(secstr,float(js1),1,0,idum)
	    filout=filout(1:lnblnk(filout))//'.'//secstr
	  end if
c request comment 
	  if (ircspipe.eq.0) then
 6001	    WRITE(6,13) COMMENT
 13	FORMAT('   Enter comment, <60 characters:'/
     *         ' (',A60,')')
	    CALL READSTRD(60,COMMENT,*900,*6001)
	  else
	    comment=strf2
	  end if
	  call opennew(28,1,28,filout,*900)
c	  OPEN(UNIT=28,FILE=FILOUT,status='NEW',ERR=600)
c	  CALL DATE(ADATE)
c	  CALL TIME(ATIME)
	  DO 110 I=60,1,-1
 110	    IF (COMMENT(I:I).NE.' ') GO TO 111
 111	  PCOMMENT(NFP)=COMMENT(1:MIN0(40,I+1))//fdate()
	END IF
 3	FORMAT(A60)
 2	FORMAT(A15)
	WRITE(6,*) '  CURRENT POSITION FILE FOR FRAME',NFP
	WRITE(6,41) NOB(NFP), PCOMMENT(NFP)
 4	FORMAT(I6,1X,A60)
 41	FORMAT(2X,I6,' objects -- ',A60)
	IF (IPAR.EQ.0) THEN
	  IF (JS1.EQ.0) THEN
	    I1=1
	    I2=NOB(NFP)
	  ELSE
	    I1=JS1
	    I2=J2
	    if (j2.eq.0) i2=i1
	  END IF
	  DO 100 I=I1,I2
	    II=IJOI(I,NFP)
	    JJ=IJOJ(I,NFP)
 100	    WRITE(6,120) I, IDOB(I,NFP),II,JJ,IX(II,JJ,NFP)
	ELSE IF (IPAR.EQ.1) THEN
	  DO 102 I=1,NOB(NFP)
	    IF (IJOJ(I,NFP).GE.JS1) THEN
	      IF (IJOJ(I,NFP).LE.J2) THEN
	        II=IJOI(I,NFP)
	        JJ=IJOJ(I,NFP)
 	        WRITE(6,120) I, IDOB(I,NFP),II,JJ,IX(II,JJ,NFP)
	      ELSE 
	        GO TO 103
	      END IF
	    END IF
 102	  CONTINUE
 103	  CONTINUE
	ELSE 
c save to disk
	  WRITE(28,4) NOB(NFP),PCOMMENT(NFP)
	  call wtsecinfo(nfp,28)
	  DO 101 I=1,NOB(NFP)
	    II=IJOI(I,NFP)
	    JJ=IJOJ(I,NFP)
	    if (ii.le.0.or.jj.le.0.or.
     *            ii.gt.nii(nfp).or.jj.gt.njj(nfp)) then
              write(6,35) i,ii,jj
 35	format(' ** warning ** obj#',i4,' @ ',2i5, 
     *        ' position outside of range')
	      item=0
	    else
	      item=IX(II,JJ,NFP)
	    end if
	    WRITE(28,121) II,JJ,IDOB(I,NFP),item,I
 101	  continue
	  CLOSE(UNIT=28)
	END IF
 120	FORMAT(2X,I4,1X,I4,3X,2I5,2X,I7)
 121	FORMAT(1X,2I6,1X,I4,2X,I7,2X,I5)
 900	RETURN1
	END
c////////////////////////////////////////////////////////////
c
c subroutine to  write section information
	subroutine wtsecinfo(nfp,idev)
        include 'objcat.inc' 
        include 'picdir.inc' 
	include 'mosaic.inc'
c  set up new pos section info
	if (nsecpos(nfp).ne.nsct(nfp)) then
	  nsecpos(nfp)=nsct(nfp)
	  isecpos1(nfp)=isec1(nsct(nfp))
	  jsecpos1(nfp)=jsec1(nsct(nfp))
	  isecpos2(nfp)=isec2(nsct(nfp))
	  jsecpos2(nfp)=jsec2(nsct(nfp))
	  nedgepos(nfp)=nedge
	end if
	write(idev,5)  nsecpos(nfp),isecpos1(nfp), 
     *        jsecpos1(nfp),isecpos2(nfp),jsecpos2(nfp),nedgepos(nfp)
 5	format('#secinfo:sect ',i2,10x,4I6,9x,i4)
c  determine world co-ordinate of defined area
	  if (nsecpos(nfp).gt.0) then
	    call worldpos(nfp,nsecpos(nfp),ip1,jp1,ip2,jp2)
	  else
	    ip1=ilpos(nfp)
	    jp1=jlpos(nfp)
	    ip2=iupos(nfp)
	    jp2=jupos(nfp)
	  end if
	  write(idev,6) ilpos(nfp),jlpos(nfp),iupos(nfp),jupos(nfp)
     *             ,ip1,jp1,ip2,jp2 
 6	format('#posinfo',4i6,5x,4i6)
	return
	end 
C	
C//////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CONSOLIDATE ONE TO THREE POSTION FILES
C    ALL POSTION IN THE FILE(S) ARE EXAMINED, POSITION WITHIN
C    A GIVEN RADIUS ARE DISCARDED, ALL OTHERS ARE COMBINED INTO
C    A SINGLE FILE AND PUT INTO THE FIRST FILE
C	
	SUBROUTINE PFCOMBINOLD(*,NFP1,NFP2,KF)
c	INTEGER*2 IIT(10000,2),JJT(10000,2),NP(2),IDT(10000,2)
	INTEGER IIT(10000,2),JJT(10000,2),NP(2),IDT(10000,2)
        include 'objcat.inc' 
	include 'pppcore.inc'
	equivalence (iit(1,1),iscr(1)),(jjt(1,1),iscr(20000))
     *             ,(idt(1,1),iscr(40000))
	IF (NFP1.EQ.0) THEN
	  CALL QUERYNFR(NFP1,nposfil+1,1,*999,*600)
 600	  WRITE(6,10) 
	  nfp2=0
 10	FORMAT('  Enter 1 more file or none: ',$)
	  CALL READ1I(NFP2,*999,*600)
	ELSE
	  CALL QUERYNFR(NFP1,nposfil+1,1,*999,*20002)
20002	  continue
	END IF
 501	IF (NFP2.EQ.0) THEN
	  NF=1
	ELSE
	  CALL QUERYNFR(NFP2,nposfil+1,2,*999,*20003)
20003	  NF=2
	END IF
	NP(1)=NFP1
	NP(2)=NFP2
 602	WRITE(6,11) IRAD
 11	FORMAT('  Enter radius of recognition (default:',I3,'): ',$)
	CALL READ1I(IRAD,*999,*602)
	IF (IRAD.LT.0) GO TO 602
	DO 100 L=1,NF
	  DO 100 I=1,NOB(NP(L))
	   IIT(I,L)=IJOI(I,NP(L))
	   JJT(I,L)=IJOJ(I,NP(L))
 100	   IDT(I,L)=0
	DO 101 L=1,NF
	  DO 101 I=1,NOB(NP(L))
	    IF (IDT(I,L).EQ.0) THEN
	      DO 102 M=1,NF
	        DO 103 N=1,NOB(NP(L))
	          JTT=JJT(N,M)-JJT(I,L)
	          IF (JTT.GT.IRAD) GO TO 102
	          IF (IABS(JTT).GT.IRAD) GO TO 103
	          IF (M.EQ.L.AND.I.EQ.N) GO TO 103
c	          ITT=IABS_2(IIT(N,M)-IIT(I,L))
	          ITT=IABS(IIT(N,M)-IIT(I,L))
	          IF (ITT.LE.IRAD) IDT(N,M)=-1
 103	        CONTINUE
 102          CONTINUE
	    END IF
 101	CONTINUE
C pick up all objects not having IDT=-1
	KK=0
	DO 110 L=1,NF
	  DO 110 I=1,NOB(NP(L))
	write(6,*) L,I,IDT(I,L)
	    IF (IDT(I,L).EQ.0) THEN
	      KK=KK+1
	      IJOI(KK,NFP1)=IIT(I,L)
	      IJOJ(KK,NFP1)=JJT(I,L)
	      IDOB(KK,NFP1)=IDOB(I,NP(L))
	    END IF
 110	CONTINUE
	NOB(NFP1)=KK
C  reshuffle
	call arranpos(nob(nfp1),ijoi(1,nfp1),ijoj(1,nfp1),
     *                idob(1,nfp1))
 999	RETURN1
	END
C	
C//////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CONSOLIDATE 2 position files
C   into  A SINGLE FILE AND PUT INTO THE FIRST FILE
C	
	SUBROUTINE PFCOMBIN(*,NFP1,NFP2,KF)
c	INTEGER*2 IIT(10000,2),JJT(10000,2),NP(2),IDT(10000,2),irc(30)
	INTEGER IIT(10000,2),JJT(10000,2),NP(2),IDT(10000,2),irc(30)
        include 'objcat.inc' 
	include 'pppcore.inc'
	equivalence (iit(1,1),iscr(1)),(jjt(1,1),iscr(20000))
     *             ,(idt(1,1),iscr(40000))
	IF (NFP1.EQ.0) THEN
	  CALL QUERYNFR(NFP1,nposfil+1,1,*999,*600)
 600	  WRITE(6,10) 
	  nfp2=0
 10	FORMAT('  Enter 1 more file or none: ',$)
	  CALL READ1I(NFP2,*999,*600)
	ELSE
	  CALL QUERYNFR(NFP1,nposfil+1,1,*999,*20002)
20002	  continue
	END IF
 501	IF (NFP2.EQ.0) THEN
	  NF=1
	ELSE
	  CALL QUERYNFR(NFP2,nposfil+1,2,*999,*20003)
20003	  NF=2
	END IF
	NP(1)=NFP1
	NP(2)=NFP2
 602	WRITE(6,11) IRAD
 11	FORMAT('  Enter max radius of recognition (default:',I3,'): ',$)
	CALL READ1I(IRAD,*999,*602)
	IF (IRAD.LT.0) GO TO 602
	if (irad.gt.30) then
	  irad=30
	  write(6,*) '  ++ max radius too large, set to 30 ++'
	end if
c  set up radius array
	do 130 i=1,irad+1
	  irc(i)=i-1
 130	continue
c initialize working array
	DO 100 L=1,NF
	  DO 100 I=1,NOB(NP(L))
	   IIT(I,L)=IJOI(I,NP(L))
	   JJT(I,L)=IJOJ(I,NP(L))
 100	   IDT(I,L)=0
c  merge files, starting with radius=0
	ntotot=0
	do 200 k=1,irad+1
	  ntot=0
	  DO 101 I=1,NOB(NP(1))
	    IF (IDT(I,1).EQ.0) THEN
	      DO 103 N=1,NOB(NP(2))
c  make sure the obj being tested has not been paired
	        if (idt(n,2).eq.-1) goto 103
	          JTT=JJT(N,2)-JJT(I,1)
	          IF (IABS(JTT).GT.irc(k)) GO TO 103
c	          ITT=IABS_2(IIT(N,M)-IIT(I,L))
	          ITT=IABS(IIT(N,2)-IIT(I,1))
	          IF (ITT.LE.irc(k)) then
c remove file 2 objects from the pool
	            IDT(N,2)=-1
c remove file 1 objects from more testing
	            idt(i,1)=99
	            ntot=ntot+1
	            goto 101
	          end if
 103	        CONTINUE
	    END IF
 101	  CONTINUE
	  write(6,15) irc(k),ntot
	  ntotot=ntotot+ntot
 15	format('  .. merge radius=',i2,' pix;  total objs merged:',i4)
 200	continue
C pick up all objects not having IDT=-1
	KK=nob(nfp1)
	DO 110 I=1,NOB(2)
	  IF (IDT(I,2).EQ.0) THEN
	    KK=KK+1
	    IJOI(KK,NFP1)=IIT(I,2)
	    IJOJ(KK,NFP1)=JJT(I,2)
	    IDOB(KK,NFP1)=IDOB(I,NP(2))
	  END IF
 110	CONTINUE
	write(6,16) ntotot,nfp1,kk-nob(nfp1),nob(nfp2)-ntotot
 16	format(' --- total number merged: ',i4,/
     *  '   total new obj addeded to file',i2,':',i4,' (verified:',
     *       i4,')')
	NOB(NFP1)=KK
C  reshuffle
	call arranpos(nob(nfp1),ijoi(1,nfp1),ijoj(1,nfp1),
     *                idob(1,nfp1))
 999	RETURN1
	END

c////////////////////////////////////////////////////////////////////
c  subroutine to take 2 PF files detemine the scale ratio and
c    relative rotation, and modify the first 1 to fit the 2nd
c
	subroutine matchpf(*,np1,np2)
	include 'objcat.inc'
 605	write(6,5) np1,np2,ncen1,ncen2
 5	format('  Enter central ref obj #s for frs ',i2,' and ',i2, 
     *        ' [',2i5,']: ',$)
	call read2i(ncen1,ncen2,*999,*605)
	if (ncen1.le.0.or.ncen2.le.0.or.ncen1.gt.nob(np1).or.ncen2.gt.
     *    nob(np2)) then
	  write(6,*) '  +++ Obj # out of bound, enter again...'
	  goto 605
	end if
	if (gscale.le.0.00) gscale=1.
 606	write(6,6) gscale,grot
 6	format('  Enter initial scale ratio (2/1) and rot (2-1) [',
     *    f7.5,f8.2,']: ',$)
	call read2r(gscale,grot,*999,*606)
c  copy file 1 to a temp file and do the transformation

c plot out the 2 position files, in file 2 co-ordinates, 
c    centered at the 2 central obj

c request entering another 2 reference objects

c  recompute scale and rotation

c  request if file 1 should be transformed permanently 
 999	return1
	end
	  
C//////////////////////////////////////////////////////////////////////
C
C   SUBROUTINE TO CROSS CORRELATE TWO POSITION FILES
C       RETURNS TWO FILES WITH COMMON POSITIONS RELATIVE TO A 
C       GIVEN CENTER
C
	SUBROUTINE PCROSS(*,IJ1I,IJ1J,IJ2I,IJ2J,NOB1,NOB2)
c	INTEGER*2 IJ1I(1),IJ1J(1),IJ2I(1),IJ2J(1),
c    *     IJ3I(10000),IJ3J(10000),IOB1(10000),IOB2(10000)
	INTEGER IJ1I(1),IJ1J(1),IJ2I(1),IJ2J(1),
     *     IJ3I(10000),IJ3J(10000),IOB1(10000),IOB2(10000)
c
	CHARACTER*1 IANS
	include 'pppcore.inc'
	equivalence (ij3i(1),iscr(1)),(ij3j(1),iscr(10001))
     *             ,(iob1(1),iscr(20001)),(iob2(1),iscr(30001))
 300	WRITE(6,15) ICEN1,ICEN2
 15	FORMAT('  Enter center object id# for 1st and 2nd files (deflt:'
     *             ,2I5,'): ',$)
	CALL READ2I(ICEN1,ICEN2,*999,*300)
	IF (ICEN1.EQ.0.OR.ICEN2.EQ.0) RETURN1
	WRITE(6,310) NFP1,IJ1I(ICEN1),IJ1J(ICEN1)
	WRITE(6,310) NFP2,IJ2I(ICEN2),IJ2J(ICEN2)
 310 	FORMAT('  FILE#',I2,'  CENTRAL OBJECT AT ',I4,I4)
 6001	WRITE(6,16) 
 16	FORMAT(' Are the positions acceptable? y/n: ',$)
	call readstr(1,ians,*999,*6001)
	IF (IANS.NE.'y') GO TO 300
 302	WRITE(6,17) RAD 
 17	FORMAT('  Enter radius of recognition (real pixel, deflt:',F6.2,
     *         '): ',$)
	CALL READ1R(RAD,*999,*302)
	IRAD=RAD+.5
C Shift file 2 positions (integer shift only), and initialize
C  IOB1 and 2 : array in which non-0 numbers represent accepted objects
	ID=IJ1I(ICEN1)-IJ2I(ICEN2)
	JD=IJ1J(ICEN1)-IJ2J(ICEN2)
	DO 110 I=1, MAX0(NOB1,NOB2)
	  IOB1(I)=0
 110	  IOB2(I)=0
	DO 100 I=1,NOB2
	  IJ3I(I)=IJ2I(I)+ID
 100	  IJ3J(I)=IJ2J(I)+JD
	NOBS=0
	NSTART=1
C  Loop for cross correlating files
	DO 101 I=1,NOB1
C  a box of IRAD X IRAD around each object in file 1 is created
	  K1=IJ1I(I)-IRAD
	  K2=IJ1I(I)+IRAD
	  L1=IJ1J(I)-IRAD
	  L2=IJ1J(I)+IRAD
	  DO 102 J=NSTART,NOB2
C   check if any object in file 2 falls in the box
	    IF (IJ3J(J).LT.L1) GO TO 102
C   quit completely when J co-ordinate is lager than upper limit
	    IF (IJ3J(J).GT.L2) GO TO 101
	    IF (IJ3I(J).LT.K1) GO TO 102
	    IF (IJ3I(J).GT.K2) GO TO 102
C  check integral "path length" <= IRAD (this simulates a Sebok circle)
c	    IF ((IABS_2(IJ1J(I)-IJ3J(J))+IABS_2(IJ1I(I)-IJ3I(J))).GT.IRAD)
	    IF ((IABS(IJ1J(I)-IJ3J(J))+IABS(IJ1I(I)-IJ3I(J))).GT.IRAD)
     *         GO TO 102
	    IF (IOB2(J).NE.0) GO TO 109
C first object identified in box
 108	    NOBS=NOBS+1
	    IOB1(I)=NOBS
	    IOB2(J)=NOBS
C	NSTART=MAX0(1,J-IRAD-1)
	    GO TO 101
 109	    CONTINUE
C   for the case of more than one object in box -- take nearest one
	    DO 111 M=1,I-1
	      IF (IOB1(M).EQ.IOB2(J)) GO TO 112
 111	    CONTINUE
	    IF (M.EQ.I) GO TO 101
 112	    IA=IJ1I(M)-IJ3I(J)
	    IB=IJ1J(M)-IJ3J(J)
	    IC=IJ1I(I)-IJ3I(J)
	    ID=IJ1J(I)-IJ3J(J)
	    X1=SQRT(FLOAT(IA*IA+IB*IB))
	    X2=SQRT(FLOAT(IC*IC+ID*ID))
	    IF (X1.LE.X2) GO TO 102
	    IOB1(I)=IOB1(M)
	    IOB1(M)=0
 102	  CONTINUE
 101	CONTINUE
C
C   fill new array of ij's, using IOB to determine which obj to take
	NN=0
	DO 201 I=1,NOB1
	  IF (IOB1(I).EQ.0) GO TO 201
	  NN=NN+1
	  IJ1I(NN)=IJ1I(I)
	  IJ1J(NN)=IJ1J(I)
	  IOB1(NN)=IOB1(I)
 201	CONTINUE
	NN=0
	DO 202 I=1,NOB2
	IF (IOB2(I).EQ.0) GO TO 202
	NN=NN+1
	IJ2I(NN)=IJ2I(I)
	IJ2J(NN)=IJ2J(I)
	IOB2(NN)=IOB2(I)
 202	CONTINUE
C  reshuffle objects, according to J 
 250	ILOOP=0
	DO 220 I=2,NOBS
	IF (IJ1J(I).GE.IJ1J(I-1)) GO TO 240
	ILOOP=1
	ITEMI=IJ1I(I-1)
	ITEMJ=IJ1J(I-1)
	ITEM=IOB1(I-1)
	IJ1I(I-1)=IJ1I(I)
	IJ1J(I-1)=IJ1J(I)
	IOB1(I-1)=IOB1(I)
	IJ1I(I)=ITEMI
	IJ1J(I)=ITEMJ
	IOB1(I)=ITEM
 240	IF (IJ2J(I).GE.IJ2J(I-1)) GO TO 220
	ILOOP=1
	ITEMI=IJ2I(I-1)
	ITEMJ=IJ2J(I-1)
	ITEM=IOB2(I-1)
	IJ2I(I-1)=IJ2I(I)
	IJ2J(I-1)=IJ2J(I)
	IOB1(I-1)=IOB1(I)
	IJ2I(I)=ITEMI
	IJ2J(I)=ITEMJ
	IOB2(I)=ITEM
 220	CONTINUE
	IF (ILOOP.EQ.1) GO TO 250
	WRITE(6,*) ' CROSS CORRELATED FILES,',NOBS,' OBECTS'
	WRITE(6,320) (I,IJ1I(I),IJ1J(I),IJ2I(I),IJ2J(I),I=1,NOBS)
 320 	FORMAT(1X,I4,5X,2I4,10X,2I4)
	NOB1=NOBS
	NOB2=NOBS
 999	RETURN1
	END
C//////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO SHIFT POSITION FILE CO-ORDINATE
C
c   ipar=0: user input
c   ipar=1: common block tranf used
c		
	SUBROUTINE PFSHIFT(*,NFP,IDT,JDT,SCDUM,IPAR)
	CHARACTER*60 SCDUM
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	CALL QUERYNFR(NFP,7,0,*999,*20001)
20001	IF (NFP.GT.nposfil) THEN
	  WRITE(6,*) '  *** OBJECT FILE NUMBER MUST BE <= ***'
	  RETURN1
	END IF
	if (ipar.eq.0) then
	  IF (JDT.EQ.0.AND.SCDUM.EQ.' ') THEN
 600	    WRITE(6,10) ID,JD 
 10	FORMAT('  Enter integer shift of position file (default:',2I5,
     *	  ')'/,'        New position = Old + shift : ',$)
	    CALL READ2I(ID,JD,*999,*600)
	  ELSE
	    ID=IDT
	    JD=JDT
	  END IF
	else
c ipar=1, use common block shift values 
	  ID=nint(dxmean)
	  JD=nint(dymean)
	  write(6,1) dxmean,dymean,ID,JD
 1	format(' .. posf shifting from smat/p dx(',f7.3,')/dy(',f7.3,
     *           ') : ',2I4)
	end if
	DO 100 I=1,NOB(NFP)
	  IJOI(I,NFP)=IJOI(I,NFP)+ID
	  IJOJ(I,NFP)=IJOJ(I,NFP)+JD
 100	CONTINUE
 999	RETURN1
	END
C////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO MOVE POSITION FILE FROM ONE FRAME TO ANOTHER
C
	SUBROUTINE PFMOVE(*,NFP1,NFP2)
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	CALL QUERYNFR(NFP1,7,1,*900,*20001)
20001	CALL QUERYNFR(NFP2,7,2,*900,*20002)
20002	IF (NFP1.GT.nposfil.OR.NFP2.GT.nposfil) THEN
	  WRITE(6,*) '  *** OBJECT FILE NUMBER MUST BE <= ***'
	  RETURN1
	END IF
	NOB(NFP2)=NOB(NFP1)
	PCOMMENT(NFP2)=PCOMMENT(NFP1)
	DO 100 I=1,NOB(NFP1)
	IJOI(I,NFP2)=IJOI(I,NFP1)
	IJOJ(I,NFP2)=IJOJ(I,NFP1)
 100	IDOB(I,NFP2)=IDOB(I,NFP1)
 900	RETURN1
	END
C//////////////////////////////////////////////////////////////////////
C
C   SUBROUTINE TO CROSS CORRELATE TWO POSITION FILES
C       RETURNS TWO FILES WITH COMMON POSITIONS RELATIVE TO A 
C       GIVEN CENTER
C
C       THIS ROUTINE USES CENTROIDS AND REAL CO-ORDS.
C
	SUBROUTINE RCROSS(*,IJ1I,IJ1J,IJ2I,IJ2J,NOB1,NOB2,
     *                   NFP1,NFP2,IX,NU,NV,KF)
c	INTEGER*2 IJ1I(1),IJ1J(1),IJ2I(1),
c    *            IJ2J(1),IOB1(10000),IOB2(10000),IX(NU,NV,KF)
	INTEGER IJ1I(1),IJ1J(1),IJ2I(1),
     *            IJ2J(1),IOB1(10000),IOB2(10000),IX(NU,NV,KF)
	DIMENSION REALI1(10000),REALI2(10000),REALJ1(10000),
     *      REALJ2(10000),DUM(10000)
	CHARACTER*1 IANS
	include 'pppcore.inc'
	include 'ppparm.inc'
	include 'picdir.inc'
	include 'apert.inc'
	EQUIVALENCE (iscr(1),REALI1(1)),(iscr(20001),REALJ1(1)),
     *    (iscr(40001),REALI2(1)),(iscr(60001),REALJ2(1)),
     *    (iscr(80001),DUM(1)),(iscr(100001),IOB1(1)),
     *             (iscr(110001),IOB2(1))
 600	WRITE(6,15) NFP1,NFP2,ICEN1,ICEN2
 15	FORMAT('  Enter center object id#''s for files',I2,' and',I2,
     *    /'      (dflt:',2I5,', 0 0 for entering positions): ',$)
	CALL READ2I(ICEN1,ICEN2,*999,*600)
	IF (ICEN1.GT.NOB1.OR.ICEN2.GT.NOB2) THEN
	  WRITE(6,*) '  **** Object nmber out of bound ***'
	  RETURN1
c ! request co-ordinates
	ELSE IF (ICEN1.LE.0.OR.ICEN2.LE.0) THEN
 650	  WRITE(6,350) NFP1,IX1,IY1
	  CALL READ2I(IX1,IY1,*999,*650)
	  CALL GETOBJNUM(IX1,IY1,IJ1I,IJ1J,NOB1,ICEN1,*650,*651)
 651	  WRITE(6,350) NFP2,IX2,IY2
 350	FORMAT('  Enter integer position of ref. for frame',I2,
     *           ' (dflt:',2I5,'): ',$)
	  CALL READ2I(IX2,IY2,*999,*651)
	  CALL GETOBJNUM(IX2,IY2,IJ2I,IJ2J,NOB2,ICEN2,*651,*302)
	END IF
	WRITE(6,310) NFP1,IJ1I(ICEN1),IJ1J(ICEN1)
	WRITE(6,310) NFP2,IJ2I(ICEN2),IJ2J(ICEN2)
 310 	FORMAT('  FILE#',I2,'  CENTRAL OBJECT AT ',I4,I4)
 6001	WRITE(6,16) 
 16	FORMAT(' Are the positions acceptable? y/n: ',$)
	call readstr(1,ians,*999,*6001)
	IF (IANS.NE.'y') GO TO 600
 302	WRITE(6,17) RAD 
 17	FORMAT('  Enter radius of recognition (real pixel, deflt:',F6.2,
     *         '): ',$)
	CALL READ1R(RAD,*999,*302)
	IRAD=RAD+.5
C Shift file 2 positions (integer shift only), and initialize
C  IOB1 and 2 : array in which non-0 numbers represent accepted objects
C
C determine centroid of reference objects:
	CALL PCENTR(NFP1,IPO,IX,NU,NV,KF,REALI1,REALJ1,DUM(1),DUM1,
     *      IJ1I(ICEN1),IJ1J(ICEN1),1,FLOAT(NAPCEN),31,1,7)
	CALL PCENTR(NFP2,IPO,IX,NU,NV,KF,REALI2,REALJ2,DUM(1),DUM1,
     *      IJ2I(ICEN2),IJ2J(ICEN2),1,0.,0,1,7)
	CENI1=REALI1(1)
	CENJ1=REALJ1(1)
	CENI2=REALI2(1)
	CENJ2=REALJ2(1)
	WRITE(6,12) CENI1,CENJ1,CENI2,CENJ2
 12	FORMAT('   -- Centroids of reference objs: ',4F8.2)
	DELTAI=CENI1-CENI2
	DELTAJ=CENJ1-CENJ2
	DO 110 I=1, MAX0(NOB1,NOB2)
	  IOB1(I)=0
 110	  IOB2(I)=0
	WRITE(6,*) '   Computing centroids for first file...'
	CALL PCENTR(NFP1,IPO,IX,NU,NV,KF,REALI1,REALJ1,DUM,DUM1,IJ1I,
     *      IJ1J,NOB1,0.,0,0,4)
	CRIT=2.5*RAD
	RADSQ=RAD*RAD
C determine best Real co-ord of objects in frame NFP1
	DO 120 I=1,NOB1
	  IF (ABS(REALI1(I)-FLOAT(IJ1I(I))).GE.CRIT.OR.
     *        ABS(REALJ1(I)-FLOAT(IJ1J(I))).GE.CRIT) THEN
	    IOB1(I)=-1
	  ELSE
C    for objects found more than once, locate the highest pixel
	    IPK=0
	    DO 121 J=MAX0(1,I-35),MIN0(NOB1,I+35)
	      IF (ABS(REALI1(I)-REALI1(J)).LE.RAD.AND.
     *            ABS(REALJ1(I)-REALJ1(J)).LE.RAD) THEN
	        IOB1(J)=-1
	        IF (IX(IJ1I(J),IJ1J(J),NFP1).GT.IPK) THEN
	          IPK=IX(IJ1I(J),IJ1J(J),NFP1)
	          JPK=J
	        END IF
	      END IF
 121	    CONTINUE
	    IOB1(JPK)=0
	  END IF
 120	CONTINUE
	IF (IPRT.EQ.1) THEN
	  DO 141 I=1,NOB1
 141	    WRITE(6,*) I,IJ1I(I),IJ1J(I),REALI1(I),REALJ1(I),IOB1(I)
	END IF
C determine best Real co-ord of objects in frame NFP2
	WRITE(6,*) '   Computing centroids for second file...'
	CALL PCENTR(NFP2,IPO,IX,NU,NV,KF,REALI2,REALJ2,DUM,DUM1,IJ2I,
     *      IJ2J,NOB2,0.,0,0,4)
	DO 130 I=1,NOB2
	  IF (ABS(REALI2(I)-FLOAT(IJ2I(I))).GE.CRIT.OR.
     *        ABS(REALJ2(I)-FLOAT(IJ2J(I))).GE.CRIT) THEN
	    IOB2(I)=-1
	  ELSE
C    for objects found more than once, locate the highest pixel
	    IPK=0
	    DO 131 J=MAX0(1,I-35),MIN0(NOB2,I+35)
	      IF (ABS(REALI2(I)-REALI2(J)).LE.RAD.AND.
     *            ABS(REALJ2(I)-REALJ2(J)).LE.RAD) THEN
	        IOB2(J)=-1
	        IF (IX(IJ2I(J),IJ2J(J),NFP2).GT.IPK) THEN
	          IPK=IX(IJ2I(J),IJ2J(J),NFP2)
	          JPK=J
	        END IF
	      END IF
 131	    CONTINUE
	   IOB2(JPK)=0
	  END IF
 130	CONTINUE
	IF (IPRT.EQ.1) THEN
	  DO 140 I=1,NOB2
 140	    WRITE(6,*) I,IJ2I(I),IJ2J(I),REALI2(I),REALJ2(I),IOB2(I)
	END IF
	DO 100 I=1,NOB2
	  REALI2(I)=REALI2(I)+DELTAI
	  REALJ2(I)=REALJ2(I)+DELTAJ
 100	CONTINUE
	NOBS=0
	NSTART=1
C  Loop for cross correlating files
	DO 101 I=1,NOB1
	  IF (IOB1(I).EQ.-1) GO TO 101
C  a box of IRAD X IRAD around each object in file 1 is created
	  RK1=REALI1(I)-RAD
	  RK2=REALI1(I)+RAD
	  RL1=REALJ1(I)-RAD
	  RL2=REALJ1(I)+RAD
	  RLC2=RL2+CRIT
	  DO 102 J=NSTART,NOB2
	    IF (IOB2(J).NE.0) GO TO 102
C   quit when J co-ordinate is lager than upper limit
	    IF (REALJ2(J).GT.RLC2) GO TO 101
C   check if any object in file 2 falls in the box
	    IF (REALJ2(J).LT.RL1) GO TO 102
	    IF (REALJ2(J).GT.RL2) GO TO 102
	    IF (REALI2(J).LT.RK1) GO TO 102
	    IF (REALI2(J).GT.RK2) GO TO 102
C  check RADIUS
	    RADCHECK=(REALI1(I)-REALI2(J))**2+(REALJ1(I)-REALJ2(J))**2
            IF (RADCHECK.GT.RADSQ)  GO TO 102
	    IF (IOB2(J).GT.0) GO TO 102
C first object identified in box
 108	    NOBS=NOBS+1
	    IOB1(I)=NOBS
	    IOB2(J)=NOBS
C	NSTART=MAX0(1,J-IRAD-2)
	    GO TO 101
C 109	    CONTINUE
C   for the case of more than one object in box -- take nearest one
C	    DO 111 M=1,I-1
C	      IF (IOB1(M).EQ.IOB2(J)) GO TO 112
C 111	    CONTINUE
C	    IF (M.EQ.I) GO TO 101
C 112	    A=REALI1(M)-REALI2(J)
C	    B=REALJ1(M)-REALJ2(J)
C	    IF (SQRT(A*A+B*B).LE.RADCHECK) GO TO 102
C	    IOB1(I)=IOB1(M)
C	    IOB1(M)=0
 102	  CONTINUE
 101	CONTINUE
C
C   fill new array of ij's, using IOB to determine which obj to take
	NN=0
	DO 201 I=1,NOB1
	  IF (IOB1(I).LE.0) GO TO 201
	  NN=NN+1
	  IF (ABS(FLOAT(IJ1I(I))-REALI1(I)).LE.2..AND.
     *           ABS(FLOAT(IJ1J(I))-REALJ1(I)).LE.2.) THEN
	    IJ1I(NN)=NINT(REALI1(I))
	    IJ1J(NN)=NINT(REALJ1(I))
	  ELSE
	    IJ1I(NN)=IJ1I(I)
	    IJ1J(NN)=IJ1J(I)
	  END IF
	  IOB1(NN)=IOB1(I)
 201	CONTINUE
	NN=0
	DO 202 I=1,NOB2
	  IF (IOB2(I).LE.0) GO TO 202
	  NN=NN+1
	  REALI2(I)=REALI2(I)-DELTAI
	  REALJ2(I)=REALJ2(I)-DELTAJ
	  IF (ABS(FLOAT(IJ2I(I))-REALI2(I)).LE.2..AND.
     *           ABS(FLOAT(IJ2J(I))-REALJ2(I)).LE.2.) THEN
	    IJ2I(NN)=NINT(REALI2(I))
	    IJ2J(NN)=NINT(REALJ2(I))
	  ELSE
	    IJ2I(NN)=IJ2I(I)
	    IJ2J(NN)=IJ2J(I)
	  END IF
	  IOB2(NN)=IOB2(I)
 202	CONTINUE
C  reshuffle objects 
 250	ILOOP=0
	DO 220 I=2,NOBS
	  IF (IOB1(I).LT.IOB1(I-1)) THEN
	    ILOOP=1
	    ITEMI=IJ1I(I-1)
	    ITEMJ=IJ1J(I-1)
	    ITEM=IOB1(I-1)
	    IJ1I(I-1)=IJ1I(I)
	    IJ1J(I-1)=IJ1J(I)
	    IOB1(I-1)=IOB1(I)
	    IJ1I(I)=ITEMI
	    IJ1J(I)=ITEMJ
	    IOB1(I)=ITEM
 	  END IF
	  IF (IOB2(I).LT.IOB2(I-1)) THEN
	    ILOOP=1
	    ITEMI=IJ2I(I-1)
	    ITEMJ=IJ2J(I-1)
	    ITEM=IOB2(I-1)
	    IJ2I(I-1)=IJ2I(I)
	    IJ2J(I-1)=IJ2J(I)
	    IOB2(I-1)=IOB2(I)
	    IJ2I(I)=ITEMI
	    IJ2J(I)=ITEMJ
	    IOB2(I)=ITEM
	  END IF
 220	CONTINUE
	IF (ILOOP.EQ.1) GO TO 250
	CALL RBELL(IBELL)
	WRITE(6,*) ' CROSS CORRELATED FILES,',NOBS,' OBECTS'
	WRITE(6,320) (I,IJ1I(I),IJ1J(I),IJ2I(I),IJ2J(I),I=1,NOBS)
 320 	FORMAT(1X,I4,5X,2I4,10X,2I4)
	NOB1=NOBS
	NOB2=NOBS
 999	RETURN1
	END
C//////////////////////////////////////////////////////////////////////
C
C
	SUBROUTINE GETOBJNUM(IX,IY,II,JJ,NOB,ICEN,*,*)	
c	INTEGER*2 II(1),JJ(1)
	INTEGER II(1),JJ(1)
	DO 100 I=1,NOB
	  IF (IX.EQ.II(I).AND.IY.EQ.JJ(I)) THEN
	    ICEN=I
	    WRITE(6,10) ICEN
	    RETURN2
 10	FORMAT('  Reference object number:',I5)
	  END IF
 100	CONTINUE
C  object not found
	WRITE(6,*) ' **** No object found in the expected position ***'
	ICEN=0
	RETURN1
	END
C//////////////////////////////////////////////////////////////////////
C
C   SUBROUTINE TO CROSS CORRELATE TWO POSITION FILES
C       RETURNS TWO FILES WITH COMMON POSITIONS RELATIVE TO A 
C       GIVEN CENTER
C
C       THIS ROUTINE USES THE INTEGER POSITION OF THE POS FILES ONLY
C
	SUBROUTINE ICROSS(*,IJ1I,IJ1J,IJ2I,IJ2J,NOB1,NOB2,
     *                   NFP1,NFP2,IX,NU,NV,KF)
c	INTEGER*2 IJ1I(1),IJ1J(1),IJ2I(1),IJ2J(1),IOB1(10000),
c    *    IOB2(10000),IX(NU,NV,KF),IJ3I(10000),IJ3J(10000)
 	INTEGER IJ1I(1),IJ1J(1),IJ2I(1),IJ2J(1),IOB1(10000),
     *    IOB2(10000),IX(NU,NV,KF),IJ3I(10000),IJ3J(10000)
	CHARACTER*1 IANS
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
	include 'pppcore.inc'
	equivalence (ij3i(1),iscr(1)),(ij3j(1),iscr(10001))
     *             ,(iob1(1),iscr(20001)),(iob2(1),iscr(30001))
 300	WRITE(6,15) NFP1,NFP2,ICEN1,ICEN2
 15	FORMAT('  Enter center object id#''s for files',I2,' and',I2,
     *         ' [:',2I5,']: ',$)
	CALL READ2I(ICEN1,ICEN2,*999,*300)
	IF (ICEN1.LE.0.OR.ICEN2.LE.0.OR.ICEN1.GT.NOB1.OR.
     *       ICEN2.GT.NOB2) THEN
	  WRITE(6,*) '  **** Object nmber out of bound ***'
	  RETURN1
	END IF
	WRITE(6,310) NFP1,IJ1I(ICEN1),IJ1J(ICEN1)
	WRITE(6,310) NFP2,IJ2I(ICEN2),IJ2J(ICEN2)
 310 	FORMAT('  FILE#',I2,'  CENTRAL OBJECT AT ',I4,I4)
 6001	WRITE(6,16) 
 16	FORMAT(' Are the positions acceptable? y/n: ',$)
	call readstr(1,ians,*999,*6001)
	IF (IANS.NE.'y') GO TO 300
 302	WRITE(6,17) RAD 
 17	FORMAT('  Enter radius of recognition (real pixel) [',F6.2,
     *         ']: ',$)
	CALL READ1R(RAD,*999,*302)
	IRAD=RAD+.5
C Shift file 2 positions (integer shift only), and initialize
C  IOB1 and 2 : array in which non-0 numbers represent accepted objects
C
	IDELTAI=IJ1I(ICEN1)-IJ2I(ICEN2)
	IDELTAJ=IJ1J(ICEN1)-IJ2J(ICEN2)
	DO 100 I=1,NOB2
	  IJ3I(I)=IJ2I(I)+IDELTAI
	  IJ3J(I)=IJ2J(I)+IDELTAJ
	  IOB2(I)=0
 100	CONTINUE
	DO 110 I=1, NOB1
 110	  IOB1(I)=0
	RADSQ=RAD*RAD
C determine best Real co-ord of objects in frame NFP1
	DO 120 I=1,NOB1
C    for objects found more than once, locate the highest pixel
	    IPK=0
	    DO 121 J=MAX0(1,I-35),MIN0(NOB1,I+35)
c	      IF (IABS_2(IJ1I(I)-IJ1I(J)).LE.IRAD.AND.
c    *            IABS_2(IJ1J(I)-IJ1J(J)).LE.IRAD) THEN
	      IF (IABS(IJ1I(I)-IJ1I(J)).LE.IRAD.AND.
     *            IABS(IJ1J(I)-IJ1J(J)).LE.IRAD) THEN
	        IOB1(J)=-1
	        IF (IX(IJ1I(J),IJ1J(J),NFP1).GT.IPK) THEN
	          IPK=IX(IJ1I(J),IJ1J(J),NFP1)
	          JPK=J
	        END IF
	      END IF
 121	    CONTINUE
	    IOB1(JPK)=0
 120	CONTINUE
	IF (IPRT.EQ.1) THEN
	  DO 141 I=1,NOB1
 141	    WRITE(6,*) I,IJ1I(I),IJ1J(I),IOB1(I)
	END IF
C frame NFP2
	DO 130 I=1,NOB2
C    for objects found more than once, locate the highest pixel
	    IPK=0
	    DO 131 J=MAX0(1,I-35),MIN0(NOB2,I+35)
c	      IF (IABS_2(IJ2I(I)-IJ2I(J)).LE.IRAD.AND.
c    *            IABS_2(IJ2J(I)-IJ2J(J)).LE.IRAD) THEN
	      IF (IABS(IJ2I(I)-IJ2I(J)).LE.IRAD.AND.
     *            IABS(IJ2J(I)-IJ2J(J)).LE.IRAD) THEN
	        IOB2(J)=-1
	        IF (IX(IJ2I(J),IJ2J(J),NFP2).GT.IPK) THEN
	          IPK=IX(IJ2I(J),IJ2J(J),NFP2)
	          JPK=J
	        END IF
	      END IF
 131	    CONTINUE
	   IOB2(JPK)=0
 130	CONTINUE
	IF (IPRT.EQ.1) THEN
	  DO 140 I=1,NOB2
 140	    WRITE(6,*) I,IJ2I(I),IJ2J(I),IOB2(I)
	END IF
	NOBS=0
	NSTART=1
C  Loop for cross correlating files
	DO 101 I=1,NOB1
	  IF (IOB1(I).EQ.-1) GO TO 101
C  a box of IRAD X IRAD around each object in file 1 is created
	  K1=IJ1I(I)-IRAD
	  K2=IJ1I(I)+IRAD
	  L1=IJ1J(I)-IRAD
	  L2=IJ1J(I)+IRAD
	  IRLC2=L2+2.5*IRAD
	  DO 102 J=NSTART,NOB2
	    IF (IOB2(J).NE.0) GO TO 102
C   quit when J co-ordinate is lager than upper limit
	    IF (IJ3J(J).GT.IRLC2) GO TO 101
C   check if any object in file 2 falls in the box
	    IF (IJ3J(J).LT.L1) GO TO 102
	    IF (IJ3J(J).GT.L2) GO TO 102
	    IF (IJ3I(J).LT.K1) GO TO 102
	    IF (IJ3I(J).GT.K2) GO TO 102
C  check RADIUS
	    RADCHECK=(IJ1I(I)-IJ3I(J))**2+(IJ1J(I)-IJ3J(J))**2
            IF (RADCHECK.GT.RADSQ)  GO TO 102
C first object identified in box
 108	    NOBS=NOBS+1
	    IOB1(I)=NOBS
	    IOB2(J)=NOBS
	    GO TO 101
 102	  CONTINUE
 101	CONTINUE
C
C   fill new array of ij's, using IOB to determine which obj to take
	NN=0
	DO 201 I=1,NOB1
	  IF (IOB1(I).GT.0) THEN
	    NN=NN+1
	    IJ1I(NN)=IJ1I(I)
	    IJ1J(NN)=IJ1J(I)
	    IOB1(NN)=IOB1(I)
	  END IF
 201	CONTINUE
	NN=0
	DO 202 I=1,NOB2
	  IF (IOB2(I).GT.0) THEN
	    NN=NN+1
	    IJ2I(NN)=IJ2I(I)
	    IJ2J(NN)=IJ2J(I)
	    IOB2(NN)=IOB2(I)
	  END IF
 202	CONTINUE
C  reshuffle objects 
 250	ILOOP=0
	DO 220 I=2,NOBS
	  IF (IOB1(I).LT.IOB1(I-1)) THEN
	    ILOOP=1
	    ITEMI=IJ1I(I-1)
	    ITEMJ=IJ1J(I-1)
	    ITEM=IOB1(I-1)
	    IJ1I(I-1)=IJ1I(I)
	    IJ1J(I-1)=IJ1J(I)
	    IOB1(I-1)=IOB1(I)
	    IJ1I(I)=ITEMI
	    IJ1J(I)=ITEMJ
	    IOB1(I)=ITEM
 	  END IF
	  IF (IOB2(I).LT.IOB2(I-1)) THEN
	    ILOOP=1
	    ITEMI=IJ2I(I-1)
	    ITEMJ=IJ2J(I-1)
	    ITEM=IOB2(I-1)
	    IJ2I(I-1)=IJ2I(I)
	    IJ2J(I-1)=IJ2J(I)
	    IOB2(I-1)=IOB2(I)
	    IJ2I(I)=ITEMI
	    IJ2J(I)=ITEMJ
	    IOB2(I)=ITEM
	  END IF
 220	CONTINUE
	IF (ILOOP.EQ.1) GO TO 250
	WRITE(6,*) '  CROSS CORRELATED FILES,',NOBS,' obects'
	WRITE(6,320) (I,IJ1I(I),IJ1J(I),IJ2I(I),IJ2J(I),I=1,NOBS)
 320 	FORMAT(1X,I4,5X,2I4,10X,2I4)
	NOB1=NOBS
	NOB2=NOBS
 999	RETURN1
	END
C//////////////////////////////////////////////////////////////////////
C
C
	SUBROUTINE CENTINT(NFR,IX,NU,NV,KF,RAD,RIIN,RJIN,INI,INJ,RMIN
     *                      ,RIOUT,RJOUT,IIOUT,IJOUT)
c	INTEGER*2 II(0:10),IJ(0:10),INI,INJ,IX(NU,NV,KF)
	INTEGER II(0:10),IJ(0:10),INI,INJ,IX(NU,NV,KF)
	REAL RI(0:10),RJ(0:10),RM(0:10),DI(0:10),DJ(0:10)
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
	include 'apert.inc'
C check if postion is larger than rad away:
	DI(0)=RIIN-FLOAT(INI)
	DJ(0)=RJIN-FLOAT(INJ)
	IF (ABS(DI(0)).LT.RAD.AND.ABS(DJ(0)).LT.RAD) THEN
	  RIOUT=RIIN
	  RJOUT=RJIN
	  IIOUT=INI
	  IJOUT=INJ
	  RETURN
	END IF
C other wise do iteration:
	RI(0)=RIIN
	RJ(0)=RJIN
	RM(0)=RMIN
	II(0)=INI
	IJ(0)=INJ
	DO 100 J=1,10
C for discrepancy >2.1 pixels, corrections are halved
	  DDI=0.
	  IF (ABS(DI(J-1)).GT.2.1) DDI=DI(J-1)*.5
	  DDJ=0.
	  IF (ABS(DJ(J-1)).GT.2.1) DDJ=DJ(J-1)*.5
C for delta > 3.5 pixels, only 1 pixel change is made
	  IF (ABS(DI(J-1)).GT.3.5.OR.ABS(DJ(J-1)).GT.3.5) THEN
	    II(J)=II(J-1)+SIGN(AMIN1(1.,ABS(DI(J-1))),DI(J-1))+.49
	    IJ(J)=IJ(J-1)+SIGN(AMIN1(1.,ABS(DJ(J-1))),DJ(J-1))+.49
	  ELSE
	    II(J)=RI(J-1)+.49-DDI
	    IJ(J)=RJ(J-1)+.49-DDJ
	  END IF
	  CALL PCENTR(NFR,IPO,IX,NU,NV,KF,RI(J),RJ(J),RM(J),DUM,
     *	               II(J),IJ(J),1,0.,0,0,4)
	  DI(J)=RI(J)-FLOAT(II(J))
	  DJ(J)=RJ(J)-FLOAT(IJ(J))
C criterior met
C	write(6,*) ' #',J,II(J),IJ(J),RI(J),RJ(J)
	  IF (ABS(DI(J)).LT.RAD.AND.ABS(DJ(J)).LT.RAD) GO TO 120
C check for oscillating co-ords
	  DO 101 K=J-1,0,-1
	    IF (II(J).EQ.II(K).AND.IJ(J).EQ.IJ(K)) GO TO 130
 101	  CONTINUE
 100	CONTINUE
 130	DISMIN=100000.
C check for min delta
	DO 110 K=1,J-1
	  IF ((DI(K)*DI(K)+DJ(K)*DJ(K)).LT.DISMIN)  KMIN=K
 110	CONTINUE
	J=KMIN
 120	RIOUT=RI(J)
	RJOUT=RJ(J)
	IIOUT=II(J)
	IJOUT=IJ(J)
	RETURN
	END
C
C//////////////////////////////////////////////////////////////////
C
C  TRIMMING POSITION FILE TO COVER A SMALLER FRAME
C
	SUBROUTINE PTRIM(*,NFP)
	CHARACTER IAN*1
        include 'objcat.inc' 
	CALL QUERYNFR(NFP,7,0,*999,*20001)
20001	IF (NFP.GT.nposfil) THEN
	  WRITE(6,*) '  *** OBJECT FILE NUMBER MUST BE <= ***'
	  RETURN1
	END IF
 600	WRITE(6,10) I1,I2
 10	FORMAT('  Enter pixel limits for I (dftl:',2I5,'): ',$)
	CALL READ2I(I1,I2,*999,*600)
 601	WRITE(6,20) J1,J2
 20	FORMAT('  Enter pixel limits for J (dftl:',2I5,'): ',$)
	CALL READ2I(J1,J2,*999,*601)
C  check the last one
	DO 100 I=NOB(NFP),1,-1
	  IF (IJOI(I,NFP).GT.I2.OR.IJOI(I,NFP).LT.I1.OR.
     *       IJOJ(I,NFP).GT.J2.OR.IJOJ(I,NFP).LT.J1) THEN
	        NOB(NFP)=NOB(NFP)-1
	  ELSE
	    GO TO 101
	  END IF
 100	CONTINUE
 101	CONTINUE
	NN=NOB(NFP)-1
	DO 102 I=NN,1,-1
	  IF (IJOI(I,NFP).GT.I2.OR.IJOI(I,NFP).LT.I1.OR.
     *        IJOJ(I,NFP).GT.J2.OR.IJOJ(I,NFP).LT.J1) THEN
 	        DO 103 J=I+1,NOB(NFP)
 	          IJOI(J-1,NFP)=IJOI(J,NFP)
 103	          IJOJ(J-1,NFP)=IJOJ(J,NFP)
	        NOB(NFP)=NOB(NFP)-1
	  END IF
 102	CONTINUE
 602	WRITE(6,12) NOB(NFP)
 12	FORMAT('  ...Position file trimmed to ',I4,' objects,'/
     *         '     Do you want to shift to edge=(1,1)? (y/n): ',$)
	call readstr(1,ian,*999,*602)
	IF (IAN.EQ.'y') THEN
	  DO 104 I=1,NOB(NFP)
	    IJOI(I,NFP)=IJOI(I,NFP)-I1+1
 104        IJOJ(I,NFP)=IJOJ(I,NFP)-J1+1
	  WRITE(6,13) I1,J1
 13	FORMAT(' ... Position file shifted so that old(',I4,',',I3,
     *           ') = (1,1)')
 	END IF
 999	RETURN1
	END
C//////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE FOR EDITING POSITION FILE
C
	SUBROUTINE PEDIT(*,NFP,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),NNDO(200)
	INTEGER IX(NU,NV,KF),NNDO(200)
	CHARACTER*1 CODE
	CHARACTER*60 STR
        include 'objcat.inc' 
	CALL QUERYNFR(NFP,KF,0,*300,*20001)
20001	IF (NFP.GT.nposfil) THEN
	  WRITE(6,*) '  *** OBJECT FILE NUMBER MUST BE < ***'
	  RETURN1
	END IF
	IDEL=0
 100	WRITE(6,*) ' ENTER editing code: a=add, x=delete, '
     *            ,'c=change, t=type, r=rearrange, <cr> = end'
	call readstr(1,code,*300,*100)
	IF (CODE.EQ.' ') GO TO 300
	IF (CODE.EQ.'a') THEN
 600	  WRITE(6,3) 
 3	FORMAT('  ENTER i j co-ordinates, integers: ',$)
	  call read2i(ii,jj,*100,*600)
	  NOB(NFP)=NOB(NFP)+1
	  IJOI(NOB(NFP),NFP)=II
	  IJOJ(NOB(NFP),NFP)=JJ
	  IDOB(NOB(NFP),NFP)=1
	  GO TO 100
	END IF
C   delete objects
	IF (CODE.EQ.'x') THEN
	  WRITE(6,4)
 4	FORMAT('  ENTER object numbers to be deleted: ',$)
	  STR=' '
	  CALL MFNUM(STR,60,NNDO,200,NND,0)
	  DO 102 I=1,NND
 102	  IDOB(NNDO(I),NFP)=-1
	  IDEL=1
	  GO TO 100
	END IF
	IF (CODE.EQ.'c') THEN
 601	  WRITE(6,5)
 5	FORMAT('  ENTER object numbers to be changes: ',$)
	  STR=' '
	  CALL MFNUM(STR,60,NNDO,200,NND,0)
	  DO 103 I=1,NND
 602	  WRITE(6,6) 	NNDO(I),IJOI(NNDO(I),NFP),IJOJ(NNDO(I),NFP)
     *                  ,IDOB(NNDO(I),NFP)
 6	FORMAT(' object #',I3,' :',3X,2I4,2X,I2,'  enter new I J')
	  call read2i(ii,jj,*100,*602)
	  IJOI(NNDO(I),NFP)=II
	  IJOJ(NNDO(I),NFP)=JJ
 103	  IDOB(NNDO(I),NFP)=IDOB(NNDO(I),NFP)+2
	  GO TO 100
	END IF
	IF (CODE.EQ.'t') THEN
	  STR=' '
	  CALL PTYPE(*88,NFP,STR,STR,0,0,0,IX,NU,NV,KF)
 88	  GO TO 100
	END IF
 	IF (CODE.EQ.'r') THEN
C delete object with ID=-1
	   NOBT=NOB(NFP)
	   I=0
 104	   I=I+1
	   IF (I.LE.NOB(NFP)) THEN
	    IF (IDOB(I,NFP).EQ.-1) THEN
	    DO 105 K=I+1,NOB(NFP)
	      IJOI(K-1,NFP)=IJOI(K,NFP)
	      IJOJ(K-1,NFP)=IJOJ(K,NFP)
 105	      IDOB(K-1,NFP)=IDOB(K,NFP)
  	    NOB(NFP)=NOB(NFP)-1
	    I=I-1
	    END IF
	    GO TO 104
	   END IF
 1041	  CONTINUE
C  rearrange object order according to J co-ordinate
	  call arranpos(nob(nfp),ijoi(1,nfp),ijoj(1,nfp),idob(1,nfp))
c	  DO 106 I=1,NOB(NFP)
c	    IEX=0
c	    DO 107 J=1,NOB(NFP)-1
c	      IF (IJOJ(J,NFP).LE.IJOJ(J+1,NFP)) GO TO 107
c	      IEX=1
c	      IJOIT=IJOI(J,NFP)
c	      IJOJT=IJOJ(J,NFP)
c	      IDOBT=IDOB(J,NFP)
c	      IJOI(J,NFP)=IJOI(J+1,NFP)
c	      IJOJ(J,NFP)=IJOJ(J+1,NFP)
c	      IDOB(J,NFP)=IDOB(J+1,NFP)
c	      IJOI(J+1,NFP)=IJOIT
c	      IJOJ(J+1,NFP)=IJOJT
c	      IDOB(J+1,NFP)=IDOBT
c 107	    CONTINUE  
c	    IF (IEX.EQ.0) GO TO 109
c 106	  CONTINUE
 109	  GO TO 100
	END IF
	WRITE(6,*) ' ***** INCORRECT INPUT *****'
	GO TO 100
 300	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO READ POSITION FILE FOR PHOTOMETRY
C     IPAR=0 READ INTEGER CO-ORDS
C     IPAR=1 READ REAL CO-ORDS
C     IPAR=-1 READ INTEGER CO-ORDS FROM AUPH FILE
C     IPAR=-2 READ READ CO-ORDS FROMM AUPH FILE
c
c    jan 1999, modified to include section number and information
c      in pos file
c    feb 24 1999, modify file name creator to include recognizing
c                 section number appendage.  new call parameter js1
c                 added to allow manual setting of section number.
	SUBROUTINE RPOF(*,NFR,STRF,js1,IPAR)
 	CHARACTER*28 FILEN,FILT
	CHARACTER*60 STRF,string*80,secstr*1
	CHARACTER*3 APP
        include 'objcat.inc' 
	include 'picdir.inc'
	include 'mosaic.inc'
c	write(6,*) ' js1 ',js1,' nsct(nfr) ', nsct(nfr)
	IF (NFR.LE.0) THEN
 600	  WRITE(6,10) 
 10	FORMAT(' ..Enter position file number: ',$)
	  call read1i(nfr,*999,*600)
	END IF
	IF (NFR.GT.nposfil.OR.NFR.LE.0) THEN
	  WRITE(6,*) '  *** OBJECT FILE NUMBER MUST BE <= ***'
	  RETURN1
	END IF
	IF (IPAR.GE.0) THEN
	  APP='pos'
	ELSE
	  APP='phm'
	END IF
 601	CALL READFN2(FILT,STRF(1:28),FILEN,APP,'i',28,*999,*2001,*2002)
2001	strf=' '
	go to 601
c   check for section appendage
2002    if (js1.eq.0) js1=nsct(nfr)
c hard wire js1 to 0 (this is causing problem, as it is not passed
c        through as 0
	js1=0
c	write(6,*) ' js1 ',js1,' nsct(nfr) ', nsct(nfr)
c check if name is .pos
    	  namelen=lnblnk(filen)
	  if (filen(namelen-2:namelen).ne.app)
     *        filen=filen(1:namelen)//'.'//app
	if (js1.ne.0) then
	  istatus=encode(secstr,float(js1),1,0,idum)
	  write(6,41) js1
 41	format('  ...Reading section',i3,' pos file...')
	else
	  secstr=' '
	end if
	nlength=lnblnk(filen)
	if (secstr.ne.' ') filen=filen(1:nlength)//'.'//secstr
	write(6,*) ' posfil name ',filen
 	OPEN(UNIT=29,FILE=FILEN,status='OLD',ERR=2003)
	write(6,*) ' rpof: file opened '
	go to 2004
c  did not find file, check if there are files with section appendage 1
c   or if there is a file with no section appendage
2003    if (secstr.eq.' ') then
	  filen=filen(1:lnblnk(filen))//'.1'
	else
	  filen=filen(1:nlength)
	end if
 	OPEN(UNIT=29,FILE=FILEN,status='OLD',ERR=9000)
	write(6,38) js1,filen
 38	format(' +++ WARNing +++ pos file for section',i2,
     *     ' not found, file __',a18,'__ read instead')
2004	IF (IPAR.EQ.0) THEN
c read header
	  READ(29,4,END=998,err=991) NOBB,PCOMMENT(NFR)
 4	FORMAT(I6,A60)
c read additional header lines if exist (preceeded by #)
 150	  read(29,'(a80)',end=998,err=991) string
	  if (string(1:1).eq.'#') then
c additional header line 1: subsectioning information
	    if (string(2:8).eq.'secinfo') then
	      read(string(14:80),*,err=150) nsecpos(nfr),isecpos1(nfr), 
     *          jsecpos1(nfr),isecpos2(nfr),jsecpos2(nfr),nedgepos(nfr)
c verify that the pos section number is the same as image section number
	      if (nsecpos(nfr).ne.nsct(nfr)) then
	        write(6,39) nsecpos(nfr),nsct(nfr)
 39	format('  +++ warning, section number mismatch -- pos:',i2,
     *     ' image:',i2)
	      else
c  now check section parameters
	        if ((isecpos1(nfr).ne.isec1(nsct(nfr))).or.
     *              (isecpos2(nfr).ne.isec2(nsct(nfr))).or.
     *              (jsecpos1(nfr).ne.jsec1(nsct(nfr))).or.
     *              (jsecpos2(nfr).ne.jsec2(nsct(nfr)))) then
	        write(6,40) isec1(nsct(nfr)),jsec1(nsct(nfr)),
     *               isec2(nsct(nfr)),jsec2(nsct(nfr)),
     *           isecpos1(nfr),jsecpos1(nfr),isecpos2(nfr),jsecpos2(nfr)
 40	format('  +++ warning, section boundries mismatch:'/
     *         '         IMAGE:  ',4i6,/'         POSFIL: ',4i6)
	        end if
	      end if
	    end if
	    if (string(2:8).eq.'posinfo') then
	      read(string(10:80),*,err=150) ilpos(nfr),jlpos(nfr),
     *              iupos(nfr),jupos(nfr),ipl,jpl,ipu,jpu
	      write(6,44) ilpos(nfr),jlpos(nfr),
     *              iupos(nfr),jupos(nfr),ipl,jpl,ipu,jpu
 44	format('  Section posfil limits (I,J): ',2I6,2x,2I6,/
     *         '     in world co-ordinates   : ',2I6,2x,2I6)
	    end if
	    goto 150
	  else
	    backspace 29
	  end if
c
	  DO 101 I=1,nobmax
 	    READ(29,*,END=201,err=991) IJOI(I,NFR),IJOJ(I,NFR),
     *               IDOB(I,NFR)
 101	  CONTINUE
	ELSE IF (IPAR.EQ.1) THEN
	  READ(29,2) PCOMMENT(NFR) 
2	FORMAT(1X,A60)
	  DO 102 I=1,nobmax
	    READ(29,*,END=201,ERR=201) NUMDUM,XI,YI
	    IJOI(I,NFR)=INT(XI+.5)
 	    IJOJ(I,NFR)=INT(YI+.5)
	    IDOB(I,NFR)=3
 102	  CONTINUE
	ELSE IF (IPAR.EQ.-1) THEN
	  READ(29,2) PCOMMENT(NFR)
	  READ(29,1) IDUM
	  DO 103 I=1,nobmax
	    READ(29,1,END=201) IDUM
	    READ(29,*,END=201,ERR=201) IJOI(I,NFR),IJOJ(I,NFR)
	    READ(29,1,END=201) IDUM 
	    IDOB(I,NFR)=0
 103	  CONTINUE
	END IF
 1	FORMAT(A1)
 201	WRITE(6,5) PCOMMENT(NFR)
	NOB(NFR)=I-1
	WRITE(6,6) NOB(NFR), IJOI(1,NFR),IJOJ(1,NFR)
 	CLOSE(UNIT=29)
 5	FORMAT(1X,A60)
 6	FORMAT('  # of objs',I6,'   first obj: ',2I5)
 202 	RETURN1
 9000	WRITE(6,*) '   ****** NO SUCH FILE IN DISK *****'
	RETURN1
 991	write(6,*) '  *** error in reading file ***'
 	CLOSE(UNIT=29)
	return1
 998	WRITE(6,*) '   ****** POSITION FILE IS EMPTY ******'
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////
C
C SUBOUTINE FOR READING POSITION FILE WITH FREE FORMAT
C
	SUBROUTINE FRPOF(*,NFR)
	CHARACTER FILNAM1*18,STRING*232,FILNAM1A*18
	character*64 string2,string1,fstr12,fstr13
	DIMENSION IB(232),IE(232)
        include 'objcat.inc' 
	IF (NFR.LE.0) THEN
 600	  WRITE(6,10) 
 10	FORMAT(' ..Enter position file number: ',$)
	  call read1i(nfr,*999,*600)
	END IF
	IF (NFR.GT.nposfil.OR.NFR.LE.0) THEN
	  WRITE(6,*) '  *** OBJECT FILE NUMBER MUST BE <= ***'
	  RETURN1
	END IF
 6001	WRITE(6,20) FILNAM1
 20	FORMAT('  Enter (FULL) position filename (deft: ',A20,'): ',$)
	call readstrd(18,filnam1a,*999,*6001)
	IF (FILNAM1A.NE.' ') FILNAM1=FILNAM1A
	OPEN(UNIT=30,FILE=FILNAM1,status='OLD',ERR=900)
	CLOSE(UNIT=30)
	GO TO 601
 900	  WRITE(6,*) ' **** ERR in opening file ****'
	  GO TO 600
 601	WRITE(6,21) LINIT1,LINCR1
 21	FORMAT('  Enter initial data line and line increment (dflt:',
     *          2I3,'): ',$)
	CALL READ2I(LINIT1,LINCR1,*999,*601)
 603	WRITE(6,22) NXC,NYC
 22	FORMAT('  Enter column numbers for x and y (dflt:',2I3,'): ',$)
	CALL READ2I(NXC,NYC,*999,*603)
	OPEN(UNIT=30,FILE=FILNAM1,status='OLD',ERR=900)
	DO 90 I=1,LINIT1-1
 90	  READ(30,18,END=102) STRING
 18	FORMAT(A232)
	DO 100 I=1,nobmax
 	  READ(30,18,END=102) STRING
	  CALL FSTR1(STRING,232,IB,IE,KK)
	  IF (KK.LT.NYC) GO TO 100
	  istatus=encode(string1,float(ie(nxc)-ib(nxc)+1),1,0,idum)
	  fstr12='(F'//string1(1:lnblnk(string1))//'.0)'
	  READ(STRING(IB(NXC):IE(NXC)),fstr12,ERR=100,END=102) XX
	  IJOI(I,NFR)=NINT(XX)
	  istatus=encode(string2,float(ie(nyc)-ib(nyc)+1),1,0,idum)
	  fstr13='(F'//string2(1:lnblnk(string2))//'.0)'
	  READ(STRING(IB(NYC):IE(NYC)),fstr13,ERR=100,END=102) XX
	  IJOJ(I,NFR)=NINT(XX)
	  IDOB(I,NFR)=0
	  DO 91 J=1,LINCR1-1
 91	    READ(30,18,END=102) STRING
 100	CONTINUE
 102	NOB(NFR)=I-1
	PCOMMENT(NFR)='  Read from file - '//FILNAM1
c 12	FORMAT(F<IE(NXC)-IB(NXC)+1>.0)
c 13	FORMAT(F<IE(NYC)-IB(NYC)+1>.0)
	CLOSE(UNIT=30)
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////
C
C SUBOUTINE FOR rotating  POSITION FILE
C
	SUBROUTINE rotpof(*,NFR,kf)
        include 'objcat.inc' 
	include 'picdir.inc'
	CALL QUERYNFR(NFR,kf,0,*999,*600)
 600	WRITE(6,20) rott
 20	FORMAT('  Enter rotation in deg (CC=+) [',F8.2,'] : ',$)
	CALL READ1R(rott,*999,*600)
	rot=rott/57.2958
 601	write(6,21) xcent,ycent
 21	format('  Enter center of rotation, (0,0)=cen of pic [',
     *        2f7.1,']: ',$)
	call read2r(xcent,ycent,*999,*601)
	if (xcent.le.0.001.and.ycent.le.0.001) then
	  xcen=0.5*nii(nfr)
	  yxen=0.5*njj(nfr)
	else
	  xcen=xcent
	  ycen=ycent
	end if
c rotate positions
	do 100 i=1,nob(nfr)
c compute vector wrt center
	  xd=ijoi(i,nfr)-xcen
	  yd=ijoj(i,nfr)-ycen
          dist=sqrt(xd*xd+yd*yd)
          theta=atan2(xd,yd)+rot
c rotated position
          ijoi(i,nfr)=nint(dist*sin(theta)+xcen)
          ijoj(i,nfr)=nint(dist*cos(theta)+ycen)
 100    continue
 999	return1
	end 
c///////////////////////////////////////////////
c  subroutine to match one position file to another image
c    input: object number for 2 objs from 1 frame (with pof)
c           plus the int co-ordinates of the equivalent
c           objs from the other frame
c    method:  centroid position for the 4 objects are computed
c             (x11,y11), (x12,y12), and (x21,y21) and (x22,y22).
c         compute (1) scale stretch: d1/d2
c                 (2) compute delta vector angle
c
c         transform: each position from 1 is stretched and
c                    rotated relative to object 1 of frame 2.
c         positions attributed to frame 2, no re-ordering.
	SUBROUTINE transpof(*,NFR1,nfr2,ix,nu,nv,kf)
c	integer*2 ix(nu,nv,kf),ix21t,iy21t,ix22t,iy22t
	integer ix(nu,nv,kf),ix21t,iy21t,ix22t,iy22t
        include 'objcat.inc' 
	include 'picdir.inc'
	CALL QUERYNFR(NFR1,kf,1,*999,*600)
 600	CALL QUERYNFR(NFR2,kf,2,*999,*601)
 601	write(6,1) nfr1,nref11,nref12
 1	format('  Enter 2 ref. obj #s from fr.',i3,' [',2i5,']: ',$)
	call read2i(nref11,nref12,*999,*601)
 602	write(6,2) nfr2,ix21,iy21
 2	format('  Enter I,J position of ref 1 in fr.',i3,
     *        '[',2i5,']: ',$)
	call read2i(ix21,iy21,*999,*602)
 603	write(6,3) nfr2,ix22,iy22
 3	format('  Enter I,J position of ref 2 in fr.',i3,
     *        '[',2i5,']: ',$)
	call read2i(ix22,iy22,*999,*603)
c find centroid of each:
	ix21t=ix21
	ix22t=ix22
	iy21t=iy21
	iy22t=iy22
	call pcentr(nfr1,0,ix,nu,nv,kf,rx11,ry11,dum,dum1,
     *      ijoi(nref11,nfr1),ijoj(nref11,nfr1),1,5.,55,1,15)
	call pcentr(nfr1,0,ix,nu,nv,kf,rx12,ry12,dum,dum1,
     *      ijoi(nref12,nfr1),ijoj(nref12,nfr1),1,5.,55,1,15)
	call pcentr(nfr2,0,ix,nu,nv,kf,rx21,ry21,dum,dum1,
     *      ix21t,iy21t,1,5.,55,1,15)
	call pcentr(nfr2,0,ix,nu,nv,kf,rx22,ry22,dum,dum1,
     *      ix22t,iy22t,1,5.,55,1,15)
c out put centroid values
	write(6,4) nfr1,nref11,ijoi(nref11,nfr1),ijoj(nref11,nfr1),
     *      rx11,ry11,nref12,ijoi(nref12,nfr1),ijoj(nref12,nfr1),
     *      rx12,ry12,nfr2,ix21,iy21,rx21,ry21,ix22,iy22,rx22,ry22
 4	format('  Centroids: fr',i3,' obj#',i4,' @(',2i5,'):',2f10.4,
     *        /'                   obj#',i4,' @(',2i5,'):',2f10.4,/
     *         '             fr',i3,'          @(',2i5,'):',2f10.4,/
     *         '                            @(',2i5,'):',2f10.4)
c compute scale:
	scale=sqrt(((rx22-rx21)**2+(ry22-ry21)**2)/
     *             ((rx12-rx11)**2+(ry12-ry11)**2))
c compute rotation
	an2=atan2(rx22-rx21,ry22-ry21)
	an1=atan2(rx12-rx11,ry12-ry11)
	rot=an2-an1
	write(6,5) scale,an1*57.2958,an2*57.2958,rot*57.2958
 5	format('  Scale (2/1):',f7.4/'  Vec1:',f8.2,'  Vec2:',
     *        f8.2,' Rot(2-1):',f8.2)
c  do transformation, using object 1 as origin
	delx=rx21-rx11
	dely=ry21-ry11
	do 100 i=1,nob(nfr1)
	  xx=float(ijoi(i,nfr1))+delx
	  yy=float(ijoj(i,nfr1))+dely
	  dist=scale*sqrt((xx-rx21)**2+(yy-ry21)**2)
          theta=atan2(xx-rx21,yy-ry21)+rot
c rotated position
          ijoi(i,nfr2)=nint(dist*sin(theta)+rx21)
          ijoj(i,nfr2)=nint(dist*cos(theta)+ry21)
	  idob(i,nfr2)=idob(i,nfr1)
 100	continue
	nob(nfr2)=nob(nfr1)
	write(6,*) '  Transform completed '
 999	return1
	end 
C///////////////////////////////////////////////////////////////////
C
C SUBOUTINE FOR LINEAR SCALING OF POSITION FILE
C
	SUBROUTINE SCALEPF(*,NFR,kf)
        include 'objcat.inc' 
	CALL QUERYNFR(NFR,kf,0,*999,*600)
 600	WRITE(6,20) SCALE
 20	FORMAT('  Enter scaling constant [',F8.4,'] : ',$)
	CALL READ1R(SCALE,*999,*600)
	DO 100 I=1,NOB(NFR)
	  IJOI(I,NFR)=NINT(IJOI(I,NFR)*SCALE)
	  IJOJ(I,NFR)=NINT(IJOJ(I,NFR)*SCALE)
 100	CONTINUE
	PCOMMENT(NFR)=PCOMMENT(NFR)(1:40)//' SCALED'
 999	RETURN1
	END
C/////////////////////////////////////////////////////////////////
C
C  Driving routine for merging close-neighbouring objects in posfil
C
	SUBROUTINE MEROBJD(*,NFR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <= FOR POSITION FILE'
	  RETURN1
	END IF
	CALL MERGEOBJ(NFR,IX,NU,NV,KF,NJJ(NFR),IJOI(1,NFR),
     *               IJOJ(1,NFR),NOB(NFR))
 999	RETURN1
	end
C////////////////////////////////////////////////////////////////////////
C
C   SUBROUTINE FOR MIRROR INVERSION of position file
C           IPAR=0 : X(I,J)NEW = X(NI-I+1,J) MIRRORED IN J-AXIS
C           IPAR=1 : X(I,J)NEW = X(I,NJ-J+1) MIRRORED IN I-AXIS
C
	SUBROUTINE MIRRORPF(*,NFR,IPAR,kf)
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	CALL QUERYNFR(NFR,kf,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <= FOR POSITION FILE'
	  RETURN1
	END IF
	IF (IPAR.EQ.1) THEN
	  DO 102 N=1,nob(nfr)
	    ijoj(n,nfr)=njj(nfr)-ijoj(n,nfr)+1
 102	  continue
	ELSE
	  DO 103 n=1,nob(nfr)
	    ijoi(n,nfr)=nii(nfr)-ijoi(n,nfr)+1
 103	  continue
	end if
 999	RETURN1
	END
C////////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO TRANSPOSE position files
C       IX(I,J)NEW=IX(J,I)OLD
C
	SUBROUTINE TRANSPPF(*,NFR,kf)
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <= FOR POSITION FILE'
	  RETURN1
	END IF
	do 100 n=1,nob(nfr)
	  itemp=ijoi(n,nfr)
	  ijoi(n,nfr)=ijoj(n,nfr)
	  ijoj(n,nfr)=itemp
 100	continue
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO ROTATE position file by 90 OR 180 DEG 
C     IPAR=2  ROTATE 180 DEG
C     IPAR=1  C-CLOCKWISE (I,J)NEW=(NJ-J+1,I)OLD
C     IPAR=0  CLOKWISE  (I,J)NEW=(J,NI-I+1)OLD
C
	SUBROUTINE ROT90PF(*,NFR,IPAR,kf)
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <= FOR POSITION FILE'
	  RETURN1
	END IF
c! ROTATE 180 DEG 
	IF (IPAR.EQ.2) THEN 
	  NIT=nii(nfr)+1
	  NJT=njj(nfr)+1
	  DO 101 n=1,nob(nfr)
	    ijoi(n,nfr)=nit-ijoi(n,nfr)
	    ijoj(n,nfr)=njt-ijoj(n,nfr)
 101	  continue
	ELSE 
 600	  write(6,10)
 10	format('  Enter original I,J dimension of image: ',$)
	  call read2i(ni,nj,*999,*600)
	  IF (IPAR.EQ.0) THEN  
c ! CLOCKWISE  ??? there is an apparent inconsistency here from the definition of the ROT90
c   subroutine for picture aperation, but it seems to give the right answer...
	    NJT=NJ+1
	    DO 102 n=1,nob(nfr)
	      itemp=ijoj(n,nfr)
	      ijoj(n,nfr)=ijoi(n,nfr)
	      ijoi(n,nfr)=njt-itemp
 102	    continue
	  ELSE                  
c ! COUNTER-CLOCKWISE
	    NIT=NI+1
	    DO 103 n=1,nob(nfr)
	      itemp=ijoi(n,nfr)
	      ijoi(n,nfr)=ijoj(n,nfr)
	      ijoj(n,nfr)=nit-itemp
 103	    continue
	  end if
	end if
 999	RETURN1
	END

c//////////////////////////////////////////////////////////////
c
c subroutine to rearrange objects
	subroutine arranpos(nob,ijoi,ijoj,idob)
c	integer*2 ijoi(1),ijoj(1),idob(1)
	integer ijoi(1),ijoj(1),idob(1)
C  rearrange object order according to J co-ordinate
	  DO 106 I=1,NOB
	    IEX=0
	    DO 107 J=1,NOB-1
	      IF (IJOJ(J).LE.IJOJ(J+1)) GO TO 107
	      IEX=1
	      IJOIT=IJOI(J)
	      IJOJT=IJOJ(J)
	      IDOBT=IDOB(J)
	      IJOI(J)=IJOI(J+1)
	      IJOJ(J)=IJOJ(J+1)
	      IDOB(J)=IDOB(J+1)
	      IJOI(J+1)=IJOIT
	      IJOJ(J+1)=IJOJT
	      IDOB(J+1)=IDOBT
 107	    CONTINUE  
c  iex=0 means all objects are in order -- exit
	    IF (IEX.EQ.0) GO TO 999
 106	  CONTINUE
 999	return
	end
c/////////////////////////////////////////////////////////////
c  subroutine to identify object number, given I,J co-ordinates
c
	subroutine objnum(*,nfr,iint,jint,ix,nu,nv,kf)
c	integer*2 ix(nu,nv,kf)
	integer ix(nu,nv,kf)
	include 'objcat.inc'
	CALL QUERYNFR(nfr,KF,0,*999,*2001)
 2001	IF (NFP.GT.nposfil) THEN
	  WRITE(6,*) '  *** OBJECT FILE NUMBER MUST BE <= ',nposfil
	  RETURN1
	END IF
c get co-ordinate
	if (iint.le.0.or.jint.le.0) then
 600	  write(6,1) iin,jin
 1	format('  Enter I and J co-ordinate [',2i5,']: ',$)
	  call read2i(iin,jin,*999,*600)
	else
	  iin=iint
	  jin=jint
	end if
c locate object number
	call locobj(iin,jin,num,2,nob(nfr),ijoi(1,nfr),ijoj(1,nfr))
c output
	write(6,2) num,ijoi(num,nfr),ijoj(num,nfr),
     *             ix(ijoi(num,nfr),ijoj(num,nfr),nfr)
 2	format('  Nearest object: ppp#',i5,' @(i,j) ',2i6,
     *      ', pix value: ',i7)
 999	return1
	end

c////////////////////////////////////////////////////////////
c
c  produces the world co-ordinate limits from the section limits
c    and size
c
	subroutine worldpos(nfr,nsec,ip1,jp1,ip2,jp2)
	include 'objcat.inc'
	include 'mosaic.inc'
	if (nsec.gt.0) then
	  if (isubim.eq.0) then
	    write(6,1)
 1	format('  +++ no subimaging parameter +++ .pos section field'
     *        ,' info not computed +++')
	    return
	  else
	    ip1=isec1(nsec)+ilpos(nfr)-1
	    jp1=jsec1(nsec)+jlpos(nfr)-1
	    ip2=ip1+iupos(nfr)-ilpos(nfr)
	    jp2=jp1+jupos(nfr)-jlpos(nfr)
	  end if
	else
	  ip1=ilpos(nfr)
	  jp1=jlpos(nfr)
	  ip2=iupos(nfr)
	  jp2=jupos(nfr)
	end if
	return
	end
