C///////////////////////////////////////////////////////////////////////
C
C    SUBROUTINE to select variable PSFs by computing the pc2 plot of 
c                  a list of stars
c        ipar=0, interactive
c        ipar=1, auto
c
C
	SUBROUTINE psfc2(NFR,ipsf,jpsf,npsf,nob,iapmaxt,ipar,
     *              IX,NU,NV,kf)
	parameter (maxn=1000)
	INTEGER IX(NU,NV,kf),ipsf(*),jpsf(*),IDS(maxn),
     *    ICLP(maxn),ICLS(maxn),
     *    NMASK(500,500),NNEI(maxn),idelete(maxn)
	integer nng(100),npsf(*)
	DIMENSION  RI(30),RMAG(30,maxn),PK(maxn),RSMAG(maxn),
     *   REALI(maxn),REALJ(maxn),SKY(maxn),ZSIG(maxn),
     *    DELMAG(maxn),EXMAG(maxn),SP(0:30,maxn)
     *     ,SKYERR(maxn),SUMDEL(maxn),SKARAY(50000),PIXN(30),
     *     irefv(maxn),refstv(30,maxn),refstt(30)
     *     ,idsrefv(maxn),psfpxv(maxn),psfpyv(maxn),refpkv(maxn)
	CHARACTER*18 DEV,HPLOT,SPLOT,filout,ians*1,dumstr*60
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	COMMON/PLOTDEV/ HPLOT,SPLOT,ipinit
	INCLUDE 'picdir.inc'
	include 'apert.inc'
	include 'pipeparm.inc'
c	equivalence (iscr(1),rmag(1,1)),(iscr(450001),sp(0,1))
	CDIAM=NAPCEN
	nvpsf=min0(nvpsf,4)
	iprt=0
	NI=NII(NFR)
	NJ=NJJ(NFR)
	nobb=min0(maxn,nob)
	IF (nob.GT.maxn) THEN
          WRITE(6,*) '  *** # of psfs >',maxn,', rest not used ***'
	ELSE IF (nob.LE.0) THEN
	  WRITE(6,*) '  **** no psf chosen ***'
	  RETURN
	END IF
	if (iapmaxt.eq.0) then
	 if (ircspipe.eq.0) then
	write(6,*) ' ircspipe ',ircspipe,' iapmaxt ',iapmaxt
     *                       ,' iapmaxpipe ',iapmaxpipe
 602	   WRITE(6,11) IAPMIN,IAPIS,IAPMAX
 11	FORMAT(' Initial obj diameter:',I2,', Max sky diam=(max obj dia'
     *          ,'m)+',I2,
     *	      /'  Enter MAX obj DIAMETER in integer pixels [',i3,']: ',$)
	    CALL READ1I(IAPMAX,*999,*602)
	  else
c  upse pipeline value
	    iapmax=iapmaxpipe
	write(6,*) ' II  ircspipe ',ircspipe,' iapmaxt ',iapmaxt
     *                       ,' iapmaxpipe ',iapmaxpipe
	  end if
	else
	  iapmax=iapmaxt
	end if
	IF (IAPMAX.LE.IAPMIN) GO TO 602
	IAP2=IAPMAX+IAPIS+3
	IF (IAP2.GT.maxap) THEN
	  WRITE(6,*) '  **** Diameter too large ******'
	  GO TO 602
	END IF
c check if there is any 00 co-ordinate, if so, issue warning and
c    do not continue
	do 180 i=1,nobb
	  if (ipsf(i).le.0.or.jpsf(i).le.0) then
	    write(6,67) i,ipsf(i),jpsf(i)
 67	format('  +++ warning: invalid position in psf file, # ',i3,' @'
     *        ,2i5,/'      PSF checking not done +++')
	    return
	  end if
 180	continue
c  recentering 
	CDIAM=5.
c  pcentr needs int*2 positions
 500	CALL PCENTR(NFR,0,IX,NU,NV,KF,REALI(1),REALJ(1),RSMAG(1),DUM,
     *              ipsf(1),jpsf(1),1,CDIAM,31,0,4)
        CALL PCENTR(NFR,0,IX,NU,NV,KF,REALI(2),REALJ(2),RSMAG(2),DUM,
     *              ipsf(2),jpsf(2),NOBB-1,0.000000,0,0,4)
c	write(6,*) '  initializing centroiding done...'
	do 280 i=1,nobb
	  item=ipsf(i)
	  jtem=jpsf(i)
	  if (ircspipe.ne.1) then
 	    CALL rcentr(i,item,jtem,reali(i),realj(i),rsmag(i),
     *      idumb,1,nfr,IX,NU,NV,kf)
	  else
 	    CALL rcentr(i,item,jtem,reali(i),realj(i),rsmag(i),
     *      idumb,0,nfr,IX,NU,NV,kf)
	  end if
 280	continue
c	write(6,*) '  recentroiding done...'
C reset sky aperture
 5994	IAP2=IAPMAX+IAPIS+3
C create sky aperture
	CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,IPRT)
C number of apertures
	NAP=MIN0(30,(IAPMAX-IAPMIN+IDELD)/IDELD)
	IEXAP1=MIN0(IEXAP,NAP)
C
C   MAKE APERTURES
C
	DO 100 I=1,NAP
 100	  IAP1(I)=IAPMIN+(I-1)*IDELD
	IAP1(31)=IAP1(NAP)+3
C  set inner sky aperture radius
	IF (IAP2-IAP1(NAP).GT.8) THEN
	  NNAP=31
	ELSE
	  NNAP=NAP
	END IF
	CALL APARAY(IAP1(NNAP),IT1(1,NNAP),IROW1(NNAP),QDUM,RDUM,PDUM
     *                 ,NA(NNAP),IPRT)
c    !Max radius
	IRMAX=IAP1(NAP)          
	IRMAXSQ=IRMAX*IRMAX          
c  ! array size for neighbor mask
	MASKSIZE=MIN0(250,2*IAP1(NAP)+1)     
	iexapf=min0(iexap,nap)
c  compute average sky for purpose of checking in case
c   bright stars or bad columns
c backup sky from circle, from 2 positions 
c       I1=NI/3
c       J1=NJ/3
c       CALL RCSKY(1,BKG1,BSIG,1,I1,J1,NI,NJ,IX(1,1,nfr),NU,NV,SKARAY,
c    *           50000,nsky,0,IPR)
c       I1=2*NI/3
c       J2=2*NJ/3
c       CALL RCSKY(1,BKG,BSIG,1,I1,J1,NI,NJ,IX(1,1,nfr),NU,NV,SKARAY,
c    *             50000,nsky,0,IPR)
c       BKG=0.5*(BKG1+BKG)
c	bkg=bkg*.5
C
c  July 11, 2007, updated backup sky calculation, as per the change
c      in ppphot.f July 5, 2007
        nfm=0
        call rowskyval(nfr,nfm,100,50,nii(nfr)-50
     *           ,bkgtrue,bsig,ix,nu,nv,kf,*821)
 821    WRITE(6,*) '  Back-up sky value: ',BKGtrue,bsig
	bkg=0.5*bkgtrue
C...............................................................
C  Big loop #1
C  do photometry for each objects
C
	DO 101 I=1,NOBB
c ! Maximum allowable final aperture
	  MAXIDS=nap         
	  II=ipsf(i)
	  JJ=jpsf(i)
	  if (ii.le.0.or.ii.gt.ni.or.jj.le.0.or.jj.gt.nj)
     *         then
	    write(6,87) i,ii,jj
 87	format('  +++ obj#',i4,' at',2i4,
     *             ' outside of image: photometry not done ')
	    ids(i)=1
	    reali(i)=ii
	    realj(j)=jj
	    do 1011 k=1,nap
	      rmag(k,i)=99.
 1011	    continue
	    go to 101
	  end if
C  check for neighbours
	  CALL NNEIGH(NNEI(I),NNG,II,JJ,NOBB,ipsf,jpsf,
     *          I,IRMAX,IRMAXSQ)
C  determine sky
	  CALL RCSKY(1,SKY(I),ZSIG(I),NNAP,II,JJ,NI,NJ,IX(1,1,nfr)
     *                    ,NU,NV,SKARAY,50000,nsky,0,IPR)
c check if sky is reasonable (ie > 0.5 of average)
	  if (sky(i).lt.bkg) then
c  reduce aperture to 2/3 max aperture to max aperture
	    iap2=iapmax
	    nnaptem=nap*2/3
	    skytemp=sky(i)
	    CALL RCSKY(1,SKY(I),ZSIG(I),NNAPTEM,II,JJ,NI,NJ,
     *                 IX(1,1,nfr),NU,NV,SKARAY,50000,nsky,0,IPR)
C reset sky aperture
	    IAP2=IAPMAX+IAPIS+3
	    write(6,*) '    +++ sky problem: ',skytemp,
     *      ' recomputed using smaller aperture: ',sky(i)
c  if there still is a problem, use backup
	    if (sky(i).lt.bkg) sky(i)=2.*bkg
	    write(6,*) '    +++ still sky problem, use backup: ',sky(i)
	  end if
	  IF (IPR.NE.0) THEN
	    WRITE(6,*) ' ****  photometry not done *****'
	    DO 106 JK=1,30
	      RI(JK)=0.
 106	    CONTINUE
	    ZSIG(I)=0
	    REALI(I)=II
	    REALJ(I)=JJ
	    GO TO 107
	  END IF
C  set up mask
	  CALL MAKEMASK(500,MASKSIZE,NMASK,NNEI(I),NNG,
     *        ipsf,ipsf,II,JJ,
     *        SKY(I),IRMAX,IX(1,1,nfr),NU,NV,NI,NJ,maxids,iapmin)
C Determine fractional pixel centroid
	  CALL PHOTCEN(II,JJ,REALI(I),REALJ(I),SKY(I),IRMAX,NMASK,CDIAM,
     *         IX(1,1,nfr),NU,NV,NI,NJ,CENSTEP,ITERCEN,IPRT)
C  Do photometry
	  CALL PPPHOT(RI,SP(0,I),REALI(I),REALJ(I),SKY(I),IRMAX,NMASK,
     *           NAP,IAP1,IX(1,1,nfr),NU,NV,ni,nj,PIXN,IPRT)
 107	  PK(I)=IX(NINT(REALI(I)),NINT(REALJ(I)),NFR)-SKY(I)
	  SKYERR(I)=RI(ISE)/
     *              (AMAX1(.00001,ZSIG(I)*SQRT(AMAX1(0.,PIXN(ISE)))))
C  convert integrated and surface profile to magnitudes
	  DO 120 L=1,NAP
 	    IF (RI(L).GT.0.0000001) THEN
	      RMAG(L,I)=-2.5*ALOG10(RI(L))
	    ELSE 
	      RMAG(L,I)=99.
	    END IF
 120	  CONTINUE
C determine best integration magnitude
	  CALL IDSDET(NAP,RMAG(1,I),RI,PIXN,ZSIG(I),DER1X,DER2X,NSTOP)
C check that it is smaller than MAXIDS (dependent on neigbour distance)
	  IDS(I)=MAX0(1,MIN0(MAXIDS,NSTOP))
 101	CONTINUE
C
C   End of loop for photometry for each object
C  ...........................................
C
C    
c   
c  pick all objects as psf 
	do 129 m=1,nobb
          psfpxv(m)=reali(m)
          psfpyv(m)=realj(m)
          idsrefv(m)=ids(m)
          refpkv(m)=pk(m)
          irefv(m)=m
          do 128 k=1,idsrefv(m)
            refstv(k,m)=rmag(k,m)
 128      continue
 129	continue
	nrefv=nobb
C   Loop # 2
C    BIG LOOP FOR EACH OBJECT TO DETERMINE EXTRAPOLATED MAG,
C      SURFACE PROFILE AND PARAMETERS, AND TWO CLASSIFICATIONS
C
c   .................................................................
	ISDAPT=MIN0(2,MAX0(1,ISDAP))
c variable psf
	aa=0.
	do 273 kk=1,nrefv
	  aa=aa+refstv(idsrefv(kk),kk)+
     *           2.5*alog10(amax1(.0001,refpkv(kk)))
 273	continue
	aa=aa/float(kk)
	rmaxsq=rrefmax*rrefmax*ni*nj
	delx=10.
	dely=10.
c   begin of big loop#2
	DO 200 I=1,NOBB
c  variable psf
c  determine average refstar from 4*nvpsf nearest 
	  if (nvpsf.eq.1) then
	    call refstcurv1(reali(i),realj(i),refstv,idsrefv,psfpxv,
     *         psfpyv,nrefv,refstt,idsreft,delx,dely,rmaxsq,iexapf,
     *         maxn)
	  else
	    call refstcurv(reali(i),realj(i),refstv,idsrefv,psfpxv,
     *     psfpyv,nrefv,refstt,idsreft,delx,dely,rmaxsq,iexapf,nvpsf
     *     ,maxn)
	  end if
	  CALL MAGEXT(IDS(I),IDSREFT,EXMAG(I),RMAG(IDS(I),I),REFSTT)
	  CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),
     *        REFSTT,IDSREFT,AA,SKY(I),ADUSAT*raduclas,
     *        ISDAPT,CLPC,ICLP(I),DELMAG(I),CLSC,ICLS(I),SUMDEL(I))
c  determine best reference curve to use
 	  if (ircspipe.ne.1) 
     *          WRITE(6,41) I,reali(i),realj(i),EXMAG(I),IDS(I),
     *          SUMDEL(I),ICLS(I)
 41	FORMAT(1X,'#',I4,'@',2f7.1,'  mag:',F6.2,'  apert.:',I2,
     *    '  C2:',F7.3,'   Cl:',I2)
 200	CONTINUE
C
C  plotting 
C
	DEV=SPLOT
	filout=' PSFs'
	if (ipar.eq.0) CALL PGLTC2(EXMAG,SUMDEL,SKYERR,NOBB,
     *              IREFV,nrefv,CLSC,icls,FILOUT,DEV,nsct(nfr))
c  make a list of objects not being class 3
	thres=clsc(2)-0.015
 299	continue
	kd=0
	do 210 i=1,nobb
c  eliminate only fuzzy objects (and objects with bad sumdel
	  if (sumdel(i).lt.thres.or.sumdel(i).gt.50.0) then
	    kd=kd+1
	    idelete(kd)=i
	  end if
 210	continue
 298	continue
	if (kd.gt.0) then
	 if (ircspipe.eq.0) then
	  write(6,26) 
 26	format(/ ' -- The following objs are set for deletion --'
     *	  /'  N  ppp#    I     J    peak     C2')
	  do 211 i=1,kd
	    kk=idelete(i)
	    write(6,20) kk,npsf(kk),ipsf(kk),jpsf(kk),
     *              ix(ipsf(kk),jpsf(kk),nfr),sumdel(kk)
c	    npsf(kk)=-1
 20	format(i3,i6,i6,i6,i7,3x,f5.2)
 211	  continue
	 end if
	else 
	  write(6,*) ' ... no fuzzy objects in list ...'
	end if
c  deleting fuzzy objs
	if (kd.gt.0) then
	  ians=' '
	  if (ipar.eq.0) then	    
 605	    write(6,21) 
 21	format('  ..Options: y=df=delete /s=set cut /e=exit /'
     *         ,'x=delete entered #s: ',$)
	    read(5,'(a1)',end=999) ians
	  end if
	  if (ipar.eq.1.or.ians.eq.' '.or.ians.eq.'y') then
c  delete bad objects and redo c2
	    do 212 i=1,kd
	      npsf(idelete(i))=-1
 212	    continue
	    kdel=0
	    do 231 i=nob,1,-1
              if (npsf(i).lt.0) then
	        kdel=kdel+1
                do 232 k=i,nob-kdel
                  npsf(k)=npsf(k+1)
                  ipsf(k)=ipsf(k+1)
                  jpsf(k)=jpsf(k+1)
 232            continue
                npsf(k)=0
c           do 231 i=1,nob
c             if (npsf(i).lt.0) then
c               do 232 k=i,nob-1
c                 npsf(k)=npsf(k+1)
c                 ipsf(k)=ipsf(k+1)
c                 jpsf(k)=jpsf(k+1)
c232            continue
c               npsf(nob)=0
              end if
 231        continue
            nob=nob-kd
	    nobb=nob
	    write(6,*) ' ...interation: ',kd,' objects deleted ...'
	    goto 500
	  else if (ians.eq.'s') then
 606	    write(6,22) thres
 22	format( ' .. setting new threshold :'
     *     /'  Enter new C2 threshold for deletion [',f7.4,']: ',$)
	    call read1r(thres,*999,*606)
	    goto 299
	  else if (ians.eq.'e') then
	    return1
	  else if (ians.eq.'x') then
	    write(6,23)
 23	format('  Enter psf #s (in pc2 plot) to be deleted (MFO): '
     *        ,$)	
            read(5,'(a60)',end=999) dumstr
c parse strength
            call mfnum(dumstr,60,idelete,10,kd,1)
c list objs and delete
	    write(6,26) 
	    do 214 i=1,kd
	      kk=idelete(i)
	      write(6,20) kk,npsf(kk),ipsf(kk),jpsf(kk),
     *              ix(ipsf(kk),jpsf(kk),nfr),sumdel(kk)
 	      npsf(kk)=-1
 214	    continue
            do 233 i=1,nob
              if (npsf(i).lt.0) then
                do 234 k=i,nob-1
                  npsf(k)=npsf(k+1)
	          ipsf(k)=ipsf(k+1)
	          jpsf(k)=jpsf(k+1)
 234            continue
                npsf(nob)=0
              end if
 233        continue
            nob=nob-kd
	    nobb=nob
	    write(6,*) ' ..interation: ',kd,' objects deleted ...'
	    goto 500
	  end if
	end if
 999	RETURN1
	END
c/////////////////////////////////////////////////
c  driving subroutine for automatically determining the .ref file
c
c  npsf= ppp# of psf
c  iipsf, jjpsf = ij co-ordinate of psf
c  nopsf=number of psf
c
c  ipar=1: output file
c  ipar=0: do not output file
c
	subroutine autoref(nfr,ix,nu,nv,kf,ipar,*)
        parameter (maxmark=1000)
        integer ix(nu,nv,kf),ndel(10),iipsf(maxmark),jjpsf(maxmark)
	integer npsf(maxmark)
        character filout*24,filoutf*28,secstr*1
        include 'picdir.inc'
        include 'objcat.inc'
        include 'ppparm.inc'
	include 'pipeparm.inc'
 2000   call querynfr(nfr,kf,0,*999,*2001)
c make initial list
 2001	call initref(nfr,'m',nopsf,npsf,maxmark,ix,nu,nv,kf)
c save positions in a file and do photometry
        do 110 k=1,nopsf
          iipsf(k)=ijoi(npsf(k),nfr)
          jjpsf(k)=ijoj(npsf(k),nfr)
 110    continue
	write(6,*) ' Initial number of psf candidates: ',nopsf
c do checking
	iapmaxt=0
	call psfc2(NFR,iipsf,jjpsf,npsf,nopsf,iapmaxt,1,
     *              IX,NU,NV,kf)
c out put results
	if (ipar.eq.1) then
	  if (ircspipe.eq.0) then
	    write(6,10) filout
 10     format('   Enter output file name (.ref appended)[',a24,']: ',$)
	    read(5,'(a24)',end=999) filout
	  else
	    filout=poutname(1:min0(lnblnk(poutname),24))
	  end if
c  read file
          if (filout.ne.' ') filoutf=filout(1:lnblnk(filout))//'.ref'
	  if (nsct(nfr).gt.0) then
	    istatus=encode(secstr,float(nsct(nfr)),1,0,dum)
	    filoutf=filoutf(1:lnblnk(filoutf))//'.'//secstr
	  end if
          call opennew(28,1,18,filoutf,*999)
          call updateref(nfr,ipsf,npsf,maxmark)
	else
	  filout='no out put file'
	end if
        write(6,11) filout,nopsf
         if (ipar.eq.1) write(28,11) filout,nopsf
 11     format('  ppp#   I   J   //// PSF input for ',A18,
     *        i5,' objs entered')
        do 100 i=1,nopsf
          write(6,12) i,npsf(i),ijoi(npsf(i),nfr),ijoj(npsf(i),nfr)
 12     format('  Ref#',i3,' ppp #:',i5,' @ ',2i5)
          if (ipar.eq.1)
     *      write(28,*) npsf(i),ijoi(npsf(i),nfr),ijoj(npsf(i),nfr)
 100    continue
        if (ipar.eq.1) close(unit=28)
c  determine fractional centroid positions, and store in common block
	nobref=min0(200,nopsf)
	do 105 i=1,nobref
	  npppref(i)=npsf(i)
	  refx(i)=ijoi(npsf(i),nfr)
	  refy(i)=ijoj(npsf(i),nfr)
 105	continue
	write(6,*) ' computing fractional pos '
	call fracpos(nfr,ix,nu,nv,kf,0,*200)
 200	continue
c	write(6,*) ' finish aref'
 999	return1
	end 
