C
C   Subroutine to read and write pictures into FITS format on disk
C   (NOT COMPLETE)
C****************************************************************************
C
C DRIVING ROUTINE  IPAR=0 READ, IPAR=1 WRITE
C
        SUBROUTINE VISTAIO(*,NFR,FITSNAM,IX,NU,NV,KF,IPAR)
        INTEGER*2 IX(NU,NV,KF)
        INTEGER NPAX(2)
        REAL*8 BSCALE,BZERO
        CHARACTER*20 FITSNAM,OBJNAM,OBN,ITEST1
        CHARACTER*35 NCOM,NCOMC
        CHARACTER HEADBLK*5760,IANS*1,HDR*80
        COMMON/PICC/NCOMC(15)
        INCLUDE 'picdir.inc'
        CALL QUERYNFR(NFR,KF,0,*999,20001)
C   get fits file name, default extension=FIT
20001        IF (FITSNAM.EQ.' ') THEN
 600      WRITE(6,1)
 1      FORMAT('   Enter FITS file name: ',$)
          READ(5,2,END=999,ERR=600) FITSNAM
 2      FORMAT(A20)
        END IF
        BSCALE=1.
        BZERO=0.
        DO 100 I=1,20
          IF (FITSNAM(I:I).EQ.'.') GO TO 101
          IF (FITSNAM(I:I).EQ.' ') GO TO 102
 100    CONTINUE
 102    IF (I.EQ.1) GO TO 600
        FITSNAM=FITSNAM(1:I-1)//'.fit'
 101    IF (IPAR.EQ.0) THEN
          OPEN(UNIT=20,FILE=FITSNAM,FORM='UNFORMATTED',STATUS='OLD'
     *        ,ERR=998)
          READ (20,ERR=987,END=986) HEADBLK
C  go through header block and extract needed info
          NHEAD=1
          IHB=0
          N1=1
          N2=80
          IANS=HEADBLK(30:30)
          READ(HEADBLK(N1:N2),611) HDR
          WRITE(6,612) HDR
          IF (IANS.NE.'T') GO TO 987
          NHEAD=NHEAD+1
          N1=N1+80
          N2=N2+80
C  Get "Number-of-bits-per-data-point"
          READ (HEADBLK(N1:N2),502) NAXIS
          READ(HEADBLK(N1:N2),611) HDR
502     FORMAT (10X,I20)
          WRITE(6,612) HDR
          NHEAD=NHEAD+1
          N1=N1+80
          N2=N2+80
C  Get number of axes
          READ (HEADBLK(N1:N2),502) NAXIS
          READ(HEADBLK(N1:N2),611) HDR
          WRITE(6,612) HDR
          NHEAD=NHEAD+1
          N1=N1+80
          N2=N2+80
          NNY=1
C  Get number of data points along first axis, etc.
          DO 108 I=1,NAXIS
            READ (HEADBLK(N1:N2),502) NPAX(I)
            NNY=NNY*NPAX(I)
            READ(HEADBLK(N1:N2),611) HDR
            WRITE(6,612) HDR
            NHEAD=NHEAD+1
            N1=N1+80
            N2=N2+80
            N3=N1+2
 108      CONTINUE
          IF (NPAX(1).GT.NU.OR.NPAX(2).GT.NV) THEN
            CLOSE(UNIT=20)
            WRITE(6,*)' +++ Picture size too large for configuration'
            RETURN1
          END IF
          NII(NFR)=NPAX(1)
          NJJ(NFR)=NPAX(2)
C  get bscale and bzero
C         NHEAD=NHEAD+1
C         N1=N1+80
C         N2=N2+80
C           READ(HEADBLK(N1:N2),611) HDR
C           WRITE(6,612) HDR
C         READ(HEADBLK(N1   )  BSCALE
C         NHEAD=NHEAD+1
C         N1=N1+80
C         N2=N2+80
C           READ(HEADBLK(N1:N2),611) HDR
C           WRITE(6,612) HDR
C         READ() BZERO
C  find objectname and put it in the comment field
          KNH=72-NHEAD
 150      IF (IHB.GE.1) KNH=72
          DO 110 I=1,KNH
            READ(HEADBLK(N1:N2),611) HDR
            IF (HDR.EQ.' ') GO TO 110
            WRITE(6,612) HDR
            ITEST1=HEADBLK(N1:N3)
            IF (ITEST1.EQ.'OBJ') READ(HEADBLK(N1+11:N1+31),677)
     *               NCOMC(NFR)
            IF (ITEST1.EQ.'BSC') READ(HEADBLK(N1+11:N1+31),*)
     *               BSCALE
            IF (ITEST1.EQ.'BZE') READ(HEADBLK(N1+11:N1+31),*)
     *               BZERO
 690    FORMAT(F20.3)
            NHEAD=NHEAD+1
            N1=N1+80
            N2=N2+80
            N3=N1+2
            N4=N1+11
 611   FORMAT(A80)
C           WRITE(8,622) HDR
            ITEST1=HEADBLK(N1:N3)
C           IF (ITEST1.EQ.'OBJ'.OR.ITEST1.EQ.'HIS'.OR.ITEST1.EQ.'F1P')
C    *        WRITE(6,612) HDR
677     FORMAT(A20)
612     FORMAT(1X,A80)
622     FORMAT(1X,A80)
653         IF(ITEST1.EQ.'END') GO TO 111
 110      CONTINUE
C   "END" is not reached, read another header block
C         READ (20,ERR=986,END=986) HEADBLK
C         IHB=IHB+1
C         GO TO 150
111       CONTINUE
C
C  read data
        WRITE(6,*) 'BSCALE ',BSCALE,'    BZERO ',BZERO
         BSCALE=1./BSCALE
C        BZERO=0
          DO 120 J=1,NJJ(NFR)
            READ(20,ERR=985,END=984) (IX(I,J,NFR),I=1,NII(NFR))
            DO 120 I=1,NII(NFR)
              IX(I,J,NFR)=INTLIMR(FLOAT(IX(I,J,NFR))*BSCALE-BZERO)
 120      CONTINUE
        ELSE
C  write FITS disk file
        WRITE(6,*) '   NOT WORKING YET!'
        END IF
        CLOSE(UNIT=20)
 999    RETURN1
 998    WRITE(6,*) '  **** NO SUCH FILE ***'
        RETURN1
 986    WRITE(6,*) '  **** CAN''T READ HEADER *** ',IHB+1
        CLOSE(UNIT=20)
        RETURN1
 987    WRITE(6,*) '  **** NOT SIMPLE FITS ***'
        CLOSE(UNIT=20)
        RETURN1
 985    WRITE(6,*) '  **** ERR READING DATA *** at ',I,J
        CLOSE(UNIT=20)
        RETURN1
 984    WRITE(6,*) '  +++ DATA ENDED PREMATURELY +++ at ',I,J
        CLOSE(UNIT=20)
        RETURN1
        END
